/* Generated by re2c 0.9.1-C on Wed Mar 26 22:43:51 2003
 */
#line 1 "./modules/arch/x86/x86id.re"
/*
 * x86 identifier recognition and instruction handling
 *
 *  Copyright (C) 2002  Peter Johnson
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND OTHER CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR OTHER CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
#define YASM_LIB_INTERNAL
#define YASM_BC_INTERNAL
#define YASM_EXPR_INTERNAL
#include <libyasm.h>
RCSID("$IdPath: yasm/modules/arch/x86/x86id.re,v 1.45 2003/03/26 05:07:55 peter Exp $");

#include "modules/arch/x86/x86arch.h"


/* Available CPU feature flags */
#define CPU_Any	    (0UL)	/* Any old cpu will do */
#define CPU_086	    CPU_Any
#define CPU_186	    (1UL<<0)	/* i186 or better required */
#define CPU_286	    (1UL<<1)	/* i286 or better required */
#define CPU_386	    (1UL<<2)	/* i386 or better required */
#define CPU_486	    (1UL<<3)	/* i486 or better required */
#define CPU_586	    (1UL<<4)	/* i585 or better required */
#define CPU_686	    (1UL<<5)	/* i686 or better required */
#define CPU_P3	    (1UL<<6)	/* Pentium3 or better required */
#define CPU_P4	    (1UL<<7)	/* Pentium4 or better required */
#define CPU_IA64    (1UL<<8)	/* IA-64 or better required */
#define CPU_K6	    (1UL<<9)	/* AMD K6 or better required */
#define CPU_Athlon  (1UL<<10)	/* AMD Athlon or better required */
#define CPU_Hammer  (1UL<<11)	/* AMD Sledgehammer or better required */
#define CPU_FPU	    (1UL<<12)	/* FPU support required */
#define CPU_MMX	    (1UL<<13)	/* MMX support required */
#define CPU_SSE	    (1UL<<14)	/* Streaming SIMD extensions required */
#define CPU_SSE2    (1UL<<15)	/* Streaming SIMD extensions 2 required */
#define CPU_3DNow   (1UL<<16)	/* 3DNow! support required */
#define CPU_Cyrix   (1UL<<17)	/* Cyrix-specific instruction */
#define CPU_AMD	    (1UL<<18)	/* AMD-specific inst. (older than K6) */
#define CPU_SMM	    (1UL<<19)	/* System Management Mode instruction */
#define CPU_Prot    (1UL<<20)	/* Protected mode only instruction */
#define CPU_Undoc   (1UL<<21)	/* Undocumented instruction */
#define CPU_Obs	    (1UL<<22)	/* Obsolete instruction */
#define CPU_Priv    (1UL<<23)	/* Priveleged instruction */

/* Technically not CPU capabilities, they do affect what instructions are
 * available.  These are tested against BITS==64.
 */
#define CPU_64	    (1UL<<24)	/* Only available in 64-bit mode */
#define CPU_Not64   (1UL<<25)	/* Not available (invalid) in 64-bit mode */

/* What instructions/features are enabled?  Defaults to all. */
static unsigned long cpu_enabled = ~CPU_Any;

/* Opcode modifiers.  The opcode bytes are in "reverse" order because the
 * parameters are read from the arch-specific data in LSB->MSB order.
 * (only for asthetic reasons in the lexer code below, no practical reason).
 */
#define MOD_Op2Add  (1UL<<0)	/* Parameter adds to opcode byte 2 */
#define MOD_Gap0    (1UL<<1)	/* Eats a parameter */
#define MOD_Op1Add  (1UL<<2)	/* Parameter adds to opcode byte 1 */
#define MOD_Gap1    (1UL<<3)	/* Eats a parameter */
#define MOD_Op0Add  (1UL<<4)	/* Parameter adds to opcode byte 0 */
#define MOD_SpAdd   (1UL<<5)	/* Parameter adds to "spare" value */
#define MOD_OpSizeR (1UL<<6)	/* Parameter replaces opersize */
#define MOD_Imm8    (1UL<<7)	/* Parameter is included as immediate byte */
#define MOD_AdSizeR (1UL<<8)	/* Parameter replaces addrsize (jmprel only) */

/* Modifiers that aren't actually used as modifiers.  Rather, if set, bits
 * 20-27 in the modifier are used as an index into an array.
 * Obviously, only one of these may be set at a time.
 */
#define MOD_ExtNone (0UL<<28)	/* No extended modifier */
#define MOD_ExtErr  (1UL<<28)	/* Extended error: index into error strings */
#define MOD_ExtWarn (2UL<<28)	/* Extended warning: index into warning strs */
#define MOD_Ext_MASK (0xFUL<<28)
#define MOD_ExtIndex_SHIFT	20
#define MOD_ExtIndex(indx)	(((unsigned long)(indx))<<MOD_ExtIndex_SHIFT)
#define MOD_ExtIndex_MASK	(0xFFUL<<MOD_ExtIndex_SHIFT)

/* Operand types.  These are more detailed than the "general" types for all
 * architectures, as they include the size, for instance.
 * Bit Breakdown (from LSB to MSB):
 *  - 5 bits = general type (must be exact match, except for =3):
 *             0 = immediate
 *             1 = any general purpose or FPU register
 *             2 = memory
 *             3 = any general purpose or FPU register OR memory
 *             4 = any MMX or XMM register
 *             5 = any MMX or XMM register OR memory
 *             6 = any segment register
 *             7 = any CR register
 *             8 = any DR register
 *             9 = any TR register
 *             A = ST0
 *             B = AL/AX/EAX/RAX (depending on size)
 *             C = CL/CX/ECX/RCX (depending on size)
 *             D = DL/DX/EDX/RDX (depending on size)
 *             E = CS
 *             F = DS
 *             10 = ES
 *             11 = FS
 *             12 = GS
 *             13 = SS
 *             14 = CR4
 *             15 = memory offset (an EA, but with no registers allowed)
 *                  [special case for MOV opcode]
 *  - 3 bits = size (user-specified, or from register size):
 *             0 = any size acceptable/no size spec acceptable (dep. on strict)
 *             1/2/3/4 = 8/16/32/64 bits (from user or reg size)
 *             5/6 = 80/128 bits (from user)
 *  - 1 bit = size implicit or explicit ("strictness" of size matching on
 *            non-registers -- registers are always strictly matched):
 *            0 = user size must exactly match size above.
 *            1 = user size either unspecified or exactly match size above.
 *  - 3 bits = target modification.
 *            0 = no target mod acceptable
 *            1 = NEAR
 *            2 = SHORT
 *            3 = FAR
 *            4 = TO
 *
 * MSBs than the above are actions: what to do with the operand if the
 * instruction matches.  Essentially describes what part of the output bytecode
 * gets the operand.  This may require conversion (e.g. a register going into
 * an ea field).  Naturally, only one of each of these may be contained in the
 * operands of a single insn_info structure.
 *  - 4 bits = action:
 *             0 = does nothing (operand data is discarded)
 *             1 = operand data goes into ea field
 *             2 = operand data goes into imm field
 *             3 = operand data goes into sign-extended imm field
 *             4 = operand data goes into "spare" field
 *             5 = operand data is added to opcode byte 0
 *             6 = operand data is added to opcode byte 1
 *             7 = operand data goes into BOTH ea and spare
 *                 [special case for imul opcode]
 *             8 = relative jump (outputs a jmprel instead of normal insn)
 *             9 = operand size goes into address size (jmprel only)
 * The below describes postponed actions: actions which can't be completed at
 * parse-time due to things like EQU and complex expressions.  For these, some
 * additional data (stored in the second byte of the opcode with a one-byte
 * opcode) is passed to later stages of the assembler with flags set to
 * indicate postponed actions.
 *  - 2 bits = postponed action:
 *             0 = none
 *             1 = shift operation with a ,1 short form (instead of imm8).
 *             2 = large imm16/32 that can become a sign-extended imm8.
 */
#define OPT_Imm		0x0
#define OPT_Reg		0x1
#define OPT_Mem		0x2
#define OPT_RM		0x3
#define OPT_SIMDReg	0x4
#define OPT_SIMDRM	0x5
#define OPT_SegReg	0x6
#define OPT_CRReg	0x7
#define OPT_DRReg	0x8
#define OPT_TRReg	0x9
#define OPT_ST0		0xA
#define OPT_Areg	0xB
#define OPT_Creg	0xC
#define OPT_Dreg	0xD
#define OPT_CS		0xE
#define OPT_DS		0xF
#define OPT_ES		0x10
#define OPT_FS		0x11
#define OPT_GS		0x12
#define OPT_SS		0x13
#define OPT_CR4		0x14
#define OPT_MemOffs	0x15
#define OPT_MASK	0x1F

#define OPS_Any		(0UL<<5)
#define OPS_8		(1UL<<5)
#define OPS_16		(2UL<<5)
#define OPS_32		(3UL<<5)
#define OPS_64		(4UL<<5)
#define OPS_80		(5UL<<5)
#define OPS_128		(6UL<<5)
#define OPS_MASK	(7UL<<5)
#define OPS_SHIFT	5

#define OPS_Relaxed	(1UL<<8)
#define OPS_RMASK	(1UL<<8)

#define OPTM_None	(0UL<<9)
#define OPTM_Near	(1UL<<9)
#define OPTM_Short	(2UL<<9)
#define OPTM_Far	(3UL<<9)
#define OPTM_To		(4UL<<9)
#define OPTM_MASK	(7UL<<9)

#define OPA_None	(0UL<<12)
#define OPA_EA		(1UL<<12)
#define OPA_Imm		(2UL<<12)
#define OPA_SImm	(3UL<<12)
#define OPA_Spare	(4UL<<12)
#define OPA_Op0Add	(5UL<<12)
#define OPA_Op1Add	(6UL<<12)
#define OPA_SpareEA	(7UL<<12)
#define OPA_JmpRel	(8UL<<12)
#define OPA_AdSizeR	(9UL<<12)
#define OPA_MASK	(0xFUL<<12)

#define OPAP_None	(0UL<<16)
#define OPAP_ShiftOp	(1UL<<16)
#define OPAP_SImm8Avail	(2UL<<16)
#define OPAP_MASK	(3UL<<16)

typedef struct x86_insn_info {
    /* The CPU feature flags needed to execute this instruction.  This is OR'ed
     * with arch-specific data[2].  This combined value is compared with
     * cpu_enabled to see if all bits set here are set in cpu_enabled--if so,
     * the instruction is available on this CPU.
     */
    unsigned long cpu;

    /* Opcode modifiers for variations of instruction.  As each modifier reads
     * its parameter in LSB->MSB order from the arch-specific data[1] from the
     * lexer data, and the LSB of the arch-specific data[1] is reserved for the
     * count of insn_info structures in the instruction grouping, there can
     * only be a maximum of 3 modifiers.
     */
    unsigned long modifiers;

    /* Operand Size */
    unsigned char opersize;

    /* The length of the basic opcode */
    unsigned char opcode_len;

    /* The basic 1-3 byte opcode */
    unsigned char opcode[3];

    /* The 3-bit "spare" value (extended opcode) for the R/M byte field */
    unsigned char spare;

    /* The number of operands this form of the instruction takes */
    unsigned char num_operands;

    /* The types of each operand, see above */
    unsigned long operands[3];
} x86_insn_info;

/* Define lexer arch-specific data with 0-3 modifiers. */
#define DEF_INSN_DATA(group, mod, cpu)	do { \
    data[0] = (unsigned long)group##_insn; \
    data[1] = ((mod)<<8) | \
    	      ((unsigned char)(sizeof(group##_insn)/sizeof(x86_insn_info))); \
    data[2] = cpu; \
    } while (0)

#define RET_INSN(group, mod, cpu)	do { \
    DEF_INSN_DATA(group, mod, cpu); \
    return YASM_ARCH_CHECK_ID_INSN; \
    } while (0)

/*
 * General instruction groupings
 */

/* Placeholder for instructions invalid in 64-bit mode */
static const x86_insn_info not64_insn[] = {
    { CPU_Not64, 0, 0, 0, {0, 0, 0}, 0, 0, {0, 0, 0} }
};

/* One byte opcode instructions with no operands */
static const x86_insn_info onebyte_insn[] = {
    { CPU_Any, MOD_Op0Add|MOD_OpSizeR, 0, 1, {0, 0, 0}, 0, 0, {0, 0, 0} }
};

/* Two byte opcode instructions with no operands */
static const x86_insn_info twobyte_insn[] = {
    { CPU_Any, MOD_Op1Add|MOD_Op0Add, 0, 2, {0, 0, 0}, 0, 0, {0, 0, 0} }
};

/* Three byte opcode instructions with no operands */
static const x86_insn_info threebyte_insn[] = {
    { CPU_Any, MOD_Op2Add|MOD_Op1Add|MOD_Op0Add, 0, 3, {0, 0, 0}, 0, 0,
      {0, 0, 0} }
};

/* One byte opcode instructions with general memory operand */
static const x86_insn_info onebytemem_insn[] = {
    { CPU_Any, MOD_Op0Add|MOD_SpAdd, 0, 1, {0, 0, 0}, 0, 1,
      {OPT_Mem|OPS_Any|OPA_EA, 0, 0} }
};

/* Two byte opcode instructions with general memory operand */
static const x86_insn_info twobytemem_insn[] = {
    { CPU_Any, MOD_Op1Add|MOD_Op0Add|MOD_SpAdd, 0, 1, {0, 0, 0}, 0, 1,
      {OPT_Mem|OPS_Any|OPA_EA, 0, 0} }
};

/* Move instructions */
static const x86_insn_info mov_insn[] = {
    { CPU_Any, 0, 0, 1, {0xA0, 0, 0}, 0, 2,
      {OPT_Areg|OPS_8|OPA_None, OPT_MemOffs|OPS_8|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Any, 0, 16, 1, {0xA1, 0, 0}, 0, 2,
      {OPT_Areg|OPS_16|OPA_None, OPT_MemOffs|OPS_16|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386, 0, 32, 1, {0xA1, 0, 0}, 0, 2,
      {OPT_Areg|OPS_32|OPA_None, OPT_MemOffs|OPS_32|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0xA1, 0, 0}, 0, 2,
      {OPT_Areg|OPS_64|OPA_None, OPT_MemOffs|OPS_64|OPS_Relaxed|OPA_EA, 0} },

    { CPU_Any, 0, 0, 1, {0xA2, 0, 0}, 0, 2,
      {OPT_MemOffs|OPS_8|OPS_Relaxed|OPA_EA, OPT_Areg|OPS_8|OPA_None, 0} },
    { CPU_Any, 0, 16, 1, {0xA3, 0, 0}, 0, 2,
      {OPT_MemOffs|OPS_16|OPS_Relaxed|OPA_EA, OPT_Areg|OPS_16|OPA_None, 0} },
    { CPU_386, 0, 32, 1, {0xA3, 0, 0}, 0, 2,
      {OPT_MemOffs|OPS_32|OPS_Relaxed|OPA_EA, OPT_Areg|OPS_32|OPA_None, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0xA3, 0, 0}, 0, 2,
      {OPT_MemOffs|OPS_64|OPS_Relaxed|OPA_EA, OPT_Areg|OPS_64|OPA_None, 0} },

    { CPU_Any, 0, 0, 1, {0x88, 0, 0}, 0, 2,
      {OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_8|OPA_Spare, 0} },
    { CPU_Any, 0, 16, 1, {0x89, 0, 0}, 0, 2,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_16|OPA_Spare, 0} },
    { CPU_386, 0, 32, 1, {0x89, 0, 0}, 0, 2,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_32|OPA_Spare, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x89, 0, 0}, 0, 2,
      {OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_64|OPA_Spare, 0} },

    { CPU_Any, 0, 0, 1, {0x8A, 0, 0}, 0, 2,
      {OPT_Reg|OPS_8|OPA_Spare, OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Any, 0, 16, 1, {0x8B, 0, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386, 0, 32, 1, {0x8B, 0, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x8B, 0, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_Spare, OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, 0} },

    { CPU_Any, 0, 0, 1, {0x8C, 0, 0}, 0, 2,
      {OPT_Mem|OPS_16|OPS_Relaxed|OPA_EA,
       OPT_SegReg|OPS_16|OPS_Relaxed|OPA_Spare, 0} },
    { CPU_Any, 0, 16, 1, {0x8C, 0, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_EA, OPT_SegReg|OPS_16|OPS_Relaxed|OPA_Spare, 0} },
    { CPU_386, 0, 32, 1, {0x8C, 0, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_EA, OPT_SegReg|OPS_16|OPS_Relaxed|OPA_Spare, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x8C, 0, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_EA, OPT_SegReg|OPS_16|OPS_Relaxed|OPA_Spare, 0} },

    { CPU_Any, 0, 0, 1, {0x8E, 0, 0}, 0, 2,
      {OPT_SegReg|OPS_16|OPS_Relaxed|OPA_Spare,
       OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386, 0, 0, 1, {0x8E, 0, 0}, 0, 2,
      {OPT_SegReg|OPS_16|OPS_Relaxed|OPA_Spare, OPT_Reg|OPS_32|OPA_EA, 0} },
    { CPU_Hammer|CPU_64, 0, 0, 1, {0x8E, 0, 0}, 0, 2,
      {OPT_SegReg|OPS_16|OPS_Relaxed|OPA_Spare, OPT_Reg|OPS_64|OPA_EA, 0} },

    { CPU_Any, 0, 0, 1, {0xB0, 0, 0}, 0, 2,
      {OPT_Reg|OPS_8|OPA_Op0Add, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Any, 0, 16, 1, {0xB8, 0, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Op0Add, OPT_Imm|OPS_16|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_386, 0, 32, 1, {0xB8, 0, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Op0Add, OPT_Imm|OPS_32|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0xB8, 0, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_Op0Add, OPT_Imm|OPS_64|OPS_Relaxed|OPA_Imm, 0} },
    /* Need two sets here, one for strictness on left side, one for right. */
    { CPU_Any, 0, 0, 1, {0xC6, 0, 0}, 0, 2,
      {OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, OPT_Imm|OPS_8|OPA_Imm, 0} },
    { CPU_Any, 0, 16, 1, {0xC7, 0, 0}, 0, 2,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Imm|OPS_16|OPA_Imm, 0} },
    { CPU_386, 0, 32, 1, {0xC7, 0, 0}, 0, 2,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_Imm|OPS_32|OPA_Imm, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0xC7, 0, 0}, 0, 2,
      {OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, OPT_Imm|OPS_32|OPA_Imm, 0} },
    { CPU_Any, 0, 0, 1, {0xC6, 0, 0}, 0, 2,
      {OPT_RM|OPS_8|OPA_EA, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Any, 0, 16, 1, {0xC7, 0, 0}, 0, 2,
      {OPT_RM|OPS_16|OPA_EA, OPT_Imm|OPS_16|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_386, 0, 32, 1, {0xC7, 0, 0}, 0, 2,
      {OPT_RM|OPS_32|OPA_EA, OPT_Imm|OPS_32|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0xC7, 0, 0}, 0, 2,
      {OPT_RM|OPS_64|OPA_EA, OPT_Imm|OPS_32|OPS_Relaxed|OPA_Imm, 0} },

    { CPU_586|CPU_Priv|CPU_Not64, 0, 0, 2, {0x0F, 0x22, 0}, 0, 2,
      {OPT_CR4|OPS_32|OPA_Spare, OPT_Reg|OPS_32|OPA_EA, 0} },
    { CPU_386|CPU_Priv|CPU_Not64, 0, 0, 2, {0x0F, 0x22, 0}, 0, 2,
      {OPT_CRReg|OPS_32|OPA_Spare, OPT_Reg|OPS_32|OPA_EA, 0} },
    { CPU_Hammer|CPU_Priv|CPU_64, 0, 0, 2, {0x0F, 0x22, 0}, 0, 2,
      {OPT_CRReg|OPS_32|OPA_Spare, OPT_Reg|OPS_64|OPA_EA, 0} },
    { CPU_586|CPU_Priv|CPU_Not64, 0, 0, 2, {0x0F, 0x20, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_EA, OPT_CR4|OPS_32|OPA_Spare, 0} },
    { CPU_386|CPU_Priv|CPU_Not64, 0, 0, 2, {0x0F, 0x20, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_EA, OPT_CRReg|OPS_32|OPA_Spare, 0} },
    { CPU_Hammer|CPU_Priv|CPU_64, 0, 0, 2, {0x0F, 0x20, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_EA, OPT_CRReg|OPS_32|OPA_Spare, 0} },

    { CPU_386|CPU_Priv|CPU_Not64, 0, 0, 2, {0x0F, 0x23, 0}, 0, 2,
      {OPT_DRReg|OPS_32|OPA_Spare, OPT_Reg|OPS_32|OPA_EA, 0} },
    { CPU_Hammer|CPU_Priv|CPU_64, 0, 0, 2, {0x0F, 0x23, 0}, 0, 2,
      {OPT_DRReg|OPS_32|OPA_Spare, OPT_Reg|OPS_64|OPA_EA, 0} },
    { CPU_386|CPU_Priv|CPU_Not64, 0, 0, 2, {0x0F, 0x21, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_EA, OPT_DRReg|OPS_32|OPA_Spare, 0} },
    { CPU_Hammer|CPU_Priv|CPU_64, 0, 0, 2, {0x0F, 0x21, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_EA, OPT_DRReg|OPS_32|OPA_Spare, 0} }
};

/* Move with sign/zero extend */
static const x86_insn_info movszx_insn[] = {
    { CPU_386, MOD_Op1Add, 16, 2, {0x0F, 0, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386, MOD_Op1Add, 32, 2, {0x0F, 0, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_RM|OPS_8|OPA_EA, 0} },
    { CPU_Hammer|CPU_64, MOD_Op1Add, 64, 2, {0x0F, 0, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_Spare, OPT_RM|OPS_8|OPA_EA, 0} },
    { CPU_386, MOD_Op1Add, 32, 2, {0x0F, 1, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_RM|OPS_16|OPA_EA, 0} },
    { CPU_Hammer|CPU_64, MOD_Op1Add, 64, 2, {0x0F, 1, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_Spare, OPT_RM|OPS_16|OPA_EA, 0} }
};

/* Move with sign-extend doubleword (64-bit mode only) */
static const x86_insn_info movsxd_insn[] = {
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x63, 0, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_Spare, OPT_RM|OPS_32|OPA_EA, 0} }
};

/* Push instructions */
static const x86_insn_info push_insn[] = {
    { CPU_Any, 0, 16, 1, {0x50, 0, 0}, 0, 1,
      {OPT_Reg|OPS_16|OPA_Op0Add, 0, 0} },
    { CPU_386|CPU_Not64, 0, 32, 1, {0x50, 0, 0}, 0, 1,
      {OPT_Reg|OPS_32|OPA_Op0Add, 0, 0} },
    { CPU_Hammer|CPU_64, 0, 0, 1, {0x50, 0, 0}, 0, 1,
      {OPT_Reg|OPS_64|OPA_Op0Add, 0, 0} },
    { CPU_Any, 0, 16, 1, {0xFF, 0, 0}, 6, 1, {OPT_RM|OPS_16|OPA_EA, 0, 0} },
    { CPU_386|CPU_Not64, 0, 32, 1, {0xFF, 0, 0}, 6, 1,
      {OPT_RM|OPS_32|OPA_EA, 0, 0} },
    { CPU_Hammer|CPU_64, 0, 0, 1, {0xFF, 0, 0}, 6, 1,
      {OPT_RM|OPS_64|OPA_EA, 0, 0} },
    { CPU_Any, 0, 0, 1, {0x6A, 0, 0}, 0, 1, {OPT_Imm|OPS_8|OPA_Imm, 0, 0} },
    { CPU_Any, 0, 16, 1, {0x68, 0, 0}, 0, 1, {OPT_Imm|OPS_16|OPA_Imm, 0, 0} },
    { CPU_386|CPU_Not64, 0, 32, 1, {0x68, 0, 0}, 0, 1,
      {OPT_Imm|OPS_32|OPA_Imm, 0, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x68, 0, 0}, 0, 1,
      {OPT_Imm|OPS_64|OPA_Imm, 0, 0} },
    { CPU_Not64, 0, 0, 1, {0x0E, 0, 0}, 0, 1, {OPT_CS|OPS_Any|OPA_None, 0, 0} },
    { CPU_Not64, 0, 16, 1, {0x0E, 0, 0}, 0, 1, {OPT_CS|OPS_16|OPA_None, 0, 0} },
    { CPU_Not64, 0, 32, 1, {0x0E, 0, 0}, 0, 1, {OPT_CS|OPS_32|OPA_None, 0, 0} },
    { CPU_Not64, 0, 0, 1, {0x16, 0, 0}, 0, 1, {OPT_SS|OPS_Any|OPA_None, 0, 0} },
    { CPU_Not64, 0, 16, 1, {0x16, 0, 0}, 0, 1, {OPT_SS|OPS_16|OPA_None, 0, 0} },
    { CPU_Not64, 0, 32, 1, {0x16, 0, 0}, 0, 1, {OPT_SS|OPS_32|OPA_None, 0, 0} },
    { CPU_Not64, 0, 0, 1, {0x1E, 0, 0}, 0, 1, {OPT_DS|OPS_Any|OPA_None, 0, 0} },
    { CPU_Not64, 0, 16, 1, {0x1E, 0, 0}, 0, 1, {OPT_DS|OPS_16|OPA_None, 0, 0} },
    { CPU_Not64, 0, 32, 1, {0x1E, 0, 0}, 0, 1, {OPT_DS|OPS_32|OPA_None, 0, 0} },
    { CPU_Not64, 0, 0, 1, {0x06, 0, 0}, 0, 1, {OPT_ES|OPS_Any|OPA_None, 0, 0} },
    { CPU_Not64, 0, 16, 1, {0x06, 0, 0}, 0, 1, {OPT_ES|OPS_16|OPA_None, 0, 0} },
    { CPU_Not64, 0, 32, 1, {0x06, 0, 0}, 0, 1, {OPT_ES|OPS_32|OPA_None, 0, 0} },
    { CPU_386, 0, 0, 2, {0x0F, 0xA0, 0}, 0, 1,
      {OPT_FS|OPS_Any|OPA_None, 0, 0} },
    { CPU_386, 0, 16, 2, {0x0F, 0xA0, 0}, 0, 1,
      {OPT_FS|OPS_16|OPA_None, 0, 0} },
    { CPU_386, 0, 32, 2, {0x0F, 0xA0, 0}, 0, 1,
      {OPT_FS|OPS_32|OPA_None, 0, 0} },
    { CPU_386, 0, 0, 2, {0x0F, 0xA8, 0}, 0, 1,
      {OPT_GS|OPS_Any|OPA_None, 0, 0} },
    { CPU_386, 0, 16, 2, {0x0F, 0xA8, 0}, 0, 1,
      {OPT_GS|OPS_16|OPA_None, 0, 0} },
    { CPU_386, 0, 32, 2, {0x0F, 0xA8, 0}, 0, 1,
      {OPT_GS|OPS_32|OPA_None, 0, 0} }
};

/* Pop instructions */
static const x86_insn_info pop_insn[] = {
    { CPU_Any, 0, 16, 1, {0x58, 0, 0}, 0, 1,
      {OPT_Reg|OPS_16|OPA_Op0Add, 0, 0} },
    { CPU_386|CPU_Not64, 0, 32, 1, {0x58, 0, 0}, 0, 1,
      {OPT_Reg|OPS_32|OPA_Op0Add, 0, 0} },
    { CPU_Hammer|CPU_64, 0, 0, 1, {0x58, 0, 0}, 0, 1,
      {OPT_Reg|OPS_64|OPA_Op0Add, 0, 0} },
    { CPU_Any, 0, 16, 1, {0x8F, 0, 0}, 0, 1, {OPT_RM|OPS_16|OPA_EA, 0, 0} },
    { CPU_386|CPU_Not64, 0, 32, 1, {0x8F, 0, 0}, 0, 1,
      {OPT_RM|OPS_32|OPA_EA, 0, 0} },
    { CPU_Hammer|CPU_64, 0, 0, 1, {0x8F, 0, 0}, 0, 1,
      {OPT_RM|OPS_64|OPA_EA, 0, 0} },
    /* POP CS is debateably valid on the 8086, if obsolete and undocumented.
     * We don't include it because it's VERY unlikely it will ever be used
     * anywhere.  If someone really wants it they can db 0x0F it.
     */
    /*{ CPU_Any|CPU_Undoc|CPU_Obs, 0, 0, 1, {0x0F, 0, 0}, 0, 1,
        {OPT_CS|OPS_Any|OPA_None, 0, 0} },*/
    { CPU_Not64, 0, 0, 1, {0x17, 0, 0}, 0, 1, {OPT_SS|OPS_Any|OPA_None, 0, 0} },
    { CPU_Not64, 0, 16, 1, {0x17, 0, 0}, 0, 1, {OPT_SS|OPS_16|OPA_None, 0, 0} },
    { CPU_Not64, 0, 32, 1, {0x17, 0, 0}, 0, 1, {OPT_SS|OPS_32|OPA_None, 0, 0} },
    { CPU_Not64, 0, 0, 1, {0x1F, 0, 0}, 0, 1, {OPT_DS|OPS_Any|OPA_None, 0, 0} },
    { CPU_Not64, 0, 16, 1, {0x1F, 0, 0}, 0, 1, {OPT_DS|OPS_16|OPA_None, 0, 0} },
    { CPU_Not64, 0, 32, 1, {0x1F, 0, 0}, 0, 1, {OPT_DS|OPS_32|OPA_None, 0, 0} },
    { CPU_Not64, 0, 0, 1, {0x07, 0, 0}, 0, 1, {OPT_ES|OPS_Any|OPA_None, 0, 0} },
    { CPU_Not64, 0, 16, 1, {0x07, 0, 0}, 0, 1, {OPT_ES|OPS_16|OPA_None, 0, 0} },
    { CPU_Not64, 0, 32, 1, {0x07, 0, 0}, 0, 1, {OPT_ES|OPS_32|OPA_None, 0, 0} },
    { CPU_386, 0, 0, 2, {0x0F, 0xA1, 0}, 0, 1,
      {OPT_FS|OPS_Any|OPA_None, 0, 0} },
    { CPU_386, 0, 16, 2, {0x0F, 0xA1, 0}, 0, 1,
      {OPT_FS|OPS_16|OPA_None, 0, 0} },
    { CPU_386, 0, 32, 2, {0x0F, 0xA1, 0}, 0, 1,
      {OPT_FS|OPS_32|OPA_None, 0, 0} },
    { CPU_386, 0, 0, 2, {0x0F, 0xA9, 0}, 0, 1,
      {OPT_GS|OPS_Any|OPA_None, 0, 0} },
    { CPU_386, 0, 16, 2, {0x0F, 0xA9, 0}, 0, 1,
      {OPT_GS|OPS_16|OPA_None, 0, 0} },
    { CPU_386, 0, 32, 2, {0x0F, 0xA9, 0}, 0, 1,
      {OPT_GS|OPS_32|OPA_None, 0, 0} }
};

/* Exchange instructions */
static const x86_insn_info xchg_insn[] = {
    { CPU_Any, 0, 0, 1, {0x86, 0, 0}, 0, 2,
      {OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_8|OPA_Spare, 0} },
    { CPU_Any, 0, 0, 1, {0x86, 0, 0}, 0, 2,
      {OPT_Reg|OPS_8|OPA_Spare, OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Any, 0, 16, 1, {0x90, 0, 0}, 0, 2,
      {OPT_Areg|OPS_16|OPA_None, OPT_Reg|OPS_16|OPA_Op0Add, 0} },
    { CPU_Any, 0, 16, 1, {0x90, 0, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Op0Add, OPT_Areg|OPS_16|OPA_None, 0} },
    { CPU_Any, 0, 16, 1, {0x87, 0, 0}, 0, 2,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_16|OPA_Spare, 0} },
    { CPU_Any, 0, 16, 1, {0x87, 0, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386, 0, 32, 1, {0x90, 0, 0}, 0, 2,
      {OPT_Areg|OPS_32|OPA_None, OPT_Reg|OPS_32|OPA_Op0Add, 0} },
    { CPU_386, 0, 32, 1, {0x90, 0, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Op0Add, OPT_Areg|OPS_32|OPA_None, 0} },
    { CPU_386, 0, 32, 1, {0x87, 0, 0}, 0, 2,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_32|OPA_Spare, 0} },
    { CPU_386, 0, 32, 1, {0x87, 0, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x90, 0, 0}, 0, 2,
      {OPT_Areg|OPS_64|OPA_None, OPT_Reg|OPS_64|OPA_Op0Add, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x90, 0, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_Op0Add, OPT_Areg|OPS_64|OPA_None, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x87, 0, 0}, 0, 2,
      {OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_64|OPA_Spare, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x87, 0, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_Spare, OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, 0} }
};

/* In/out from ports */
static const x86_insn_info in_insn[] = {
    { CPU_Any, 0, 0, 1, {0xE4, 0, 0}, 0, 2,
      {OPT_Areg|OPS_8|OPA_None, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Any, 0, 16, 1, {0xE5, 0, 0}, 0, 2,
      {OPT_Areg|OPS_16|OPA_None, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_386, 0, 32, 1, {0xE5, 0, 0}, 0, 2,
      {OPT_Areg|OPS_32|OPA_None, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Any, 0, 0, 1, {0xEC, 0, 0}, 0, 2,
      {OPT_Areg|OPS_8|OPA_None, OPT_Dreg|OPS_16|OPA_None, 0} },
    { CPU_Any, 0, 16, 1, {0xED, 0, 0}, 0, 2,
      {OPT_Areg|OPS_16|OPA_None, OPT_Dreg|OPS_16|OPA_None, 0} },
    { CPU_386, 0, 32, 1, {0xED, 0, 0}, 0, 2,
      {OPT_Areg|OPS_32|OPA_None, OPT_Dreg|OPS_16|OPA_None, 0} }
};
static const x86_insn_info out_insn[] = {
    { CPU_Any, 0, 0, 1, {0xE6, 0, 0}, 0, 2,
      {OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, OPT_Areg|OPS_8|OPA_None, 0} },
    { CPU_Any, 0, 16, 1, {0xE7, 0, 0}, 0, 2,
      {OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, OPT_Areg|OPS_16|OPA_None, 0} },
    { CPU_386, 0, 32, 1, {0xE7, 0, 0}, 0, 2,
      {OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, OPT_Areg|OPS_32|OPA_None, 0} },
    { CPU_Any, 0, 0, 1, {0xEE, 0, 0}, 0, 2,
      {OPT_Dreg|OPS_16|OPA_None, OPT_Areg|OPS_8|OPA_None, 0} },
    { CPU_Any, 0, 16, 1, {0xEF, 0, 0}, 0, 2,
      {OPT_Dreg|OPS_16|OPA_None, OPT_Areg|OPS_16|OPA_None, 0} },
    { CPU_386, 0, 32, 1, {0xEF, 0, 0}, 0, 2,
      {OPT_Dreg|OPS_16|OPA_None, OPT_Areg|OPS_32|OPA_None, 0} }
};

/* Load effective address */
static const x86_insn_info lea_insn[] = {
    { CPU_Any, 0, 16, 1, {0x8D, 0, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_Mem|OPS_16|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386, 0, 32, 1, {0x8D, 0, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_Mem|OPS_32|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x8D, 0, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_Spare, OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, 0} }
};

/* Load segment registers from memory */
static const x86_insn_info ldes_insn[] = {
    { CPU_Not64, MOD_Op0Add, 16, 1, {0, 0, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_Mem|OPS_Any|OPA_EA, 0} },
    { CPU_386|CPU_Not64, MOD_Op0Add, 32, 1, {0, 0, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_Mem|OPS_Any|OPA_EA, 0} }
};
static const x86_insn_info lfgss_insn[] = {
    { CPU_386, MOD_Op1Add, 16, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_Mem|OPS_Any|OPA_EA, 0} },
    { CPU_386, MOD_Op1Add, 32, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_Mem|OPS_Any|OPA_EA, 0} }
};

/* Arithmetic - general */
static const x86_insn_info arith_insn[] = {
    { CPU_Any, MOD_Op0Add, 0, 1, {0x04, 0, 0}, 0, 2,
      {OPT_Areg|OPS_8|OPA_None, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Any, MOD_Op0Add, 16, 1, {0x05, 0, 0}, 0, 2,
      {OPT_Areg|OPS_16|OPA_None, OPT_Imm|OPS_16|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_386, MOD_Op0Add, 32, 1, {0x05, 0, 0}, 0, 2,
      {OPT_Areg|OPS_32|OPA_None, OPT_Imm|OPS_32|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Hammer|CPU_64, MOD_Op0Add, 64, 1, {0x05, 0, 0}, 0, 2,
      {OPT_Areg|OPS_64|OPA_None, OPT_Imm|OPS_32|OPS_Relaxed|OPA_Imm, 0} },

    { CPU_Any, MOD_Gap0|MOD_SpAdd, 0, 1, {0x80, 0, 0}, 0, 2,
      {OPT_RM|OPS_8|OPA_EA, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Any, MOD_Gap0|MOD_SpAdd, 0, 1, {0x80, 0, 0}, 0, 2,
      {OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, OPT_Imm|OPS_8|OPA_Imm, 0} },
    { CPU_Any, MOD_Gap0|MOD_SpAdd, 16, 1, {0x83, 0, 0}, 0, 2,
      {OPT_RM|OPS_16|OPA_EA, OPT_Imm|OPS_8|OPA_SImm, 0} },
    { CPU_Any, MOD_Gap0|MOD_SpAdd, 16, 1, {0x81, 0x83, 0}, 0, 2,
      {OPT_RM|OPS_16|OPA_EA,
       OPT_Imm|OPS_16|OPS_Relaxed|OPA_Imm|OPAP_SImm8Avail, 0} },
    { CPU_Any, MOD_Gap0|MOD_SpAdd, 16, 1, {0x81, 0, 0}, 0, 2,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Imm|OPS_16|OPA_Imm, 0} },
    { CPU_386, MOD_Gap0|MOD_SpAdd, 32, 1, {0x83, 0, 0}, 0, 2,
      {OPT_RM|OPS_32|OPA_EA, OPT_Imm|OPS_8|OPA_SImm, 0} },
    { CPU_386, MOD_Gap0|MOD_SpAdd, 32, 1, {0x81, 0x83, 0}, 0, 2,
      {OPT_RM|OPS_32|OPA_EA,
       OPT_Imm|OPS_32|OPS_Relaxed|OPA_Imm|OPAP_SImm8Avail, 0} },
    { CPU_386, MOD_Gap0|MOD_SpAdd, 32, 1, {0x81, 0, 0}, 0, 2,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_Imm|OPS_32|OPA_Imm, 0} },
    { CPU_Hammer|CPU_64, MOD_Gap0|MOD_SpAdd, 64, 1, {0x83, 0, 0}, 0, 2,
      {OPT_RM|OPS_64|OPA_EA, OPT_Imm|OPS_8|OPA_SImm, 0} },
    { CPU_Hammer|CPU_64, MOD_Gap0|MOD_SpAdd, 64, 1, {0x81, 0x83, 0}, 0, 2,
      {OPT_RM|OPS_64|OPA_EA,
       OPT_Imm|OPS_32|OPS_Relaxed|OPA_Imm|OPAP_SImm8Avail, 0} },
    { CPU_Hammer|CPU_64, MOD_Gap0|MOD_SpAdd, 64, 1, {0x81, 0, 0}, 0, 2,
      {OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, OPT_Imm|OPS_32|OPA_Imm, 0} },

    { CPU_Any, MOD_Op0Add, 0, 1, {0x00, 0, 0}, 0, 2,
      {OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_8|OPA_Spare, 0} },
    { CPU_Any, MOD_Op0Add, 16, 1, {0x01, 0, 0}, 0, 2,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_16|OPA_Spare, 0} },
    { CPU_386, MOD_Op0Add, 32, 1, {0x01, 0, 0}, 0, 2,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_32|OPA_Spare, 0} },
    { CPU_Hammer|CPU_64, MOD_Op0Add, 64, 1, {0x01, 0, 0}, 0, 2,
      {OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_64|OPA_Spare, 0} },
    { CPU_Any, MOD_Op0Add, 0, 1, {0x02, 0, 0}, 0, 2,
      {OPT_Reg|OPS_8|OPA_Spare, OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Any, MOD_Op0Add, 16, 1, {0x03, 0, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386, MOD_Op0Add, 32, 1, {0x03, 0, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Hammer|CPU_64, MOD_Op0Add, 64, 1, {0x03, 0, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_Spare, OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, 0} }
};

/* Arithmetic - inc/dec */
static const x86_insn_info incdec_insn[] = {
    { CPU_Any, MOD_Gap0|MOD_SpAdd, 0, 1, {0xFE, 0, 0}, 0, 1,
      {OPT_RM|OPS_8|OPA_EA, 0, 0} },
    { CPU_Not64, MOD_Op0Add, 16, 1, {0, 0, 0}, 0, 1,
      {OPT_Reg|OPS_16|OPA_Op0Add, 0, 0} },
    { CPU_Any, MOD_Gap0|MOD_SpAdd, 16, 1, {0xFF, 0, 0}, 0, 1,
      {OPT_RM|OPS_16|OPA_EA, 0, 0} },
    { CPU_386|CPU_Not64, MOD_Op0Add, 32, 1, {0, 0, 0}, 0, 1,
      {OPT_Reg|OPS_32|OPA_Op0Add, 0, 0} },
    { CPU_386, MOD_Gap0|MOD_SpAdd, 32, 1, {0xFF, 0, 0}, 0, 1,
      {OPT_RM|OPS_32|OPA_EA, 0, 0} },
    { CPU_Hammer|CPU_64, MOD_Gap0|MOD_SpAdd, 64, 1, {0xFF, 0, 0}, 0, 1,
      {OPT_RM|OPS_64|OPA_EA, 0, 0} },
};

/* Arithmetic - "F6" opcodes (div/idiv/mul/neg/not) */
static const x86_insn_info f6_insn[] = {
    { CPU_Any, MOD_SpAdd, 0, 1, {0xF6, 0, 0}, 0, 1,
      {OPT_RM|OPS_8|OPA_EA, 0, 0} },
    { CPU_Any, MOD_SpAdd, 16, 1, {0xF7, 0, 0}, 0, 1,
      {OPT_RM|OPS_16|OPA_EA, 0, 0} },
    { CPU_386, MOD_SpAdd, 32, 1, {0xF7, 0, 0}, 0, 1,
      {OPT_RM|OPS_32|OPA_EA, 0, 0} },
    { CPU_Hammer|CPU_64, MOD_SpAdd, 64, 1, {0xF7, 0, 0}, 0, 1,
      {OPT_RM|OPS_64|OPA_EA, 0, 0} },
};

/* Arithmetic - test instruction */
static const x86_insn_info test_insn[] = {
    { CPU_Any, 0, 0, 1, {0xA8, 0, 0}, 0, 2,
      {OPT_Areg|OPS_8|OPA_None, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Any, 0, 16, 1, {0xA9, 0, 0}, 0, 2,
      {OPT_Areg|OPS_16|OPA_None, OPT_Imm|OPS_16|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_386, 0, 32, 1, {0xA9, 0, 0}, 0, 2,
      {OPT_Areg|OPS_32|OPA_None, OPT_Imm|OPS_32|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0xA9, 0, 0}, 0, 2,
      {OPT_Areg|OPS_64|OPA_None, OPT_Imm|OPS_32|OPS_Relaxed|OPA_Imm, 0} },

    { CPU_Any, 0, 0, 1, {0xF6, 0, 0}, 0, 2,
      {OPT_RM|OPS_8|OPA_EA, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Any, 0, 0, 1, {0xF6, 0, 0}, 0, 2,
      {OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, OPT_Imm|OPS_8|OPA_Imm, 0} },
    { CPU_Any, 0, 16, 1, {0xF7, 0, 0}, 0, 2,
      {OPT_RM|OPS_16|OPA_EA, OPT_Imm|OPS_16|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Any, 0, 16, 1, {0xF7, 0, 0}, 0, 2,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Imm|OPS_16|OPA_Imm, 0} },
    { CPU_386, 0, 32, 1, {0xF7, 0, 0}, 0, 2,
      {OPT_RM|OPS_32|OPA_EA, OPT_Imm|OPS_32|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_386, 0, 32, 1, {0xF7, 0, 0}, 0, 2,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_Imm|OPS_32|OPA_Imm, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0xF7, 0, 0}, 0, 2,
      {OPT_RM|OPS_64|OPA_EA, OPT_Imm|OPS_32|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0xF7, 0, 0}, 0, 2,
      {OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, OPT_Imm|OPS_32|OPA_Imm, 0} },

    { CPU_Any, 0, 0, 1, {0x84, 0, 0}, 0, 2,
      {OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_8|OPA_Spare, 0} },
    { CPU_Any, 0, 16, 1, {0x85, 0, 0}, 0, 2,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_16|OPA_Spare, 0} },
    { CPU_386, 0, 32, 1, {0x85, 0, 0}, 0, 2,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_32|OPA_Spare, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x85, 0, 0}, 0, 2,
      {OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_64|OPA_Spare, 0} },

    { CPU_Any, 0, 0, 1, {0x84, 0, 0}, 0, 2,
      {OPT_Reg|OPS_8|OPA_Spare, OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Any, 0, 16, 1, {0x85, 0, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386, 0, 32, 1, {0x85, 0, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x85, 0, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_Spare, OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, 0} }
};

/* Arithmetic - aad/aam */
static const x86_insn_info aadm_insn[] = {
    { CPU_Any, MOD_Op0Add, 0, 2, {0xD4, 0x0A, 0}, 0, 0, {0, 0, 0} },
    { CPU_Any, MOD_Op0Add, 0, 1, {0xD4, 0, 0}, 0, 1,
      {OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0, 0} }
};

/* Arithmetic - imul */
static const x86_insn_info imul_insn[] = {
    { CPU_Any, 0, 0, 1, {0xF6, 0, 0}, 5, 1, {OPT_RM|OPS_8|OPA_EA, 0, 0} },
    { CPU_Any, 0, 16, 1, {0xF7, 0, 0}, 5, 1, {OPT_RM|OPS_16|OPA_EA, 0, 0} },
    { CPU_386, 0, 32, 1, {0xF7, 0, 0}, 5, 1, {OPT_RM|OPS_32|OPA_EA, 0, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0xF7, 0, 0}, 5, 1,
      {OPT_RM|OPS_64|OPA_EA, 0, 0} },

    { CPU_386, 0, 16, 2, {0x0F, 0xAF, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386, 0, 32, 2, {0x0F, 0xAF, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 2, {0x0F, 0xAF, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_Spare, OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, 0} },

    { CPU_186, 0, 16, 1, {0x6B, 0, 0}, 0, 3,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_RM|OPS_16|OPS_Relaxed|OPA_EA,
       OPT_Imm|OPS_8|OPA_SImm} },
    { CPU_386, 0, 32, 1, {0x6B, 0, 0}, 0, 3,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_RM|OPS_32|OPS_Relaxed|OPA_EA,
       OPT_Imm|OPS_8|OPA_SImm} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x6B, 0, 0}, 0, 3,
      {OPT_Reg|OPS_64|OPA_Spare, OPT_RM|OPS_64|OPS_Relaxed|OPA_EA,
       OPT_Imm|OPS_8|OPA_SImm} },

    { CPU_186, 0, 16, 1, {0x6B, 0, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_SpareEA, OPT_Imm|OPS_8|OPA_SImm, 0} },
    { CPU_386, 0, 32, 1, {0x6B, 0, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_SpareEA, OPT_Imm|OPS_8|OPA_SImm, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x6B, 0, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_SpareEA, OPT_Imm|OPS_8|OPA_SImm, 0} },

    { CPU_186, 0, 16, 1, {0x69, 0x6B, 0}, 0, 3,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_RM|OPS_16|OPS_Relaxed|OPA_EA,
       OPT_Imm|OPS_16|OPS_Relaxed|OPA_SImm|OPAP_SImm8Avail} },
    { CPU_386, 0, 32, 1, {0x69, 0x6B, 0}, 0, 3,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_RM|OPS_32|OPS_Relaxed|OPA_EA,
       OPT_Imm|OPS_32|OPS_Relaxed|OPA_SImm|OPAP_SImm8Avail} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x69, 0x6B, 0}, 0, 3,
      {OPT_Reg|OPS_64|OPA_Spare, OPT_RM|OPS_64|OPS_Relaxed|OPA_EA,
       OPT_Imm|OPS_32|OPS_Relaxed|OPA_SImm|OPAP_SImm8Avail} },

    { CPU_186, 0, 16, 1, {0x69, 0x6B, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_SpareEA,
       OPT_Imm|OPS_16|OPS_Relaxed|OPA_SImm|OPAP_SImm8Avail, 0} },
    { CPU_386, 0, 32, 1, {0x69, 0x6B, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_SpareEA,
       OPT_Imm|OPS_32|OPS_Relaxed|OPA_SImm|OPAP_SImm8Avail, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 1, {0x69, 0x6B, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_SpareEA,
       OPT_Imm|OPS_32|OPS_Relaxed|OPA_SImm|OPAP_SImm8Avail, 0} }
};

/* Shifts - standard */
static const x86_insn_info shift_insn[] = {
    { CPU_Any, MOD_SpAdd, 0, 1, {0xD2, 0, 0}, 0, 2,
      {OPT_RM|OPS_8|OPA_EA, OPT_Creg|OPS_8|OPA_None, 0} },
    /* FIXME: imm8 is only avail on 186+, but we use imm8 to get to postponed
     * ,1 form, so it has to be marked as Any.  We need to store the active
     * CPU flags somewhere to pass that parse-time info down the line.
     */
    { CPU_Any, MOD_SpAdd, 0, 1, {0xC0, 0xD0, 0}, 0, 2,
      {OPT_RM|OPS_8|OPA_EA, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm|OPAP_ShiftOp,
       0} },
    { CPU_Any, MOD_SpAdd, 16, 1, {0xD3, 0, 0}, 0, 2,
      {OPT_RM|OPS_16|OPA_EA, OPT_Creg|OPS_8|OPA_None, 0} },
    { CPU_Any, MOD_SpAdd, 16, 1, {0xC1, 0xD1, 0}, 0, 2,
      {OPT_RM|OPS_16|OPA_EA, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm|OPAP_ShiftOp,
       0} },
    { CPU_Any, MOD_SpAdd, 32, 1, {0xD3, 0, 0}, 0, 2,
      {OPT_RM|OPS_32|OPA_EA, OPT_Creg|OPS_8|OPA_None, 0} },
    { CPU_Any, MOD_SpAdd, 32, 1, {0xC1, 0xD1, 0}, 0, 2,
      {OPT_RM|OPS_32|OPA_EA, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm|OPAP_ShiftOp,
       0} },
    { CPU_Hammer|CPU_64, MOD_SpAdd, 64, 1, {0xD3, 0, 0}, 0, 2,
      {OPT_RM|OPS_64|OPA_EA, OPT_Creg|OPS_8|OPA_None, 0} },
    { CPU_Hammer|CPU_64, MOD_SpAdd, 64, 1, {0xC1, 0xD1, 0}, 0, 2,
      {OPT_RM|OPS_64|OPA_EA, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm|OPAP_ShiftOp,
       0} }
};

/* Shifts - doubleword */
static const x86_insn_info shlrd_insn[] = {
    { CPU_386, MOD_Op1Add, 16, 2, {0x0F, 0x00, 0}, 0, 3,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_16|OPA_Spare,
       OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm} },
    { CPU_386, MOD_Op1Add, 16, 2, {0x0F, 0x01, 0}, 0, 3,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_16|OPA_Spare,
       OPT_Creg|OPS_8|OPA_None} },
    { CPU_386, MOD_Op1Add, 32, 2, {0x0F, 0x00, 0}, 0, 3,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_32|OPA_Spare,
       OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm} },
    { CPU_386, MOD_Op1Add, 32, 2, {0x0F, 0x01, 0}, 0, 3,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_32|OPA_Spare,
       OPT_Creg|OPS_8|OPA_None} },
    { CPU_Hammer|CPU_64, MOD_Op1Add, 64, 2, {0x0F, 0x00, 0}, 0, 3,
      {OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_64|OPA_Spare,
       OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm} },
    { CPU_Hammer|CPU_64, MOD_Op1Add, 64, 2, {0x0F, 0x01, 0}, 0, 3,
      {OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_64|OPA_Spare,
       OPT_Creg|OPS_8|OPA_None} }
};

/* Control transfer instructions (unconditional) */
static const x86_insn_info call_insn[] = {
    { CPU_Any, 0, 0, 0, {0, 0, 0}, 0, 1, {OPT_Imm|OPS_Any|OPA_JmpRel, 0, 0} },
    { CPU_Any, 0, 16, 0, {0, 0, 0}, 0, 1, {OPT_Imm|OPS_16|OPA_JmpRel, 0, 0} },
    { CPU_386, 0, 32, 0, {0, 0, 0}, 0, 1, {OPT_Imm|OPS_32|OPA_JmpRel, 0, 0} },

    { CPU_Any, 0, 16, 1, {0xE8, 0, 0}, 0, 1,
      {OPT_Imm|OPS_16|OPTM_Near|OPA_JmpRel, 0, 0} },
    { CPU_386, 0, 32, 1, {0xE8, 0, 0}, 0, 1,
      {OPT_Imm|OPS_32|OPTM_Near|OPA_JmpRel, 0, 0} },
    { CPU_Any, 0, 0, 1, {0xE8, 0, 0}, 0, 1,
      {OPT_Imm|OPS_Any|OPTM_Near|OPA_JmpRel, 0, 0} },

    { CPU_Any, 0, 16, 1, {0xFF, 0, 0}, 2, 1, {OPT_RM|OPS_16|OPA_EA, 0, 0} },
    { CPU_386|CPU_Not64, 0, 32, 1, {0xFF, 0, 0}, 2, 1,
      {OPT_RM|OPS_32|OPA_EA, 0, 0} },
    { CPU_Hammer|CPU_64, 0, 0, 1, {0xFF, 0, 0}, 2, 1,
      {OPT_RM|OPS_64|OPA_EA, 0, 0} },
    { CPU_Any, 0, 0, 1, {0xFF, 0, 0}, 2, 1, {OPT_Mem|OPS_Any|OPA_EA, 0, 0} },
    { CPU_Any, 0, 16, 1, {0xFF, 0, 0}, 2, 1,
      {OPT_RM|OPS_16|OPTM_Near|OPA_EA, 0, 0} },
    { CPU_386|CPU_Not64, 0, 32, 1, {0xFF, 0, 0}, 2, 1,
      {OPT_RM|OPS_32|OPTM_Near|OPA_EA, 0, 0} },
    { CPU_Hammer|CPU_64, 0, 0, 1, {0xFF, 0, 0}, 2, 1,
      {OPT_RM|OPS_64|OPTM_Near|OPA_EA, 0, 0} },
    { CPU_Any, 0, 0, 1, {0xFF, 0, 0}, 2, 1,
      {OPT_Mem|OPS_Any|OPTM_Near|OPA_EA, 0, 0} },

    /* TODO: Far Imm 16:16/32 */

    { CPU_Any, 0, 16, 1, {0xFF, 0, 0}, 3, 1,
      {OPT_Mem|OPS_16|OPTM_Far|OPA_EA, 0, 0} },
    { CPU_386, 0, 32, 1, {0xFF, 0, 0}, 3, 1,
      {OPT_Mem|OPS_32|OPTM_Far|OPA_EA, 0, 0} },
    { CPU_Any, 0, 0, 1, {0xFF, 0, 0}, 3, 1,
      {OPT_Mem|OPS_Any|OPTM_Far|OPA_EA, 0, 0} }
};
static const x86_insn_info jmp_insn[] = {
    { CPU_Any, 0, 0, 0, {0, 0, 0}, 0, 1, {OPT_Imm|OPS_Any|OPA_JmpRel, 0, 0} },
    { CPU_Any, 0, 16, 0, {0, 0, 0}, 0, 1, {OPT_Imm|OPS_16|OPA_JmpRel, 0, 0} },
    { CPU_386, 0, 32, 1, {0, 0, 0}, 0, 1, {OPT_Imm|OPS_32|OPA_JmpRel, 0, 0} },

    { CPU_Any, 0, 0, 1, {0xEB, 0, 0}, 0, 1,
      {OPT_Imm|OPS_Any|OPTM_Short|OPA_JmpRel, 0, 0} },
    { CPU_Any, 0, 16, 1, {0xE9, 0, 0}, 0, 1,
      {OPT_Imm|OPS_16|OPTM_Near|OPA_JmpRel, 0, 0} },
    { CPU_386, 0, 32, 1, {0xE9, 0, 0}, 0, 1,
      {OPT_Imm|OPS_32|OPTM_Near|OPA_JmpRel, 0, 0} },
    { CPU_Any, 0, 0, 1, {0xE9, 0, 0}, 0, 1,
      {OPT_Imm|OPS_Any|OPTM_Near|OPA_JmpRel, 0, 0} },

    { CPU_Any, 0, 16, 1, {0xFF, 0, 0}, 4, 1, {OPT_RM|OPS_16|OPA_EA, 0, 0} },
    { CPU_386|CPU_Not64, 0, 32, 1, {0xFF, 0, 0}, 4, 1,
      {OPT_RM|OPS_32|OPA_EA, 0, 0} },
    { CPU_Hammer|CPU_64, 0, 0, 1, {0xFF, 0, 0}, 4, 1,
      {OPT_RM|OPS_64|OPA_EA, 0, 0} },
    { CPU_Any, 0, 0, 1, {0xFF, 0, 0}, 4, 1, {OPT_Mem|OPS_Any|OPA_EA, 0, 0} },
    { CPU_Any, 0, 16, 1, {0xFF, 0, 0}, 4, 1,
      {OPT_RM|OPS_16|OPTM_Near|OPA_EA, 0, 0} },
    { CPU_386|CPU_Not64, 0, 32, 1, {0xFF, 0, 0}, 4, 1,
      {OPT_RM|OPS_32|OPTM_Near|OPA_EA, 0, 0} },
    { CPU_Hammer|CPU_64, 0, 0, 1, {0xFF, 0, 0}, 4, 1,
      {OPT_RM|OPS_64|OPTM_Near|OPA_EA, 0, 0} },
    { CPU_Any, 0, 0, 1, {0xFF, 0, 0}, 4, 1,
      {OPT_Mem|OPS_Any|OPTM_Near|OPA_EA, 0, 0} },

    /* TODO: Far Imm 16:16/32 */

    { CPU_Any, 0, 16, 1, {0xFF, 0, 0}, 5, 1,
      {OPT_Mem|OPS_16|OPTM_Far|OPA_EA, 0, 0} },
    { CPU_386, 0, 32, 1, {0xFF, 0, 0}, 5, 1,
      {OPT_Mem|OPS_32|OPTM_Far|OPA_EA, 0, 0} },
    { CPU_Any, 0, 0, 1, {0xFF, 0, 0}, 5, 1,
      {OPT_Mem|OPS_Any|OPTM_Far|OPA_EA, 0, 0} }
};
static const x86_insn_info retnf_insn[] = {
    { CPU_Any, MOD_Op0Add, 0, 1, {0x01, 0, 0}, 0, 0, {0, 0, 0} },
    { CPU_Any, MOD_Op0Add, 0, 1, {0x00, 0, 0}, 0, 1,
      {OPT_Imm|OPS_16|OPS_Relaxed|OPA_Imm, 0, 0} }
};
static const x86_insn_info enter_insn[] = {
    { CPU_186, 0, 0, 1, {0xC8, 0, 0}, 0, 2,
      {OPT_Imm|OPS_16|OPS_Relaxed|OPA_EA, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm,
       0} }
};

/* Conditional jumps */
static const x86_insn_info jcc_insn[] = {
    { CPU_Any, 0, 0, 0, {0, 0, 0}, 0, 1, {OPT_Imm|OPS_Any|OPA_JmpRel, 0, 0} },
    { CPU_Any, 0, 16, 0, {0, 0, 0}, 0, 1, {OPT_Imm|OPS_16|OPA_JmpRel, 0, 0} },
    { CPU_386, 0, 32, 0, {0, 0, 0}, 0, 1, {OPT_Imm|OPS_32|OPA_JmpRel, 0, 0} },
    { CPU_Any, MOD_Op0Add, 0, 1, {0x70, 0, 0}, 0, 1,
      {OPT_Imm|OPS_Any|OPTM_Short|OPA_JmpRel, 0, 0} },
    { CPU_386, MOD_Op1Add, 16, 2, {0x0F, 0x80, 0}, 0, 1,
      {OPT_Imm|OPS_16|OPTM_Near|OPA_JmpRel, 0, 0} },
    { CPU_386, MOD_Op1Add, 32, 2, {0x0F, 0x80, 0}, 0, 1,
      {OPT_Imm|OPS_32|OPTM_Near|OPA_JmpRel, 0, 0} },
    { CPU_386, MOD_Op1Add, 0, 2, {0x0F, 0x80, 0}, 0, 1,
      {OPT_Imm|OPS_Any|OPTM_Near|OPA_JmpRel, 0, 0} }
};
static const x86_insn_info jcxz_insn[] = {
    { CPU_Any, MOD_AdSizeR, 0, 0, {0, 0, 0}, 0, 1,
      {OPT_Imm|OPS_Any|OPA_JmpRel, 0, 0} },
    { CPU_Any, MOD_AdSizeR, 0, 1, {0xE3, 0, 0}, 0, 1,
      {OPT_Imm|OPS_Any|OPTM_Short|OPA_JmpRel, 0, 0} }
};

/* Loop instructions */
static const x86_insn_info loop_insn[] = {
    { CPU_Any, 0, 0, 0, {0, 0, 0}, 0, 1, {OPT_Imm|OPS_Any|OPA_JmpRel, 0, 0} },
    { CPU_Not64, 0, 0, 0, {0, 0, 0}, 0, 2,
      {OPT_Imm|OPS_Any|OPA_JmpRel, OPT_Creg|OPS_16|OPA_AdSizeR, 0} },
    { CPU_386, 0, 0, 0, {0, 0, 0}, 0, 2,
      {OPT_Imm|OPS_Any|OPA_JmpRel, OPT_Creg|OPS_32|OPA_AdSizeR, 0} },
    { CPU_Hammer|CPU_64, 0, 0, 0, {0, 0, 0}, 0, 2,
      {OPT_Imm|OPS_Any|OPA_JmpRel, OPT_Creg|OPS_64|OPA_AdSizeR, 0} },

    { CPU_Not64, MOD_Op0Add, 0, 1, {0xE0, 0, 0}, 0, 1,
      {OPT_Imm|OPS_Any|OPTM_Short|OPA_JmpRel, 0, 0} },
    { CPU_Any, MOD_Op0Add, 0, 1, {0xE0, 0, 0}, 0, 2,
      {OPT_Imm|OPS_Any|OPTM_Short|OPA_JmpRel, OPT_Creg|OPS_16|OPA_AdSizeR, 0}
    },
    { CPU_386, MOD_Op0Add, 0, 1, {0xE0, 0, 0}, 0, 2,
      {OPT_Imm|OPS_Any|OPTM_Short|OPA_JmpRel, OPT_Creg|OPS_32|OPA_AdSizeR, 0}
    },
    { CPU_Hammer|CPU_64, MOD_Op0Add, 0, 1, {0xE0, 0, 0}, 0, 2,
      {OPT_Imm|OPS_Any|OPTM_Short|OPA_JmpRel, OPT_Creg|OPS_64|OPA_AdSizeR, 0} }
};

/* Set byte on flag instructions */
static const x86_insn_info setcc_insn[] = {
    { CPU_386, MOD_Op1Add, 0, 2, {0x0F, 0x90, 0}, 2, 1,
      {OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, 0, 0} }
};

/* Bit manipulation - bit tests */
static const x86_insn_info bittest_insn[] = {
    { CPU_386, MOD_Op1Add, 16, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_16|OPA_Spare, 0} },
    { CPU_386, MOD_Op1Add, 32, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_32|OPA_Spare, 0} },
    { CPU_Hammer|CPU_64, MOD_Op1Add, 64, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_64|OPA_Spare, 0} },
    { CPU_386, MOD_Gap0|MOD_SpAdd, 16, 2, {0x0F, 0xBA, 0}, 0, 2,
      {OPT_RM|OPS_16|OPA_EA, OPT_Imm|OPS_8|OPA_Imm, 0} },
    { CPU_386, MOD_Gap0|MOD_SpAdd, 32, 2, {0x0F, 0xBA, 0}, 0, 2,
      {OPT_RM|OPS_32|OPA_EA, OPT_Imm|OPS_8|OPA_Imm, 0} },
    { CPU_Hammer|CPU_64, MOD_Gap0|MOD_SpAdd, 64, 2, {0x0F, 0xBA, 0}, 0, 2,
      {OPT_RM|OPS_64|OPA_EA, OPT_Imm|OPS_8|OPA_Imm, 0} }
};

/* Bit manipulation - bit scans - also used for lar/lsl */
static const x86_insn_info bsfr_insn[] = {
    { CPU_286, MOD_Op1Add, 16, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386, MOD_Op1Add, 32, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Hammer|CPU_64, MOD_Op1Add, 64, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_Spare, OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, 0} }
};

/* Interrupts and operating system instructions */
static const x86_insn_info int_insn[] = {
    { CPU_Any, 0, 0, 1, {0xCD, 0, 0}, 0, 1,
      {OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0, 0} }
};
static const x86_insn_info bound_insn[] = {
    { CPU_186, 0, 16, 1, {0x62, 0, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_Mem|OPS_16|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386, 0, 32, 1, {0x62, 0, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_Mem|OPS_32|OPS_Relaxed|OPA_EA, 0} }
};

/* Protection control */
static const x86_insn_info arpl_insn[] = {
    { CPU_286|CPU_Prot, 0, 0, 1, {0x63, 0, 0}, 0, 2,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_16|OPA_Spare, 0} }
};
static const x86_insn_info str_insn[] = {
    { CPU_Hammer, 0, 16, 2, {0x0F, 0x00, 0}, 1, 1,
      {OPT_Reg|OPS_16|OPA_EA, 0, 0} },
    { CPU_Hammer, 0, 32, 2, {0x0F, 0x00, 0}, 1, 1,
      {OPT_Reg|OPS_32|OPA_EA, 0, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 2, {0x0F, 0x00, 0}, 1, 1,
      {OPT_Reg|OPS_64|OPA_EA, 0, 0} },
    { CPU_286, MOD_Op1Add|MOD_SpAdd, 0, 2, {0x0F, 0x00, 0}, 0, 1,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, 0, 0} }
};
static const x86_insn_info prot286_insn[] = {
    { CPU_286, MOD_Op1Add|MOD_SpAdd, 0, 2, {0x0F, 0x00, 0}, 0, 1,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, 0, 0} }
};
static const x86_insn_info sldtmsw_insn[] = {
    { CPU_286, MOD_Op1Add|MOD_SpAdd, 0, 2, {0x0F, 0x00, 0}, 0, 1,
      {OPT_Mem|OPS_16|OPS_Relaxed|OPA_EA, 0, 0} },
    { CPU_386, MOD_Op1Add|MOD_SpAdd, 0, 2, {0x0F, 0x00, 0}, 0, 1,
      {OPT_Mem|OPS_32|OPS_Relaxed|OPA_EA, 0, 0} },
    { CPU_Hammer|CPU_64, MOD_Op1Add|MOD_SpAdd, 0, 2, {0x0F, 0x00, 0}, 0, 1,
      {OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, 0, 0} },
    { CPU_286, MOD_Op1Add|MOD_SpAdd, 16, 2, {0x0F, 0x00, 0}, 0, 1,
      {OPT_Reg|OPS_16|OPA_EA, 0, 0} },
    { CPU_386, MOD_Op1Add|MOD_SpAdd, 32, 2, {0x0F, 0x00, 0}, 0, 1,
      {OPT_Reg|OPS_32|OPA_EA, 0, 0} },
    { CPU_Hammer|CPU_64, MOD_Op1Add|MOD_SpAdd, 64, 2, {0x0F, 0x00, 0}, 0, 1,
      {OPT_Reg|OPS_64|OPA_EA, 0, 0} }
};

/* Floating point instructions - load/store with pop (integer and normal) */
static const x86_insn_info fldstp_insn[] = {
    { CPU_FPU, MOD_Gap0|MOD_SpAdd, 0, 1, {0xD9, 0, 0}, 0, 1,
      {OPT_Mem|OPS_32|OPA_EA, 0, 0} },
    { CPU_FPU, MOD_Gap0|MOD_SpAdd, 0, 1, {0xDD, 0, 0}, 0, 1,
      {OPT_Mem|OPS_64|OPA_EA, 0, 0} },
    { CPU_FPU, MOD_Gap0|MOD_Gap1|MOD_SpAdd, 0, 1, {0xDB, 0, 0}, 0, 1,
      {OPT_Mem|OPS_80|OPA_EA, 0, 0} },
    { CPU_FPU, MOD_Op1Add, 0, 2, {0xD9, 0x00, 0}, 0, 1,
      {OPT_Reg|OPS_80|OPA_Op1Add, 0, 0} }
};
static const x86_insn_info fildstp_insn[] = {
    { CPU_FPU, MOD_SpAdd, 0, 1, {0xDF, 0, 0}, 0, 1,
      {OPT_Mem|OPS_16|OPA_EA, 0, 0} },
    { CPU_FPU, MOD_SpAdd, 0, 1, {0xDB, 0, 0}, 0, 1,
      {OPT_Mem|OPS_32|OPA_EA, 0, 0} },
    { CPU_FPU, MOD_Gap0|MOD_SpAdd, 0, 1, {0xDF, 0, 0}, 0, 1,
      {OPT_Mem|OPS_64|OPA_EA, 0, 0} }
};
static const x86_insn_info fbldstp_insn[] = {
    { CPU_FPU, MOD_SpAdd, 0, 1, {0xDF, 0, 0}, 0, 1,
      {OPT_Mem|OPS_80|OPS_Relaxed|OPA_EA, 0, 0} }
};
/* Floating point instructions - store (normal) */
static const x86_insn_info fst_insn[] = {
    { CPU_FPU, 0, 0, 1, {0xD9, 0, 0}, 2, 1, {OPT_Mem|OPS_32|OPA_EA, 0, 0} },
    { CPU_FPU, 0, 0, 1, {0xDD, 0, 0}, 2, 1, {OPT_Mem|OPS_64|OPA_EA, 0, 0} },
    { CPU_FPU, 0, 0, 2, {0xDD, 0xD0, 0}, 0, 1,
      {OPT_Reg|OPS_80|OPA_Op1Add, 0, 0} }
};
/* Floating point instructions - exchange (with ST0) */
static const x86_insn_info fxch_insn[] = {
    { CPU_FPU, 0, 0, 2, {0xD9, 0xC8, 0}, 0, 1,
      {OPT_Reg|OPS_80|OPA_Op1Add, 0, 0} },
    { CPU_FPU, 0, 0, 2, {0xD9, 0xC8, 0}, 0, 2,
      {OPT_ST0|OPS_80|OPA_None, OPT_Reg|OPS_80|OPA_Op1Add, 0} },
    { CPU_FPU, 0, 0, 2, {0xD9, 0xC8, 0}, 0, 2,
      {OPT_Reg|OPS_80|OPA_Op1Add, OPT_ST0|OPS_80|OPA_None, 0} },
    { CPU_FPU, 0, 0, 2, {0xD9, 0xC9, 0}, 0, 0, {0, 0, 0} }
};
/* Floating point instructions - comparisons */
static const x86_insn_info fcom_insn[] = {
    { CPU_FPU, MOD_Gap0|MOD_SpAdd, 0, 1, {0xD8, 0, 0}, 0, 1,
      {OPT_Mem|OPS_32|OPA_EA, 0, 0} },
    { CPU_FPU, MOD_Gap0|MOD_SpAdd, 0, 1, {0xDC, 0, 0}, 0, 1,
      {OPT_Mem|OPS_64|OPA_EA, 0, 0} },
    { CPU_FPU, MOD_Op1Add, 0, 2, {0xD8, 0x00, 0}, 0, 1,
      {OPT_Reg|OPS_80|OPA_Op1Add, 0, 0} },
    { CPU_FPU, MOD_Op1Add, 0, 2, {0xD8, 0x00, 0}, 0, 2,
      {OPT_ST0|OPS_80|OPA_None, OPT_Reg|OPS_80|OPA_Op1Add, 0} }
};
/* Floating point instructions - extended comparisons */
static const x86_insn_info fcom2_insn[] = {
    { CPU_286|CPU_FPU, MOD_Op0Add|MOD_Op1Add, 0, 2, {0x00, 0x00, 0}, 0, 1,
      {OPT_Reg|OPS_80|OPA_Op1Add, 0, 0} },
    { CPU_286|CPU_FPU, MOD_Op0Add|MOD_Op1Add, 0, 2, {0x00, 0x00, 0}, 0, 2,
      {OPT_ST0|OPS_80|OPA_None, OPT_Reg|OPS_80|OPA_Op1Add, 0} }
};
/* Floating point instructions - arithmetic */
static const x86_insn_info farith_insn[] = {
    { CPU_FPU, MOD_Gap0|MOD_Gap1|MOD_SpAdd, 0, 1, {0xD8, 0, 0}, 0, 1,
      {OPT_Mem|OPS_32|OPA_EA, 0, 0} },
    { CPU_FPU, MOD_Gap0|MOD_Gap1|MOD_SpAdd, 0, 1, {0xDC, 0, 0}, 0, 1,
      {OPT_Mem|OPS_64|OPA_EA, 0, 0} },
    { CPU_FPU, MOD_Gap0|MOD_Op1Add, 0, 2, {0xD8, 0x00, 0}, 0, 1,
      {OPT_Reg|OPS_80|OPA_Op1Add, 0, 0} },
    { CPU_FPU, MOD_Gap0|MOD_Op1Add, 0, 2, {0xD8, 0x00, 0}, 0, 2,
      {OPT_ST0|OPS_80|OPA_None, OPT_Reg|OPS_80|OPA_Op1Add, 0} },
    { CPU_FPU, MOD_Op1Add, 0, 2, {0xDC, 0x00, 0}, 0, 1,
      {OPT_Reg|OPS_80|OPTM_To|OPA_Op1Add, 0, 0} },
    { CPU_FPU, MOD_Op1Add, 0, 2, {0xDC, 0x00, 0}, 0, 2,
      {OPT_Reg|OPS_80|OPA_Op1Add, OPT_ST0|OPS_80|OPA_None, 0} }
};
static const x86_insn_info farithp_insn[] = {
    { CPU_FPU, MOD_Op1Add, 0, 2, {0xDE, 0x01, 0}, 0, 0, {0, 0, 0} },
    { CPU_FPU, MOD_Op1Add, 0, 2, {0xDE, 0x00, 0}, 0, 1,
      {OPT_Reg|OPS_80|OPA_Op1Add, 0, 0} },
    { CPU_FPU, MOD_Op1Add, 0, 2, {0xDE, 0x00, 0}, 0, 2,
      {OPT_Reg|OPS_80|OPA_Op1Add, OPT_ST0|OPS_80|OPA_None, 0} }
};
/* Floating point instructions - integer arith/store wo pop/compare */
static const x86_insn_info fiarith_insn[] = {
    { CPU_FPU, MOD_Op0Add|MOD_SpAdd, 0, 1, {0x04, 0, 0}, 0, 1,
      {OPT_Mem|OPS_16|OPA_EA, 0, 0} },
    { CPU_FPU, MOD_Op0Add|MOD_SpAdd, 0, 1, {0x00, 0, 0}, 0, 1,
      {OPT_Mem|OPS_32|OPA_EA, 0, 0} }
};
/* Floating point instructions - processor control */
static const x86_insn_info fldnstcw_insn[] = {
    { CPU_FPU, MOD_SpAdd, 0, 1, {0xD9, 0, 0}, 0, 1,
      {OPT_Mem|OPS_16|OPS_Relaxed|OPA_EA, 0, 0} }
};
static const x86_insn_info fstcw_insn[] = {
    { CPU_FPU, 0, 0, 2, {0x9B, 0xD9, 0}, 7, 1,
      {OPT_Mem|OPS_16|OPS_Relaxed|OPA_EA, 0, 0} }
};
static const x86_insn_info fnstsw_insn[] = {
    { CPU_FPU, 0, 0, 1, {0xDD, 0, 0}, 7, 1,
      {OPT_Mem|OPS_16|OPS_Relaxed|OPA_EA, 0, 0} },
    { CPU_FPU, 0, 0, 2, {0xDF, 0xE0, 0}, 0, 1,
      {OPT_Areg|OPS_16|OPA_None, 0, 0} }
};
static const x86_insn_info fstsw_insn[] = {
    { CPU_FPU, 0, 0, 2, {0x9B, 0xDD, 0}, 7, 1,
      {OPT_Mem|OPS_16|OPS_Relaxed|OPA_EA, 0, 0} },
    { CPU_FPU, 0, 0, 3, {0x9B, 0xDF, 0xE0}, 0, 1,
      {OPT_Areg|OPS_16|OPA_None, 0, 0} }
};
static const x86_insn_info ffree_insn[] = {
    { CPU_FPU, MOD_Op0Add, 0, 2, {0x00, 0xC0, 0}, 0, 1,
      {OPT_Reg|OPS_80|OPA_Op1Add, 0, 0} }
};

/* 486 extensions */
static const x86_insn_info bswap_insn[] = {
    { CPU_486, 0, 32, 2, {0x0F, 0xC8, 0}, 0, 1,
      {OPT_Reg|OPS_32|OPA_Op1Add, 0, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 2, {0x0F, 0xC8, 0}, 0, 1,
      {OPT_Reg|OPS_64|OPA_Op1Add, 0, 0} }
};
static const x86_insn_info cmpxchgxadd_insn[] = {
    { CPU_486, MOD_Op1Add, 0, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_8|OPA_Spare, 0} },
    { CPU_486, MOD_Op1Add, 16, 2, {0x0F, 0x01, 0}, 0, 2,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_16|OPA_Spare, 0} },
    { CPU_486, MOD_Op1Add, 32, 2, {0x0F, 0x01, 0}, 0, 2,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_32|OPA_Spare, 0} },
    { CPU_Hammer|CPU_64, MOD_Op1Add, 64, 2, {0x0F, 0x01, 0}, 0, 2,
      {OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_64|OPA_Spare, 0} }
};

/* Pentium extensions */
static const x86_insn_info cmpxchg8b_insn[] = {
    { CPU_586, 0, 0, 2, {0x0F, 0xC7, 0}, 1, 1,
      {OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, 0, 0} }
};

/* Pentium II/Pentium Pro extensions */
static const x86_insn_info cmovcc_insn[] = {
    { CPU_686, MOD_Op1Add, 16, 2, {0x0F, 0x40, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, 0} },
    { CPU_686, MOD_Op1Add, 32, 2, {0x0F, 0x40, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, 0} },
    { CPU_Hammer|CPU_64, MOD_Op1Add, 64, 2, {0x0F, 0x40, 0}, 0, 2,
      {OPT_Reg|OPS_64|OPA_Spare, OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, 0} }
};
static const x86_insn_info fcmovcc_insn[] = {
    { CPU_686|CPU_FPU, MOD_Op0Add|MOD_Op1Add, 0, 2, {0x00, 0x00, 0}, 0, 2,
      {OPT_ST0|OPS_80|OPA_None, OPT_Reg|OPS_80|OPA_Op1Add, 0} }
};

/* Pentium4 extensions */
static const x86_insn_info movnti_insn[] = {
    { CPU_P4, 0, 0, 2, {0x0F, 0xC3, 0}, 0, 2,
      {OPT_Mem|OPS_32|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_32|OPA_Spare, 0} },
    { CPU_Hammer|CPU_64, 0, 64, 2, {0x0F, 0xC3, 0}, 0, 2,
      {OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_64|OPA_Spare, 0} }
};
static const x86_insn_info clflush_insn[] = {
    { CPU_P3, 0, 0, 2, {0x0F, 0xAE, 0}, 7, 1,
      {OPT_Mem|OPS_8|OPS_Relaxed|OPA_EA, 0, 0} }
};

/* MMX/SSE2 instructions */
static const x86_insn_info movd_insn[] = {
    { CPU_MMX, 0, 0, 2, {0x0F, 0x6E, 0}, 0, 2,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, 0} },
    { CPU_MMX|CPU_Hammer|CPU_64, 0, 64, 2, {0x0F, 0x6E, 0}, 0, 2,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, 0} },
    { CPU_MMX, 0, 0, 2, {0x0F, 0x7E, 0}, 0, 2,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_64|OPA_Spare, 0} },
    { CPU_MMX|CPU_Hammer|CPU_64, 0, 64, 2, {0x0F, 0x7E, 0}, 0, 2,
      {OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_64|OPA_Spare, 0} },
    { CPU_SSE2, 0, 0, 3, {0x66, 0x0F, 0x6E}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, 0} },
    { CPU_SSE2|CPU_Hammer|CPU_64, 0, 64, 3, {0x66, 0x0F, 0x6E}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, 0} },
    { CPU_SSE2, 0, 0, 3, {0x66, 0x0F, 0x7E}, 0, 2,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0} },
    { CPU_SSE2|CPU_Hammer|CPU_64, 0, 64, 3, {0x66, 0x0F, 0x7E}, 0, 2,
      {OPT_RM|OPS_64|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0} }
};
static const x86_insn_info movq_insn[] = {
    { CPU_MMX, 0, 0, 2, {0x0F, 0x6F, 0}, 0, 2,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_SIMDRM|OPS_64|OPS_Relaxed|OPA_EA, 0}
    },
    { CPU_MMX, 0, 0, 2, {0x0F, 0x7F, 0}, 0, 2,
      {OPT_SIMDRM|OPS_64|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_64|OPA_Spare, 0}
    },
    { CPU_SSE2, 0, 0, 3, {0xF3, 0x0F, 0x7E}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDReg|OPS_128|OPA_EA, 0} },
    { CPU_SSE2, 0, 0, 3, {0xF3, 0x0F, 0x7E}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDRM|OPS_64|OPS_Relaxed|OPA_EA, 0}
    },
    { CPU_SSE2, 0, 0, 3, {0x66, 0x0F, 0xD6}, 0, 2,
      {OPT_SIMDRM|OPS_64|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0}
    }
};
static const x86_insn_info mmxsse2_insn[] = {
    { CPU_MMX, MOD_Op1Add, 0, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_SIMDRM|OPS_64|OPS_Relaxed|OPA_EA, 0}
    },
    { CPU_SSE2, MOD_Op2Add, 0, 3, {0x66, 0x0F, 0x00}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA, 0}
    }
};
static const x86_insn_info pshift_insn[] = {
    { CPU_MMX, MOD_Op1Add, 0, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_SIMDRM|OPS_64|OPS_Relaxed|OPA_EA, 0}
    },
    { CPU_MMX, MOD_Gap0|MOD_Op1Add|MOD_SpAdd, 0, 2, {0x0F, 0x00, 0}, 0,
      2, {OPT_SIMDReg|OPS_64|OPA_EA, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0} },
    { CPU_SSE2, MOD_Op2Add, 0, 3, {0x66, 0x0F, 0x00}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA, 0}
    },
    { CPU_SSE2, MOD_Gap0|MOD_Op2Add|MOD_SpAdd, 0, 3, {0x66, 0x0F, 0x00}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_EA, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0} }
};

/* PIII (Katmai) new instructions / SIMD instructiosn */
static const x86_insn_info sseps_insn[] = {
    { CPU_SSE, MOD_Op1Add, 0, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA, 0}
    }
};
static const x86_insn_info ssess_insn[] = {
    { CPU_SSE, MOD_Op0Add|MOD_Op2Add, 0, 3, {0x00, 0x0F, 0x00}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA, 0}
    }
};
static const x86_insn_info ssecmpps_insn[] = {
    { CPU_SSE, MOD_Imm8, 0, 2, {0x0F, 0xC2, 0}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA, 0}
    }
};
static const x86_insn_info ssecmpss_insn[] = {
    { CPU_SSE, MOD_Op0Add|MOD_Imm8, 0, 3, {0x00, 0x0F, 0xC2}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA, 0}
    }
};
static const x86_insn_info ssepsimm_insn[] = {
    { CPU_SSE, MOD_Op1Add, 0, 2, {0x0F, 0x00, 0}, 0, 3,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA,
       OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm} }
};
static const x86_insn_info ssessimm_insn[] = {
    { CPU_SSE, MOD_Op0Add|MOD_Op2Add, 0, 3, {0x00, 0x0F, 0x00}, 0, 3,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA,
       OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm} }
};
static const x86_insn_info ldstmxcsr_insn[] = {
    { CPU_SSE, MOD_SpAdd, 0, 2, {0x0F, 0xAE, 0}, 0, 1,
      {OPT_Mem|OPS_32|OPS_Relaxed|OPA_EA, 0, 0} }
};
static const x86_insn_info maskmovq_insn[] = {
    { CPU_P3|CPU_MMX, 0, 0, 2, {0x0F, 0xF7, 0}, 0, 2,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_SIMDReg|OPS_64|OPA_EA, 0} }
};
static const x86_insn_info movaups_insn[] = {
    { CPU_SSE, MOD_Op1Add, 0, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA, 0}
    },
    { CPU_SSE, MOD_Op1Add, 0, 2, {0x0F, 0x01, 0}, 0, 2,
      {OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0}
    }
};
static const x86_insn_info movhllhps_insn[] = {
    { CPU_SSE, MOD_Op1Add, 0, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDReg|OPS_128|OPA_EA, 0} }
};
static const x86_insn_info movhlps_insn[] = {
    { CPU_SSE, MOD_Op1Add, 0, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, 0} },
    { CPU_SSE, MOD_Op1Add, 0, 2, {0x0F, 0x01, 0}, 0, 2,
      {OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0} }
};
static const x86_insn_info movmskps_insn[] = {
    { CPU_SSE, 0, 0, 2, {0x0F, 0x50, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0} }
};
static const x86_insn_info movntps_insn[] = {
    { CPU_SSE, 0, 0, 2, {0x0F, 0x2B, 0}, 0, 2,
      {OPT_Mem|OPS_128|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_128|OPA_Spare, 0} }
};
static const x86_insn_info movntq_insn[] = {
    { CPU_SSE, 0, 0, 2, {0x0F, 0xE7, 0}, 0, 2,
      {OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0} }
};
static const x86_insn_info movss_insn[] = {
    { CPU_SSE, 0, 0, 3, {0xF3, 0x0F, 0x10}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDReg|OPS_128|OPA_EA, 0} },
    { CPU_SSE, 0, 0, 3, {0xF3, 0x0F, 0x10}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, 0} },
    { CPU_SSE, 0, 0, 3, {0xF3, 0x0F, 0x11}, 0, 2,
      {OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0} }
};
static const x86_insn_info pextrw_insn[] = {
    { CPU_P3|CPU_MMX, 0, 0, 2, {0x0F, 0xC5, 0}, 0, 3,
      {OPT_Reg|OPS_32|OPA_EA, OPT_SIMDReg|OPS_64|OPA_Spare,
       OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm} },
    { CPU_SSE2, 0, 0, 3, {0x66, 0x0F, 0xC5}, 0, 3,
      {OPT_Reg|OPS_32|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare,
       OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm} }
};
static const x86_insn_info pinsrw_insn[] = {
    { CPU_P3|CPU_MMX, 0, 0, 2, {0x0F, 0xC4, 0}, 0, 3,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_Reg|OPS_32|OPA_EA,
       OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm} },
    { CPU_P3|CPU_MMX, 0, 0, 2, {0x0F, 0xC4, 0}, 0, 3,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_RM|OPS_16|OPS_Relaxed|OPA_EA,
       OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm} },
    { CPU_SSE2, 0, 0, 3, {0x66, 0x0F, 0xC4}, 0, 3,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_Reg|OPS_32|OPA_EA,
       OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm} },
    { CPU_SSE2, 0, 0, 3, {0x66, 0x0F, 0xC4}, 0, 3,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_RM|OPS_16|OPS_Relaxed|OPA_EA,
       OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm} }
};
static const x86_insn_info pmovmskb_insn[] = {
    { CPU_P3|CPU_MMX, 0, 0, 2, {0x0F, 0xD7, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_EA, OPT_SIMDReg|OPS_64|OPA_Spare, 0} },
    { CPU_SSE2, 0, 0, 3, {0x66, 0x0F, 0xD7}, 0, 2,
      {OPT_Reg|OPS_32|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0} }
};
static const x86_insn_info pshufw_insn[] = {
    { CPU_P3|CPU_MMX, 0, 0, 2, {0x0F, 0x70, 0}, 0, 3,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_SIMDRM|OPS_64|OPS_Relaxed|OPA_EA,
       OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm} }
};

/* SSE2 instructions */
static const x86_insn_info cmpsd_insn[] = {
    { CPU_Any, 0, 32, 1, {0xA7, 0, 0}, 0, 0, {0, 0, 0} },
    { CPU_SSE2, 0, 0, 3, {0xF2, 0x0F, 0xC2}, 0, 3,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA,
       OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm} }
};
static const x86_insn_info movaupd_insn[] = {
    { CPU_SSE2, MOD_Op2Add, 0, 3, {0x66, 0x0F, 0x00}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA, 0}
    },
    { CPU_SSE2, MOD_Op2Add, 0, 3, {0x66, 0x0F, 0x01}, 0, 2,
      {OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0}
    }
};
static const x86_insn_info movhlpd_insn[] = {
    { CPU_SSE2, MOD_Op2Add, 0, 3, {0x66, 0x0F, 0x00}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, 0} },
    { CPU_SSE2, MOD_Op2Add, 0, 3, {0x66, 0x0F, 0x01}, 0, 2,
      {OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0} }
};
static const x86_insn_info movmskpd_insn[] = {
    { CPU_SSE2, 0, 0, 3, {0x66, 0x0F, 0x50}, 0, 2,
      {OPT_Reg|OPS_32|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0} }
};
static const x86_insn_info movntpddq_insn[] = {
    { CPU_SSE2, MOD_Op2Add, 0, 3, {0x66, 0x0F, 0x00}, 0, 2,
      {OPT_Mem|OPS_128|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0} }
};
static const x86_insn_info movsd_insn[] = {
    { CPU_Any, 0, 32, 1, {0xA5, 0, 0}, 0, 0, {0, 0, 0} },
    { CPU_SSE2, 0, 0, 3, {0xF2, 0x0F, 0x10}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDReg|OPS_128|OPA_EA, 0} },
    { CPU_SSE2, 0, 0, 3, {0xF2, 0x0F, 0x10}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, 0} },
    { CPU_SSE2, 0, 0, 3, {0xF2, 0x0F, 0x11}, 0, 2,
      {OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0} }
};
static const x86_insn_info maskmovdqu_insn[] = {
    { CPU_SSE2, 0, 0, 3, {0x66, 0x0F, 0xF7}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDReg|OPS_128|OPA_EA, 0} }
};
static const x86_insn_info movdqau_insn[] = {
    { CPU_SSE2, MOD_Op0Add, 0, 3, {0x00, 0x0F, 0x6F}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA, 0}
    },
    { CPU_SSE2, MOD_Op0Add, 0, 3, {0x00, 0x0F, 0x7F}, 0, 2,
      {OPT_SIMDRM|OPS_128|OPS_Relaxed|OPA_EA, OPT_SIMDReg|OPS_128|OPA_Spare, 0}
    }
};
static const x86_insn_info movdq2q_insn[] = {
    { CPU_SSE2, 0, 0, 3, {0xF2, 0x0F, 0xD6}, 0, 2,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_SIMDReg|OPS_128|OPA_EA, 0} }
};
static const x86_insn_info movq2dq_insn[] = {
    { CPU_SSE2, 0, 0, 3, {0xF3, 0x0F, 0xD6}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_Spare, OPT_SIMDReg|OPS_64|OPA_EA, 0} }
};
static const x86_insn_info pslrldq_insn[] = {
    { CPU_SSE2, MOD_SpAdd, 0, 3, {0x66, 0x0F, 0x73}, 0, 2,
      {OPT_SIMDReg|OPS_128|OPA_EA, OPT_Imm|OPS_8|OPS_Relaxed|OPA_Imm, 0} }
};

/* AMD 3DNow! instructions */
static const x86_insn_info now3d_insn[] = {
    { CPU_3DNow, MOD_Imm8, 0, 2, {0x0F, 0x0F, 0}, 0, 2,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_SIMDRM|OPS_64|OPS_Relaxed|OPA_EA, 0} }
};

/* Cyrix MMX instructions */
static const x86_insn_info cyrixmmx_insn[] = {
    { CPU_Cyrix|CPU_MMX, MOD_Op1Add, 0, 2, {0x0F, 0x00, 0}, 0, 2,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_SIMDRM|OPS_64|OPS_Relaxed|OPA_EA, 0} }
};
static const x86_insn_info pmachriw_insn[] = {
    { CPU_Cyrix|CPU_MMX, 0, 0, 2, {0x0F, 0x5E, 0}, 0, 2,
      {OPT_SIMDReg|OPS_64|OPA_Spare, OPT_Mem|OPS_64|OPS_Relaxed|OPA_EA, 0} }
};

/* Cyrix extensions */
static const x86_insn_info rsdc_insn[] = {
    { CPU_486|CPU_Cyrix|CPU_SMM, 0, 0, 2, {0x0F, 0x79, 0}, 0, 2,
      {OPT_SegReg|OPS_16|OPA_Spare, OPT_Mem|OPS_80|OPS_Relaxed|OPA_EA, 0} }
};
static const x86_insn_info cyrixsmm_insn[] = {
    { CPU_486|CPU_Cyrix|CPU_SMM, MOD_Op1Add, 0, 2, {0x0F, 0x00, 0}, 0, 1,
      {OPT_Mem|OPS_80|OPS_Relaxed|OPA_EA, 0, 0} }
};
static const x86_insn_info svdc_insn[] = {
    { CPU_486|CPU_Cyrix|CPU_SMM, 0, 0, 2, {0x0F, 0x78, 0}, 0, 2,
      {OPT_Mem|OPS_80|OPS_Relaxed|OPA_EA, OPT_SegReg|OPS_16|OPA_Spare, 0} }
};

/* Obsolete/undocumented instructions */
static const x86_insn_info ibts_insn[] = {
    { CPU_386|CPU_Undoc|CPU_Obs, 0, 16, 2, {0x0F, 0xA7, 0}, 0, 2,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_16|OPA_Spare, 0} },
    { CPU_386|CPU_Undoc|CPU_Obs, 0, 32, 2, {0x0F, 0xA7, 0}, 0, 2,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_32|OPA_Spare, 0} }
};
static const x86_insn_info umov_insn[] = {
    { CPU_386|CPU_Undoc, 0, 0, 2, {0x0F, 0x10, 0}, 0, 2,
      {OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_8|OPA_Spare, 0} },
    { CPU_386|CPU_Undoc, 0, 16, 2, {0x0F, 0x11, 0}, 0, 2,
      {OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_16|OPA_Spare, 0} },
    { CPU_386|CPU_Undoc, 0, 32, 2, {0x0F, 0x11, 0}, 0, 2,
      {OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, OPT_Reg|OPS_32|OPA_Spare, 0} },
    { CPU_386|CPU_Undoc, 0, 0, 2, {0x0F, 0x12, 0}, 0, 2,
      {OPT_Reg|OPS_8|OPA_Spare, OPT_RM|OPS_8|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386|CPU_Undoc, 0, 16, 2, {0x0F, 0x13, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_RM|OPS_16|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386|CPU_Undoc, 0, 32, 2, {0x0F, 0x13, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_RM|OPS_32|OPS_Relaxed|OPA_EA, 0} }
};
static const x86_insn_info xbts_insn[] = {
    { CPU_386|CPU_Undoc|CPU_Obs, 0, 16, 2, {0x0F, 0xA6, 0}, 0, 2,
      {OPT_Reg|OPS_16|OPA_Spare, OPT_Mem|OPS_16|OPS_Relaxed|OPA_EA, 0} },
    { CPU_386|CPU_Undoc|CPU_Obs, 0, 32, 2, {0x0F, 0xA6, 0}, 0, 2,
      {OPT_Reg|OPS_32|OPA_Spare, OPT_Mem|OPS_32|OPS_Relaxed|OPA_EA, 0} }
};


static yasm_bytecode *
x86_new_jmprel(const unsigned long data[4], int num_operands,
	       yasm_insn_operandhead *operands, x86_insn_info *jrinfo,
	       yasm_section *cur_section, /*@null@*/ yasm_bytecode *prev_bc,
	       unsigned long lindex)
{
    x86_new_jmprel_data d;
    int num_info = (int)(data[1]&0xFF);
    x86_insn_info *info = (x86_insn_info *)data[0];
    unsigned long mod_data = data[1] >> 8;
    yasm_insn_operand *op;
    static const unsigned char size_lookup[] = {0, 8, 16, 32, 64, 80, 128, 0};

    d.lindex = lindex;

    /* We know the target is in operand 0, but sanity check for Imm. */
    op = yasm_ops_first(operands);
    if (op->type != YASM_INSN__OPERAND_IMM)
	yasm_internal_error(N_("invalid operand conversion"));
    d.target = yasm_expr_new(YASM_EXPR_SUB, yasm_expr_expr(op->data.val),
	yasm_expr_sym(yasm_symrec_define_label("$", cur_section, prev_bc,
					       0, lindex)), lindex);

    /* See if the user explicitly specified short/near. */
    switch ((int)(jrinfo->operands[0] & OPTM_MASK)) {
	case OPTM_Short:
	    d.op_sel = JR_SHORT_FORCED;
	    break;
	case OPTM_Near:
	    d.op_sel = JR_NEAR_FORCED;
	    break;
	default:
	    d.op_sel = JR_NONE;
    }

    /* Set operand size */
    d.opersize = jrinfo->opersize;

    /* Check for address size setting in second operand, if present */
    if (jrinfo->num_operands > 1 &&
	(jrinfo->operands[1] & OPA_MASK) == OPA_AdSizeR)
	d.addrsize = (unsigned char)size_lookup[(jrinfo->operands[1] &
						 OPS_MASK)>>OPS_SHIFT];
    else
	d.addrsize = 0;

    /* Check for address size override */
    if (jrinfo->modifiers & MOD_AdSizeR)
	d.addrsize = (unsigned char)(mod_data & 0xFF);

    /* Scan through other infos for this insn looking for short/near versions.
     * Needs to match opersize and number of operands, also be within CPU.
     */
    d.short_op_len = 0;
    d.near_op_len = 0;
    for (; num_info>0 && (d.short_op_len == 0 || d.near_op_len == 0);
	 num_info--, info++) {
	unsigned long cpu = info->cpu | data[2];

	if ((cpu & CPU_64) && yasm_x86_LTX_mode_bits != 64)
	    continue;
	if ((cpu & CPU_Not64) && yasm_x86_LTX_mode_bits == 64)
	    continue;
	cpu &= ~(CPU_64 | CPU_Not64);

	if ((cpu_enabled & cpu) != cpu)
	    continue;

	if (info->num_operands == 0)
	    continue;

	if ((info->operands[0] & OPA_MASK) != OPA_JmpRel)
	    continue;

	if (info->opersize != d.opersize)
	    continue;

	switch ((int)(info->operands[0] & OPTM_MASK)) {
	    case OPTM_Short:
		d.short_op_len = info->opcode_len;
		d.short_op[0] = info->opcode[0];
		d.short_op[1] = info->opcode[1];
		d.short_op[2] = info->opcode[2];
		if (info->modifiers & MOD_Op0Add)
		    d.short_op[0] += (unsigned char)(mod_data & 0xFF);
		break;
	    case OPTM_Near:
		d.near_op_len = info->opcode_len;
		d.near_op[0] = info->opcode[0];
		d.near_op[1] = info->opcode[1];
		d.near_op[2] = info->opcode[2];
		if (info->modifiers & MOD_Op1Add)
		    d.near_op[1] += (unsigned char)(mod_data & 0xFF);
		break;
	}
    }

    return yasm_x86__bc_new_jmprel(&d);
}

yasm_bytecode *
yasm_x86__new_insn(const unsigned long data[4], int num_operands,
		   yasm_insn_operandhead *operands, yasm_section *cur_section,
		   /*@null@*/ yasm_bytecode *prev_bc, unsigned long lindex)
{
    x86_new_insn_data d;
    int num_info = (int)(data[1]&0xFF);
    x86_insn_info *info = (x86_insn_info *)data[0];
    unsigned long mod_data = data[1] >> 8;
    int found = 0;
    yasm_insn_operand *op;
    int i;
    static const unsigned int size_lookup[] = {0, 1, 2, 4, 8, 10, 16, 0};

    /* Just do a simple linear search through the info array for a match.
     * First match wins.
     */
    for (; num_info>0 && !found; num_info--, info++) {
	unsigned long cpu;
	unsigned int size;
	int mismatch = 0;

	/* Match CPU */
	cpu = info->cpu | data[2];

	if ((cpu & CPU_64) && yasm_x86_LTX_mode_bits != 64)
	    continue;
	if ((cpu & CPU_Not64) && yasm_x86_LTX_mode_bits == 64)
	    continue;
	cpu &= ~(CPU_64 | CPU_Not64);

	if ((cpu_enabled & cpu) != cpu)
	    continue;

	/* Match # of operands */
	if (num_operands != info->num_operands)
	    continue;

	if (!operands) {
	    found = 1;	    /* no operands -> must have a match here. */
	    break;
	}

	/* Match each operand type and size */
	for(i = 0, op = yasm_ops_first(operands); op && i<info->num_operands &&
	    !mismatch; op = yasm_ops_next(op), i++) {
	    /* Check operand type */
	    switch ((int)(info->operands[i] & OPT_MASK)) {
		case OPT_Imm:
		    if (op->type != YASM_INSN__OPERAND_IMM)
			mismatch = 1;
		    break;
		case OPT_RM:
		    if (op->type == YASM_INSN__OPERAND_MEMORY)
			break;
		    /*@fallthrough@*/
		case OPT_Reg:
		    if (op->type != YASM_INSN__OPERAND_REG)
			mismatch = 1;
		    else {
			switch ((x86_expritem_reg_size)(op->data.reg&~0xFUL)) {
			    case X86_REG8:
			    case X86_REG8X:
			    case X86_REG16:
			    case X86_REG32:
			    case X86_REG64:
			    case X86_FPUREG:
				break;
			    default:
				mismatch = 1;
				break;
			}
		    }
		    break;
		case OPT_Mem:
		    if (op->type != YASM_INSN__OPERAND_MEMORY)
			mismatch = 1;
		    break;
		case OPT_SIMDRM:
		    if (op->type == YASM_INSN__OPERAND_MEMORY)
			break;
		    /*@fallthrough@*/
		case OPT_SIMDReg:
		    if (op->type != YASM_INSN__OPERAND_REG)
			mismatch = 1;
		    else {
			switch ((x86_expritem_reg_size)(op->data.reg&~0xFUL)) {
			    case X86_MMXREG:
			    case X86_XMMREG:
				break;
			    default:
				mismatch = 1;
				break;
			}
		    }
		    break;
		case OPT_SegReg:
		    if (op->type != YASM_INSN__OPERAND_SEGREG)
			mismatch = 1;
		    break;
		case OPT_CRReg:
		    if (op->type != YASM_INSN__OPERAND_REG ||
			(op->data.reg & ~0xFUL) != X86_CRREG)
			mismatch = 1;
		    break;
		case OPT_DRReg:
		    if (op->type != YASM_INSN__OPERAND_REG ||
			(op->data.reg & ~0xFUL) != X86_DRREG)
			mismatch = 1;
		    break;
		case OPT_TRReg:
		    if (op->type != YASM_INSN__OPERAND_REG ||
			(op->data.reg & ~0xFUL) != X86_TRREG)
			mismatch = 1;
		    break;
		case OPT_ST0:
		    if (op->type != YASM_INSN__OPERAND_REG ||
			op->data.reg != X86_FPUREG)
			mismatch = 1;
		    break;
		case OPT_Areg:
		    if (op->type != YASM_INSN__OPERAND_REG ||
			((info->operands[i] & OPS_MASK) == OPS_8 &&
			 op->data.reg != (X86_REG8 | 0) &&
			 op->data.reg != (X86_REG8X | 0)) ||
			((info->operands[i] & OPS_MASK) == OPS_16 &&
			 op->data.reg != (X86_REG16 | 0)) ||
			((info->operands[i] & OPS_MASK) == OPS_32 &&
			 op->data.reg != (X86_REG32 | 0)) ||
			((info->operands[i] & OPS_MASK) == OPS_64 &&
			 op->data.reg != (X86_REG64 | 0)))
			mismatch = 1;
		    break;
		case OPT_Creg:
		    if (op->type != YASM_INSN__OPERAND_REG ||
			((info->operands[i] & OPS_MASK) == OPS_8 &&
			 op->data.reg != (X86_REG8 | 1) &&
			 op->data.reg != (X86_REG8X | 1)) ||
			((info->operands[i] & OPS_MASK) == OPS_16 &&
			 op->data.reg != (X86_REG16 | 1)) ||
			((info->operands[i] & OPS_MASK) == OPS_32 &&
			 op->data.reg != (X86_REG32 | 1)) ||
			((info->operands[i] & OPS_MASK) == OPS_64 &&
			 op->data.reg != (X86_REG64 | 1)))
			mismatch = 1;
		    break;
		case OPT_Dreg:
		    if (op->type != YASM_INSN__OPERAND_REG ||
			((info->operands[i] & OPS_MASK) == OPS_8 &&
			 op->data.reg != (X86_REG8 | 2) &&
			 op->data.reg != (X86_REG8X | 2)) ||
			((info->operands[i] & OPS_MASK) == OPS_16 &&
			 op->data.reg != (X86_REG16 | 2)) ||
			((info->operands[i] & OPS_MASK) == OPS_32 &&
			 op->data.reg != (X86_REG32 | 2)) ||
			((info->operands[i] & OPS_MASK) == OPS_64 &&
			 op->data.reg != (X86_REG64 | 2)))
			mismatch = 1;
		    break;
		case OPT_CS:
		    if (op->type != YASM_INSN__OPERAND_SEGREG ||
			(op->data.reg & 0xF) != 1)
			mismatch = 1;
		    break;
		case OPT_DS:
		    if (op->type != YASM_INSN__OPERAND_SEGREG ||
			(op->data.reg & 0xF) != 3)
			mismatch = 1;
		    break;
		case OPT_ES:
		    if (op->type != YASM_INSN__OPERAND_SEGREG ||
			(op->data.reg & 0xF) != 0)
			mismatch = 1;
		    break;
		case OPT_FS:
		    if (op->type != YASM_INSN__OPERAND_SEGREG ||
			(op->data.reg & 0xF) != 4)
			mismatch = 1;
		    break;
		case OPT_GS:
		    if (op->type != YASM_INSN__OPERAND_SEGREG ||
			(op->data.reg & 0xF) != 5)
			mismatch = 1;
		    break;
		case OPT_SS:
		    if (op->type != YASM_INSN__OPERAND_SEGREG ||
			(op->data.reg & 0xF) != 2)
			mismatch = 1;
		    break;
		case OPT_CR4:
		    if (op->type != YASM_INSN__OPERAND_REG ||
			op->data.reg != (X86_CRREG | 4))
			mismatch = 1;
		    break;
		case OPT_MemOffs:
		    if (op->type != YASM_INSN__OPERAND_MEMORY ||
			yasm_expr__contains(yasm_ea_get_disp(op->data.ea),
					    YASM_EXPR_REG))
			mismatch = 1;
		    break;
		default:
		    yasm_internal_error(N_("invalid operand type"));
	    }

	    if (mismatch)
		break;

	    /* Check operand size */
	    size = size_lookup[(info->operands[i] & OPS_MASK)>>OPS_SHIFT];
	    if (op->type == YASM_INSN__OPERAND_REG && op->size == 0) {
		/* Register size must exactly match */
		if (yasm_x86__get_reg_size(op->data.reg) != size)
		    mismatch = 1;
	    } else {
		if ((info->operands[i] & OPS_RMASK) == OPS_Relaxed) {
		    /* Relaxed checking */
		    if (size != 0 && op->size != size && op->size != 0)
			mismatch = 1;
		} else {
		    /* Strict checking */
		    if (op->size != size)
			mismatch = 1;
		}
	    }

	    if (mismatch)
		break;

	    /* Check target modifier */
	    switch ((int)(info->operands[i] & OPTM_MASK)) {
		case OPTM_None:
		    if (op->targetmod != 0)
			mismatch = 1;
		    break;
		case OPTM_Near:
		    if (op->targetmod != X86_NEAR)
			mismatch = 1;
		    break;
		case OPTM_Short:
		    if (op->targetmod != X86_SHORT)
			mismatch = 1;
		    break;
		case OPTM_Far:
		    if (op->targetmod != X86_FAR)
			mismatch = 1;
		    break;
		case OPTM_To:
		    if (op->targetmod != X86_TO)
			mismatch = 1;
		    break;
		default:
		    yasm_internal_error(N_("invalid target modifier type"));
	    }
	}

	if (!mismatch) {
	    found = 1;
	    break;
	}
    }

    if (!found) {
	/* Didn't find a matching one */
	yasm__error(lindex, N_("invalid combination of opcode and operands"));
	return NULL;
    }

    /* Extended error/warning handling */
    switch ((int)(info->modifiers & MOD_Ext_MASK)) {
	case MOD_ExtNone:
	    /* No extended modifier, so just continue */
	    break;
	case MOD_ExtErr:
	    switch ((int)((info->modifiers & MOD_ExtIndex_MASK)
			  >> MOD_ExtIndex_SHIFT)) {
		case 0:
		    yasm__error(lindex, N_("mismatch in operand sizes"));
		    break;
		case 1:
		    yasm__error(lindex, N_("operand size not specified"));
		    break;
		default:
		    yasm_internal_error(N_("unrecognized x86 ext mod index"));
	    }
	    return NULL;    /* It was an error */
	case MOD_ExtWarn:
	    switch ((int)((info->modifiers & MOD_ExtIndex_MASK)
			  >> MOD_ExtIndex_SHIFT)) {
		default:
		    yasm_internal_error(N_("unrecognized x86 ext mod index"));
	    }
	    break;
	default:
	    yasm_internal_error(N_("unrecognized x86 extended modifier"));
    }

    /* Shortcut to JmpRel */
    if (operands && (info->operands[0] & OPA_MASK) == OPA_JmpRel)
	return x86_new_jmprel(data, num_operands, operands, info, cur_section,
			      prev_bc, lindex);

    /* Copy what we can from info */
    d.lindex = lindex;
    d.ea = NULL;
    d.imm = NULL;
    d.opersize = info->opersize;
    d.op_len = info->opcode_len;
    d.op[0] = info->opcode[0];
    d.op[1] = info->opcode[1];
    d.op[2] = info->opcode[2];
    d.spare = info->spare;
    d.rex = (yasm_x86_LTX_mode_bits == 64 && info->opersize == 64) ? 0x48: 0;
    d.im_len = 0;
    d.im_sign = 0;
    d.shift_op = 0;
    d.signext_imm8_op = 0;

    /* Apply modifiers */
    if (info->modifiers & MOD_Op2Add) {
	d.op[2] += (unsigned char)(mod_data & 0xFF);
	mod_data >>= 8;
    }
    if (info->modifiers & MOD_Gap0)
	mod_data >>= 8;
    if (info->modifiers & MOD_Op1Add) {
	d.op[1] += (unsigned char)(mod_data & 0xFF);
	mod_data >>= 8;
    }
    if (info->modifiers & MOD_Gap1)
	mod_data >>= 8;
    if (info->modifiers & MOD_Op0Add) {
	d.op[0] += (unsigned char)(mod_data & 0xFF);
	mod_data >>= 8;
    }
    if (info->modifiers & MOD_SpAdd) {
	d.spare += (unsigned char)(mod_data & 0xFF);
	mod_data >>= 8;
    }
    if (info->modifiers & MOD_OpSizeR) {
	d.opersize = (unsigned char)(mod_data & 0xFF);
	mod_data >>= 8;
    }
    if (info->modifiers & MOD_Imm8) {
	d.imm = yasm_expr_new_ident(yasm_expr_int(
	    yasm_intnum_new_uint(mod_data & 0xFF)), lindex);
	d.im_len = 1;
	/*mod_data >>= 8;*/
    }

    /* Go through operands and assign */
    if (operands) {
	for(i = 0, op = yasm_ops_first(operands); op && i<info->num_operands;
	    op = yasm_ops_next(op), i++) {
	    switch ((int)(info->operands[i] & OPA_MASK)) {
		case OPA_None:
		    /* Throw away the operand contents */
		    switch (op->type) {
			case YASM_INSN__OPERAND_REG:
			case YASM_INSN__OPERAND_SEGREG:
			    break;
			case YASM_INSN__OPERAND_MEMORY:
			    yasm_ea_delete(op->data.ea);
			    break;
			case YASM_INSN__OPERAND_IMM:
			    yasm_expr_delete(op->data.val);
			    break;
		    }
		    break;
		case OPA_EA:
		    switch (op->type) {
			case YASM_INSN__OPERAND_REG:
			    d.ea =
				yasm_x86__ea_new_reg(op->data.reg, &d.rex,
						     yasm_x86_LTX_mode_bits);
			    break;
			case YASM_INSN__OPERAND_SEGREG:
			    yasm_internal_error(
				N_("invalid operand conversion"));
			case YASM_INSN__OPERAND_MEMORY:
			    d.ea = op->data.ea;
			    if ((info->operands[i] & OPT_MASK) == OPT_MemOffs)
				/* Special-case for MOV MemOffs instruction */
				yasm_x86__ea_set_disponly(d.ea);
			    break;
			case YASM_INSN__OPERAND_IMM:
			    d.ea = yasm_x86__ea_new_imm(op->data.val,
				size_lookup[(info->operands[i] &
					     OPS_MASK)>>OPS_SHIFT]);
			    break;
		    }
		    break;
		case OPA_Imm:
		    if (op->type == YASM_INSN__OPERAND_IMM) {
			d.imm = op->data.val;
			d.im_len = size_lookup[(info->operands[i] &
						OPS_MASK)>>OPS_SHIFT];
		    } else
			yasm_internal_error(N_("invalid operand conversion"));
		    break;
		case OPA_SImm:
		    if (op->type == YASM_INSN__OPERAND_IMM) {
			d.imm = op->data.val;
			d.im_len = size_lookup[(info->operands[i] &
						OPS_MASK)>>OPS_SHIFT];
			d.im_sign = 1;
		    } else
			yasm_internal_error(N_("invalid operand conversion"));
		    break;
		case OPA_Spare:
		    if (op->type == YASM_INSN__OPERAND_SEGREG)
			d.spare = (unsigned char)(op->data.reg&7);
		    else if (op->type == YASM_INSN__OPERAND_REG) {
			if (yasm_x86__set_rex_from_reg(&d.rex, &d.spare,
				op->data.reg, yasm_x86_LTX_mode_bits,
				X86_REX_R)) {
			    yasm__error(lindex,
				N_("invalid combination of opcode and operands"));
			    return NULL;
			}
		    } else
			yasm_internal_error(N_("invalid operand conversion"));
		    break;
		case OPA_Op0Add:
		    if (op->type == YASM_INSN__OPERAND_REG) {
			unsigned char opadd;
			if (yasm_x86__set_rex_from_reg(&d.rex, &opadd,
				op->data.reg, yasm_x86_LTX_mode_bits,
				X86_REX_B)) {
			    yasm__error(lindex,
				N_("invalid combination of opcode and operands"));
			    return NULL;
			}
			d.op[0] += opadd;
		    } else
			yasm_internal_error(N_("invalid operand conversion"));
		    break;
		case OPA_Op1Add:
		    /* Op1Add is only used for FPU, so no need to do REX */
		    if (op->type == YASM_INSN__OPERAND_REG)
			d.op[1] += (unsigned char)(op->data.reg&7);
		    else
			yasm_internal_error(N_("invalid operand conversion"));
		    break;
		case OPA_SpareEA:
		    if (op->type == YASM_INSN__OPERAND_REG) {
			d.ea = yasm_x86__ea_new_reg(op->data.reg, &d.rex,
						    yasm_x86_LTX_mode_bits);
			if (!d.ea ||
			    yasm_x86__set_rex_from_reg(&d.rex, &d.spare,
				op->data.reg, yasm_x86_LTX_mode_bits,
				X86_REX_R)) {
			    yasm__error(lindex,
				N_("invalid combination of opcode and operands"));
			    if (d.ea)
				yasm_xfree(d.ea);
			    return NULL;
			}
		    } else
			yasm_internal_error(N_("invalid operand conversion"));
		    break;
		default:
		    yasm_internal_error(N_("unknown operand action"));
	    }

	    switch ((int)(info->operands[i] & OPAP_MASK)) {
		case OPAP_None:
		    break;
		case OPAP_ShiftOp:
		    d.shift_op = 1;
		    break;
		case OPAP_SImm8Avail:
		    d.signext_imm8_op = 1;
		    break;
		default:
		    yasm_internal_error(
			N_("unknown operand postponed action"));
	    }
	}
    }

    /* Create the bytecode and return it */
    return yasm_x86__bc_new_insn(&d);
}


#define YYCTYPE		char
#define YYCURSOR	id
#define YYLIMIT		id
#define YYMARKER	marker
#define YYFILL(n)

#line 2130 "./modules/arch/x86/x86id.re"


void
yasm_x86__switch_cpu(const char *id, unsigned long lindex)
{
    /*const char *marker;*/

    
#line 2115 "x86id.c"
{
	YYCTYPE yych;

	goto yy0;
	++YYCURSOR;
yy0:
	if((YYLIMIT - YYCURSOR) < 13) YYFILL(13);
	yych = *YYCURSOR;
	switch(yych){
	case '\000':	goto yy25;
	case '1':	goto yy5;
	case '2':	goto yy6;
	case '3':	goto yy7;
	case '4':	goto yy8;
	case '5':	goto yy9;
	case '6':	goto yy11;
	case '8':	goto yy2;
	case 'A':	case 'a':	goto yy14;
	case 'C':	case 'c':	goto yy21;
	case 'F':	case 'f':	goto yy18;
	case 'H':	case 'h':	goto yy16;
	case 'I':	case 'i':	goto yy4;
	case 'K':	case 'k':	goto yy12;
	case 'M':	case 'm':	goto yy20;
	case 'N':	case 'n':	goto yy19;
	case 'O':	case 'o':	goto yy17;
	case 'P':	case 'p':	goto yy10;
	case 'S':	case 's':	goto yy15;
	case 'U':	case 'u':	goto yy22;
	case 'W':	case 'w':	goto yy13;
	default:	goto yy23;
	}
yy2:	yych = *++YYCURSOR;
	if(yych == '0')	goto yy209;
	goto yy24;
yy3:
#line 2242 "./modules/arch/x86/x86id.re"
{
	    yasm__warning(YASM_WARN_GENERAL, lindex,
			  N_("unrecognized CPU identifier `%s'"), id);
	    return;
	}
#line 2158 "x86id.c"
yy4:	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych <= '3'){
			if(yych <= '0')	goto yy24;
			if(yych <= '1')	goto yy5;
			if(yych <= '2')	goto yy6;
			goto yy198;
		} else {
			if(yych <= '4')	goto yy8;
			if(yych <= '5')	goto yy9;
			if(yych <= '6')	goto yy11;
			goto yy24;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'A')	goto yy199;
			if(yych == 'T')	goto yy200;
			goto yy24;
		} else {
			if(yych <= 'a')	goto yy199;
			if(yych == 't')	goto yy200;
			goto yy24;
		}
	}
yy5:	yych = *++YYCURSOR;
	if(yych == '8')	goto yy195;
	goto yy24;
yy6:	yych = *++YYCURSOR;
	if(yych == '8')	goto yy192;
	goto yy24;
yy7:	yych = *++YYCURSOR;
	if(yych <= 'C'){
		if(yych == '8')	goto yy184;
		goto yy24;
	} else {
		if(yych <= 'D')	goto yy185;
		if(yych == 'd')	goto yy185;
		goto yy24;
	}
yy8:	yych = *++YYCURSOR;
	if(yych == '8')	goto yy181;
	goto yy24;
yy9:	yych = *++YYCURSOR;
	if(yych == '8')	goto yy180;
	goto yy24;
yy10:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= '4'){
			if(yych <= '1')	goto yy24;
			if(yych <= '2')	goto yy156;
			if(yych <= '3')	goto yy151;
			goto yy142;
		} else {
			if(yych <= '6'){
				if(yych <= '5')	goto yy158;
				goto yy154;
			} else {
				if(yych == 'E')	goto yy160;
				goto yy24;
			}
		}
	} else {
		if(yych <= 'e'){
			if(yych <= 'Q'){
				if(yych <= 'P')	goto yy161;
				goto yy24;
			} else {
				if(yych <= 'R')	goto yy162;
				if(yych <= 'd')	goto yy24;
				goto yy160;
			}
		} else {
			if(yych <= 'p'){
				if(yych <= 'o')	goto yy24;
				goto yy161;
			} else {
				if(yych == 'r')	goto yy162;
				goto yy24;
			}
		}
	}
yy11:	yych = *++YYCURSOR;
	if(yych == '8')	goto yy153;
	goto yy24;
yy12:	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych <= '5')	goto yy24;
		if(yych <= '6')	goto yy144;
		if(yych <= '7')	goto yy146;
		goto yy24;
	} else {
		if(yych <= 'A')	goto yy147;
		if(yych == 'a')	goto yy147;
		goto yy24;
	}
yy13:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy133;
	if(yych == 'i')	goto yy133;
	goto yy24;
yy14:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych == 'M')	goto yy122;
		if(yych <= 'S')	goto yy24;
		goto yy123;
	} else {
		if(yych <= 'm'){
			if(yych <= 'l')	goto yy24;
			goto yy122;
		} else {
			if(yych == 't')	goto yy123;
			goto yy24;
		}
	}
yy15:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= 'L'){
			if(yych <= 'K')	goto yy24;
			goto yy109;
		} else {
			if(yych <= 'M')	goto yy110;
			if(yych <= 'R')	goto yy24;
			goto yy111;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'k')	goto yy24;
			if(yych <= 'l')	goto yy109;
			goto yy110;
		} else {
			if(yych == 's')	goto yy111;
			goto yy24;
		}
	}
yy16:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy105;
	if(yych == 'a')	goto yy105;
	goto yy24;
yy17:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych == 'B')	goto yy95;
		if(yych <= 'O')	goto yy24;
		goto yy96;
	} else {
		if(yych <= 'b'){
			if(yych <= 'a')	goto yy24;
			goto yy95;
		} else {
			if(yych == 'p')	goto yy96;
			goto yy24;
		}
	}
yy18:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy92;
	if(yych == 'p')	goto yy92;
	goto yy24;
yy19:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy40;
	if(yych == 'o')	goto yy40;
	goto yy24;
yy20:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy37;
	if(yych == 'm')	goto yy37;
	goto yy24;
yy21:	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy32;
	if(yych == 'y')	goto yy32;
	goto yy24;
yy22:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy27;
	if(yych == 'n')	goto yy27;
	goto yy24;
yy23:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy24:	if(yych <= '\000')	goto yy3;
	goto yy23;
yy25:	yych = *++YYCURSOR;

#line 2247 "./modules/arch/x86/x86id.re"
{
	    yasm__warning(YASM_WARN_GENERAL, lindex,
			  N_("unrecognized CPU identifier `%s'"), id);
	    return;
	}
#line 2343 "x86id.c"
yy27:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy28;
	if(yych != 'd')	goto yy24;
yy28:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy29;
	if(yych != 'o')	goto yy24;
yy29:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy30;
	if(yych != 'c')	goto yy24;
yy30:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2234 "./modules/arch/x86/x86id.re"
{ cpu_enabled |= CPU_Undoc; return; }
#line 2358 "x86id.c"
yy32:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy33;
	if(yych != 'r')	goto yy24;
yy33:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy34;
	if(yych != 'i')	goto yy24;
yy34:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy35;
	if(yych != 'x')	goto yy24;
yy35:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2226 "./modules/arch/x86/x86id.re"
{ cpu_enabled |= CPU_Cyrix; return; }
#line 2373 "x86id.c"
yy37:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy38;
	if(yych != 'x')	goto yy24;
yy38:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2218 "./modules/arch/x86/x86id.re"
{ cpu_enabled |= CPU_MMX; return; }
#line 2382 "x86id.c"
yy40:	yych = *++YYCURSOR;
	switch(yych){
	case '3':	goto yy44;
	case 'A':	case 'a':	goto yy46;
	case 'C':	case 'c':	goto yy45;
	case 'F':	case 'f':	goto yy41;
	case 'M':	case 'm':	goto yy42;
	case 'O':	case 'o':	goto yy49;
	case 'P':	case 'p':	goto yy47;
	case 'S':	case 's':	goto yy43;
	case 'U':	case 'u':	goto yy48;
	default:	goto yy24;
	}
yy41:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy89;
	if(yych == 'p')	goto yy89;
	goto yy24;
yy42:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy86;
	if(yych == 'm')	goto yy86;
	goto yy24;
yy43:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'M')	goto yy78;
		if(yych <= 'R')	goto yy24;
		goto yy79;
	} else {
		if(yych <= 'm'){
			if(yych <= 'l')	goto yy24;
			goto yy78;
		} else {
			if(yych == 's')	goto yy79;
			goto yy24;
		}
	}
yy44:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy73;
	if(yych == 'd')	goto yy73;
	goto yy24;
yy45:	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy68;
	if(yych == 'y')	goto yy68;
	goto yy24;
yy46:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy65;
	if(yych == 'm')	goto yy65;
	goto yy24;
yy47:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy58;
	if(yych == 'r')	goto yy58;
	goto yy24;
yy48:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy53;
	if(yych == 'n')	goto yy53;
	goto yy24;
yy49:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy50;
	if(yych != 'b')	goto yy24;
yy50:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy51;
	if(yych != 's')	goto yy24;
yy51:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2237 "./modules/arch/x86/x86id.re"
{ cpu_enabled &= ~CPU_Obs; return; }
#line 2449 "x86id.c"
yy53:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy54;
	if(yych != 'd')	goto yy24;
yy54:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy55;
	if(yych != 'o')	goto yy24;
yy55:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy56;
	if(yych != 'c')	goto yy24;
yy56:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2235 "./modules/arch/x86/x86id.re"
{ cpu_enabled &= ~CPU_Undoc; return; }
#line 2464 "x86id.c"
yy58:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych == 'I')	goto yy60;
		if(yych <= 'N')	goto yy24;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy24;
			goto yy60;
		} else {
			if(yych != 'o')	goto yy24;
		}
	}
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy63;
	if(yych == 't')	goto yy63;
	goto yy24;
yy60:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy61;
	if(yych != 'v')	goto yy24;
yy61:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2239 "./modules/arch/x86/x86id.re"
{ cpu_enabled &= ~CPU_Priv; return; }
#line 2489 "x86id.c"
yy63:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2233 "./modules/arch/x86/x86id.re"
{ cpu_enabled &= ~CPU_Prot; return; }
#line 2495 "x86id.c"
yy65:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy66;
	if(yych != 'd')	goto yy24;
yy66:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2229 "./modules/arch/x86/x86id.re"
{ cpu_enabled &= ~CPU_AMD; return; }
#line 2504 "x86id.c"
yy68:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy69;
	if(yych != 'r')	goto yy24;
yy69:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy70;
	if(yych != 'i')	goto yy24;
yy70:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy71;
	if(yych != 'x')	goto yy24;
yy71:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2227 "./modules/arch/x86/x86id.re"
{ cpu_enabled &= ~CPU_Cyrix; return; }
#line 2519 "x86id.c"
yy73:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy74;
	if(yych != 'n')	goto yy24;
yy74:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy75;
	if(yych != 'o')	goto yy24;
yy75:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy76;
	if(yych != 'w')	goto yy24;
yy76:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2225 "./modules/arch/x86/x86id.re"
{ cpu_enabled &= ~CPU_3DNow; return; }
#line 2534 "x86id.c"
yy78:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy84;
	if(yych == 'm')	goto yy84;
	goto yy24;
yy79:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy80;
	if(yych != 'e')	goto yy24;
yy80:	yych = *++YYCURSOR;
	if(yych <= '\000')	goto yy81;
	if(yych == '2')	goto yy82;
	goto yy23;
yy81:
#line 2221 "./modules/arch/x86/x86id.re"
{ cpu_enabled &= ~CPU_SSE; return; }
#line 2549 "x86id.c"
yy82:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2223 "./modules/arch/x86/x86id.re"
{ cpu_enabled &= ~CPU_SSE2; return; }
#line 2555 "x86id.c"
yy84:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2231 "./modules/arch/x86/x86id.re"
{ cpu_enabled &= ~CPU_SMM; return; }
#line 2561 "x86id.c"
yy86:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy87;
	if(yych != 'x')	goto yy24;
yy87:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2219 "./modules/arch/x86/x86id.re"
{ cpu_enabled &= ~CPU_MMX; return; }
#line 2570 "x86id.c"
yy89:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy90;
	if(yych != 'u')	goto yy24;
yy90:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2217 "./modules/arch/x86/x86id.re"
{ cpu_enabled &= ~CPU_FPU; return; }
#line 2579 "x86id.c"
yy92:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy93;
	if(yych != 'u')	goto yy24;
yy93:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2216 "./modules/arch/x86/x86id.re"
{ cpu_enabled |= CPU_FPU; return; }
#line 2588 "x86id.c"
yy95:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy103;
	if(yych == 's')	goto yy103;
	goto yy24;
yy96:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy97;
	if(yych != 't')	goto yy24;
yy97:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy98;
	if(yych != 'e')	goto yy24;
yy98:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy99;
	if(yych != 'r')	goto yy24;
yy99:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy100;
	if(yych != 'o')	goto yy24;
yy100:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy101;
	if(yych != 'n')	goto yy24;
yy101:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2206 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_186|CPU_286|CPU_386|CPU_486|CPU_586|CPU_686|
			  CPU_K6|CPU_Athlon|CPU_Hammer|CPU_FPU|CPU_MMX|CPU_SSE|
			  CPU_3DNow|CPU_SMM|CPU_Prot|CPU_Priv;
	    return;
	}
#line 2618 "x86id.c"
yy103:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2236 "./modules/arch/x86/x86id.re"
{ cpu_enabled |= CPU_Obs; return; }
#line 2624 "x86id.c"
yy105:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy106;
	if(yych != 'm')	goto yy24;
yy106:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy107;
	if(yych != 'm')	goto yy24;
yy107:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy108;
	if(yych != 'e')	goto yy24;
yy108:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy101;
	if(yych == 'r')	goto yy101;
	goto yy24;
yy109:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy118;
	if(yych == 'e')	goto yy118;
	goto yy24;
yy110:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy116;
	if(yych == 'm')	goto yy116;
	goto yy24;
yy111:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy112;
	if(yych != 'e')	goto yy24;
yy112:	yych = *++YYCURSOR;
	if(yych <= '\000')	goto yy113;
	if(yych == '2')	goto yy114;
	goto yy23;
yy113:
#line 2220 "./modules/arch/x86/x86id.re"
{ cpu_enabled |= CPU_SSE; return; }
#line 2656 "x86id.c"
yy114:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2222 "./modules/arch/x86/x86id.re"
{ cpu_enabled |= CPU_SSE2; return; }
#line 2662 "x86id.c"
yy116:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2230 "./modules/arch/x86/x86id.re"
{ cpu_enabled |= CPU_SMM; return; }
#line 2668 "x86id.c"
yy118:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy119;
	if(yych != 'd')	goto yy24;
yy119:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy120;
	if(yych != 'g')	goto yy24;
yy120:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy121;
	if(yych != 'e')	goto yy24;
yy121:	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy16;
	if(yych == 'h')	goto yy16;
	goto yy24;
yy122:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy131;
	if(yych == 'd')	goto yy131;
	goto yy24;
yy123:	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy124;
	if(yych != 'h')	goto yy24;
yy124:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy125;
	if(yych != 'l')	goto yy24;
yy125:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy126;
	if(yych != 'o')	goto yy24;
yy126:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy127;
	if(yych != 'n')	goto yy24;
yy127:	yych = *++YYCURSOR;
	if(yych <= '-'){
		if(yych <= '\000')	goto yy128;
		if(yych <= ',')	goto yy23;
		goto yy129;
	} else {
		if(yych == '6')	goto yy130;
		goto yy23;
	}
yy128:
#line 2199 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_186|CPU_286|CPU_386|CPU_486|CPU_586|CPU_686|
			  CPU_K6|CPU_Athlon|CPU_FPU|CPU_MMX|CPU_SSE|CPU_3DNow|
			  CPU_SMM|CPU_Prot|CPU_Priv;
	    return;
	}
#line 2715 "x86id.c"
yy129:	yych = *++YYCURSOR;
	if(yych != '6')	goto yy24;
yy130:	yych = *++YYCURSOR;
	if(yych == '4')	goto yy101;
	goto yy24;
yy131:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2228 "./modules/arch/x86/x86id.re"
{ cpu_enabled |= CPU_AMD; return; }
#line 2726 "x86id.c"
yy133:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy134;
	if(yych != 'l')	goto yy24;
yy134:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy135;
	if(yych != 'l')	goto yy24;
yy135:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy136;
	if(yych != 'i')	goto yy24;
yy136:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy137;
	if(yych != 'a')	goto yy24;
yy137:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy138;
	if(yych != 'm')	goto yy24;
yy138:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy139;
	if(yych != 'e')	goto yy24;
yy139:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy140;
	if(yych != 't')	goto yy24;
yy140:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy141;
	if(yych != 't')	goto yy24;
yy141:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy142;
	if(yych != 'e')	goto yy24;
yy142:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2181 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_186|CPU_286|CPU_386|CPU_486|CPU_586|CPU_686|
			  CPU_P3|CPU_P4|CPU_FPU|CPU_MMX|CPU_SSE|CPU_SSE2|
			  CPU_SMM|CPU_Prot|CPU_Priv;
	    return;
	}
#line 2764 "x86id.c"
yy144:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2193 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_186|CPU_286|CPU_386|CPU_486|CPU_586|CPU_686|
			  CPU_K6|CPU_FPU|CPU_MMX|CPU_3DNow|CPU_SMM|CPU_Prot|
			  CPU_Priv;
	    return;
	}
#line 2775 "x86id.c"
yy146:	yych = *++YYCURSOR;
	if(yych <= '\000')	goto yy128;
	goto yy23;
yy147:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy148;
	if(yych != 't')	goto yy24;
yy148:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy149;
	if(yych != 'm')	goto yy24;
yy149:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy150;
	if(yych != 'a')	goto yy24;
yy150:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy151;
	if(yych != 'i')	goto yy24;
yy151:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2175 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_186|CPU_286|CPU_386|CPU_486|CPU_586|CPU_686|
			  CPU_P3|CPU_FPU|CPU_MMX|CPU_SSE|CPU_SMM|CPU_Prot|
			  CPU_Priv;
	    return;
	}
#line 2801 "x86id.c"
yy153:	yych = *++YYCURSOR;
	if(yych != '6')	goto yy24;
yy154:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2165 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_186|CPU_286|CPU_386|CPU_486|CPU_586|CPU_686|
			  CPU_FPU|CPU_SMM|CPU_Prot|CPU_Priv;
	    return;
	}
#line 2813 "x86id.c"
yy156:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;
yy157:
#line 2170 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_186|CPU_286|CPU_386|CPU_486|CPU_586|CPU_686|
			  CPU_FPU|CPU_MMX|CPU_SMM|CPU_Prot|CPU_Priv;
	    return;
	}
#line 2823 "x86id.c"
yy158:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;
yy159:
#line 2160 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_186|CPU_286|CPU_386|CPU_486|CPU_586|CPU_FPU|
			  CPU_SMM|CPU_Prot|CPU_Priv;
	    return;
	}
#line 2833 "x86id.c"
yy160:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy170;
	if(yych == 'n')	goto yy170;
	goto yy24;
yy161:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy169;
	if(yych == 'r')	goto yy169;
	goto yy24;
yy162:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych == 'I')	goto yy164;
		if(yych <= 'N')	goto yy24;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy24;
			goto yy164;
		} else {
			if(yych != 'o')	goto yy24;
		}
	}
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy167;
	if(yych == 't')	goto yy167;
	goto yy24;
yy164:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy165;
	if(yych != 'v')	goto yy24;
yy165:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2238 "./modules/arch/x86/x86id.re"
{ cpu_enabled |= CPU_Priv; return; }
#line 2866 "x86id.c"
yy167:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2232 "./modules/arch/x86/x86id.re"
{ cpu_enabled |= CPU_Prot; return; }
#line 2872 "x86id.c"
yy169:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy154;
	if(yych == 'o')	goto yy154;
	goto yy24;
yy170:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy171;
	if(yych != 't')	goto yy24;
yy171:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy172;
	if(yych != 'i')	goto yy24;
yy172:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy173;
	if(yych != 'u')	goto yy24;
yy173:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy174;
	if(yych != 'm')	goto yy24;
yy174:	yych = *++YYCURSOR;
	if(yych <= 'H'){
		if(yych <= '1'){
			if(yych <= '\000')	goto yy159;
			if(yych != '-')	goto yy23;
		} else {
			if(yych <= '2')	goto yy156;
			if(yych <= '3')	goto yy151;
			if(yych <= '4')	goto yy142;
			goto yy23;
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'I')	goto yy176;
			if(yych == 'P')	goto yy177;
			goto yy23;
		} else {
			if(yych <= 'i')	goto yy176;
			if(yych == 'p')	goto yy177;
			goto yy23;
		}
	}
	yych = *++YYCURSOR;
	if(yych <= '4'){
		if(yych <= '1')	goto yy24;
		if(yych <= '2')	goto yy156;
		if(yych <= '3')	goto yy151;
		goto yy142;
	} else {
		if(yych <= 'I'){
			if(yych <= 'H')	goto yy24;
		} else {
			if(yych != 'i')	goto yy24;
		}
	}
yy176:	yych = *++YYCURSOR;
	if(yych <= 'V'){
		if(yych == 'I')	goto yy179;
		if(yych <= 'U')	goto yy24;
		goto yy142;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy24;
			goto yy179;
		} else {
			if(yych == 'v')	goto yy142;
			goto yy24;
		}
	}
yy177:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy178;
	if(yych != 'r')	goto yy24;
yy178:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy154;
	if(yych == 'o')	goto yy154;
	goto yy24;
yy179:	yych = *++YYCURSOR;
	if(yych <= 'I'){
		if(yych <= '\000')	goto yy157;
		if(yych <= 'H')	goto yy23;
		goto yy151;
	} else {
		if(yych == 'i')	goto yy151;
		goto yy23;
	}
yy180:	yych = *++YYCURSOR;
	if(yych == '6')	goto yy158;
	goto yy24;
yy181:	yych = *++YYCURSOR;
	if(yych != '6')	goto yy24;
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2155 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_186|CPU_286|CPU_386|CPU_486|CPU_FPU|CPU_SMM|
			  CPU_Prot|CPU_Priv;
	    return;
	}
#line 2968 "x86id.c"
yy184:	yych = *++YYCURSOR;
	if(yych == '6')	goto yy190;
	goto yy24;
yy185:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy186;
	if(yych != 'n')	goto yy24;
yy186:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy187;
	if(yych != 'o')	goto yy24;
yy187:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy188;
	if(yych != 'w')	goto yy24;
yy188:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2224 "./modules/arch/x86/x86id.re"
{ cpu_enabled |= CPU_3DNow; return; }
#line 2986 "x86id.c"
yy190:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2151 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_186|CPU_286|CPU_386|CPU_SMM|CPU_Prot|CPU_Priv;
	    return;
	}
#line 2995 "x86id.c"
yy192:	yych = *++YYCURSOR;
	if(yych != '6')	goto yy24;
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2147 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_186|CPU_286|CPU_Priv;
	    return;
	}
#line 3006 "x86id.c"
yy195:	yych = *++YYCURSOR;
	if(yych != '6')	goto yy24;
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2143 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_186|CPU_Priv;
	    return;
	}
#line 3017 "x86id.c"
yy198:	yych = *++YYCURSOR;
	if(yych == '8')	goto yy184;
	goto yy24;
yy199:	yych = *++YYCURSOR;
	if(yych == '-')	goto yy207;
	if(yych == '6')	goto yy208;
	goto yy24;
yy200:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy201;
	if(yych != 'a')	goto yy24;
yy201:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy202;
	if(yych != 'n')	goto yy24;
yy202:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy203;
	if(yych != 'i')	goto yy24;
yy203:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy204;
	if(yych != 'u')	goto yy24;
yy204:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy205;
	if(yych != 'm')	goto yy24;
yy205:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2187 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_186|CPU_286|CPU_386|CPU_486|CPU_586|CPU_686|
			  CPU_P3|CPU_P4|CPU_IA64|CPU_FPU|CPU_MMX|CPU_SSE|
			  CPU_SSE2|CPU_SMM|CPU_Prot|CPU_Priv;
	    return;
	}
#line 3050 "x86id.c"
yy207:	yych = *++YYCURSOR;
	if(yych != '6')	goto yy24;
yy208:	yych = *++YYCURSOR;
	if(yych == '4')	goto yy205;
	goto yy24;
yy209:	yych = *++YYCURSOR;
	if(yych <= '3'){
		if(yych <= '0')	goto yy24;
		if(yych <= '1')	goto yy5;
		if(yych <= '2')	goto yy6;
		goto yy198;
	} else {
		if(yych <= '4')	goto yy8;
		if(yych != '8')	goto yy24;
	}
	yych = *++YYCURSOR;
	if(yych != '6')	goto yy24;
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy23;

#line 2139 "./modules/arch/x86/x86id.re"
{
	    cpu_enabled = CPU_Priv;
	    return;
	}
#line 3076 "x86id.c"
}
#line 2252 "./modules/arch/x86/x86id.re"

}

yasm_arch_check_id_retval
yasm_x86__check_identifier(unsigned long data[4], const char *id,
			   unsigned long lindex)
{
    const char *oid = id;
    /*const char *marker;*/
    
#line 3089 "x86id.c"
{
	YYCTYPE yych;

	goto yy213;
	++YYCURSOR;
yy213:
	if((YYLIMIT - YYCURSOR) < 12) YYFILL(12);
	yych = *YYCURSOR;
	switch(yych){
	case '\000':	goto yy240;
	case 'A':	case 'a':	goto yy221;
	case 'B':	case 'b':	goto yy229;
	case 'C':	case 'c':	goto yy224;
	case 'D':	case 'd':	goto yy225;
	case 'E':	case 'e':	goto yy228;
	case 'F':	case 'f':	goto yy218;
	case 'G':	case 'g':	goto yy230;
	case 'H':	case 'h':	goto yy234;
	case 'I':	case 'i':	goto yy232;
	case 'J':	case 'j':	goto yy233;
	case 'L':	case 'l':	goto yy222;
	case 'M':	case 'm':	goto yy226;
	case 'N':	case 'n':	goto yy215;
	case 'O':	case 'o':	goto yy220;
	case 'P':	case 'p':	goto yy231;
	case 'R':	case 'r':	goto yy223;
	case 'S':	case 's':	goto yy217;
	case 'T':	case 't':	goto yy219;
	case 'U':	case 'u':	goto yy237;
	case 'V':	case 'v':	goto yy235;
	case 'W':	case 'w':	goto yy236;
	case 'X':	case 'x':	goto yy227;
	default:	goto yy238;
	}
yy215:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych == 'E')	goto yy2339;
		if(yych <= 'N')	goto yy239;
		goto yy2340;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy239;
			goto yy2339;
		} else {
			if(yych == 'o')	goto yy2340;
			goto yy239;
		}
	}
yy216:
#line 3561 "./modules/arch/x86/x86id.re"
{
	    return YASM_ARCH_CHECK_ID_NONE;
	}
#line 3143 "x86id.c"
yy217:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy2101;
	case 'B':	case 'b':	goto yy2102;
	case 'C':	case 'c':	goto yy2103;
	case 'E':	case 'e':	goto yy2104;
	case 'F':	case 'f':	goto yy2105;
	case 'G':	case 'g':	goto yy2106;
	case 'H':	case 'h':	goto yy2107;
	case 'I':	case 'i':	goto yy2108;
	case 'L':	case 'l':	goto yy2110;
	case 'M':	case 'm':	goto yy2111;
	case 'P':	case 'p':	goto yy2112;
	case 'Q':	case 'q':	goto yy2114;
	case 'S':	case 's':	goto yy2115;
	case 'T':	case 't':	goto yy2117;
	case 'U':	case 'u':	goto yy2118;
	case 'V':	case 'v':	goto yy2119;
	case 'W':	case 'w':	goto yy2120;
	case 'Y':	case 'y':	goto yy2121;
	default:	goto yy239;
	}
yy218:	yych = *++YYCURSOR;
	switch(yych){
	case '2':	goto yy1770;
	case 'A':	case 'a':	goto yy1771;
	case 'B':	case 'b':	goto yy1772;
	case 'C':	case 'c':	goto yy1773;
	case 'D':	case 'd':	goto yy1774;
	case 'E':	case 'e':	goto yy1775;
	case 'F':	case 'f':	goto yy1776;
	case 'I':	case 'i':	goto yy1777;
	case 'L':	case 'l':	goto yy1778;
	case 'M':	case 'm':	goto yy1779;
	case 'N':	case 'n':	goto yy1780;
	case 'P':	case 'p':	goto yy1781;
	case 'R':	case 'r':	goto yy1782;
	case 'S':	case 's':	goto yy1783;
	case 'T':	case 't':	goto yy1785;
	case 'U':	case 'u':	goto yy1786;
	case 'W':	case 'w':	goto yy1787;
	case 'X':	case 'x':	goto yy1788;
	case 'Y':	case 'y':	goto yy1789;
	default:	goto yy239;
	}
yy219:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= 'N'){
			if(yych == 'E')	goto yy1761;
			goto yy239;
		} else {
			if(yych <= 'O')	goto yy1762;
			if(yych <= 'Q')	goto yy239;
			goto yy1764;
		}
	} else {
		if(yych <= 'n'){
			if(yych == 'e')	goto yy1761;
			goto yy239;
		} else {
			if(yych <= 'o')	goto yy1762;
			if(yych == 'r')	goto yy1764;
			goto yy239;
		}
	}
yy220:	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych <= '2'){
			if(yych == '1')	goto yy1735;
			goto yy239;
		} else {
			if(yych <= '3')	goto yy1736;
			if(yych == '6')	goto yy1737;
			goto yy239;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= 'R')	goto yy1738;
			if(yych == 'U')	goto yy1740;
			goto yy239;
		} else {
			if(yych <= 'r')	goto yy1738;
			if(yych == 'u')	goto yy1740;
			goto yy239;
		}
	}
yy221:	yych = *++YYCURSOR;
	switch(yych){
	case '1':	goto yy1678;
	case '3':	goto yy1679;
	case '6':	goto yy1680;
	case 'A':	case 'a':	goto yy1681;
	case 'D':	case 'd':	goto yy1682;
	case 'H':	case 'h':	goto yy1683;
	case 'L':	case 'l':	goto yy1685;
	case 'N':	case 'n':	goto yy1687;
	case 'R':	case 'r':	goto yy1688;
	case 'X':	case 'x':	goto yy1689;
	default:	goto yy239;
	}
yy222:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy1585;
	case 'D':	case 'd':	goto yy1586;
	case 'E':	case 'e':	goto yy1587;
	case 'F':	case 'f':	goto yy1588;
	case 'G':	case 'g':	goto yy1589;
	case 'I':	case 'i':	goto yy1590;
	case 'L':	case 'l':	goto yy1591;
	case 'M':	case 'm':	goto yy1592;
	case 'O':	case 'o':	goto yy1593;
	case 'S':	case 's':	goto yy1594;
	case 'T':	case 't':	goto yy1595;
	default:	goto yy239;
	}
yy223:	yych = *++YYCURSOR;
	switch(yych){
	case '1':	goto yy1473;
	case '8':
	case '9':	goto yy1474;
	case 'A':	case 'a':	goto yy1476;
	case 'B':	case 'b':	goto yy1477;
	case 'C':	case 'c':	goto yy1478;
	case 'D':	case 'd':	goto yy1479;
	case 'E':	case 'e':	goto yy1480;
	case 'I':	case 'i':	goto yy1481;
	case 'O':	case 'o':	goto yy1482;
	case 'S':	case 's':	goto yy1483;
	default:	goto yy239;
	}
yy224:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy1131;
	case 'B':	case 'b':	goto yy1132;
	case 'D':	case 'd':	goto yy1133;
	case 'H':	case 'h':	goto yy1134;
	case 'L':	case 'l':	goto yy1136;
	case 'M':	case 'm':	goto yy1138;
	case 'O':	case 'o':	goto yy1139;
	case 'P':	case 'p':	goto yy1140;
	case 'R':	case 'r':	goto yy1141;
	case 'S':	case 's':	goto yy1142;
	case 'V':	case 'v':	goto yy1144;
	case 'W':	case 'w':	goto yy1145;
	case 'X':	case 'x':	goto yy1146;
	default:	goto yy239;
	}
yy225:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy1096;
	case 'E':	case 'e':	goto yy1097;
	case 'H':	case 'h':	goto yy1098;
	case 'I':	case 'i':	goto yy1100;
	case 'L':	case 'l':	goto yy1102;
	case 'R':	case 'r':	goto yy1104;
	case 'S':	case 's':	goto yy1105;
	case 'X':	case 'x':	goto yy1107;
	default:	goto yy239;
	}
yy226:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy948;
	case 'F':	case 'f':	goto yy949;
	case 'I':	case 'i':	goto yy950;
	case 'M':	case 'm':	goto yy951;
	case 'O':	case 'o':	goto yy952;
	case 'U':	case 'u':	goto yy953;
	default:	goto yy239;
	}
yy227:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy916;
	case 'B':	case 'b':	goto yy917;
	case 'C':	case 'c':	goto yy918;
	case 'L':	case 'l':	goto yy919;
	case 'M':	case 'm':	goto yy920;
	case 'O':	case 'o':	goto yy921;
	default:	goto yy239;
	}
yy228:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy885;
	case 'B':	case 'b':	goto yy886;
	case 'C':	case 'c':	goto yy887;
	case 'D':	case 'd':	goto yy888;
	case 'M':	case 'm':	goto yy889;
	case 'N':	case 'n':	goto yy890;
	case 'S':	case 's':	goto yy891;
	default:	goto yy239;
	}
yy229:	yych = *++YYCURSOR;
	switch(yych){
	case 'H':	case 'h':	goto yy853;
	case 'L':	case 'l':	goto yy855;
	case 'O':	case 'o':	goto yy857;
	case 'P':	case 'p':	goto yy858;
	case 'S':	case 's':	goto yy860;
	case 'T':	case 't':	goto yy861;
	case 'X':	case 'x':	goto yy863;
	default:	goto yy239;
	}
yy230:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy851;
	if(yych == 's')	goto yy851;
	goto yy239;
yy231:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy429;
	case 'D':	case 'd':	goto yy430;
	case 'E':	case 'e':	goto yy431;
	case 'F':	case 'f':	goto yy432;
	case 'I':	case 'i':	goto yy433;
	case 'M':	case 'm':	goto yy434;
	case 'O':	case 'o':	goto yy435;
	case 'R':	case 'r':	goto yy436;
	case 'S':	case 's':	goto yy437;
	case 'U':	case 'u':	goto yy438;
	case 'X':	case 'x':	goto yy439;
	default:	goto yy239;
	}
yy232:	yych = *++YYCURSOR;
	switch(yych){
	case 'B':	case 'b':	goto yy380;
	case 'D':	case 'd':	goto yy381;
	case 'M':	case 'm':	goto yy382;
	case 'N':	case 'n':	goto yy383;
	case 'R':	case 'r':	goto yy385;
	default:	goto yy239;
	}
yy233:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy304;
	case 'B':	case 'b':	goto yy306;
	case 'C':	case 'c':	goto yy308;
	case 'E':	case 'e':	goto yy310;
	case 'G':	case 'g':	goto yy312;
	case 'L':	case 'l':	goto yy314;
	case 'M':	case 'm':	goto yy316;
	case 'N':	case 'n':	goto yy317;
	case 'O':	case 'o':	goto yy318;
	case 'P':	case 'p':	goto yy320;
	case 'R':	case 'r':	goto yy322;
	case 'S':	case 's':	goto yy323;
	case 'Z':	case 'z':	goto yy325;
	default:	goto yy239;
	}
yy234:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy301;
	if(yych == 'l')	goto yy301;
	goto yy239;
yy235:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy295;
	if(yych == 'e')	goto yy295;
	goto yy239;
yy236:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= 'A'){
			if(yych <= '@')	goto yy239;
			goto yy276;
		} else {
			if(yych <= 'B')	goto yy277;
			if(yych <= 'Q')	goto yy239;
			goto yy278;
		}
	} else {
		if(yych <= 'b'){
			if(yych <= '`')	goto yy239;
			if(yych <= 'a')	goto yy276;
			goto yy277;
		} else {
			if(yych == 'r')	goto yy278;
			goto yy239;
		}
	}
yy237:	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= 'D'){
			if(yych <= 'B')	goto yy239;
			if(yych <= 'C')	goto yy242;
			goto yy243;
		} else {
			if(yych <= 'L')	goto yy239;
			if(yych <= 'M')	goto yy244;
			goto yy245;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'b')	goto yy239;
			if(yych <= 'c')	goto yy242;
			goto yy243;
		} else {
			if(yych <= 'l')	goto yy239;
			if(yych <= 'm')	goto yy244;
			if(yych <= 'n')	goto yy245;
			goto yy239;
		}
	}
yy238:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy239:	if(yych <= '\000')	goto yy216;
	goto yy238;
yy240:	yych = *++YYCURSOR;

#line 3564 "./modules/arch/x86/x86id.re"
{
	    return YASM_ARCH_CHECK_ID_NONE;
	}
#line 3452 "x86id.c"
yy242:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy268;
	if(yych == 'o')	goto yy268;
	goto yy239;
yy243:	yych = *++YYCURSOR;
	if(yych <= '0')	goto yy239;
	if(yych <= '1')	goto yy266;
	if(yych <= '2')	goto yy264;
	goto yy239;
yy244:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy261;
	if(yych == 'o')	goto yy261;
	goto yy239;
yy245:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy246;
	if(yych != 'p')	goto yy239;
yy246:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy247;
	if(yych != 'c')	goto yy239;
yy247:	yych = *++YYCURSOR;
	if(yych == 'K')	goto yy248;
	if(yych != 'k')	goto yy239;
yy248:	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych == 'H')	goto yy249;
		if(yych <= 'K')	goto yy239;
		goto yy250;
	} else {
		if(yych <= 'h'){
			if(yych <= 'g')	goto yy239;
		} else {
			if(yych == 'l')	goto yy250;
			goto yy239;
		}
	}
yy249:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy256;
	if(yych == 'p')	goto yy256;
	goto yy239;
yy250:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy251;
	if(yych != 'p')	goto yy239;
yy251:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy252;
		if(yych <= 'R')	goto yy239;
		goto yy254;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy254;
			goto yy239;
		}
	}
yy252:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3449 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x6614, CPU_SSE2); }
#line 3513 "x86id.c"
yy254:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3397 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x14, CPU_SSE); }
#line 3519 "x86id.c"
yy256:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy257;
		if(yych <= 'R')	goto yy239;
		goto yy259;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy259;
			goto yy239;
		}
	}
yy257:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3448 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x6615, CPU_SSE2); }
#line 3538 "x86id.c"
yy259:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3396 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x15, CPU_SSE); }
#line 3544 "x86id.c"
yy261:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy262;
	if(yych != 'v')	goto yy239;
yy262:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3556 "./modules/arch/x86/x86id.re"
{ RET_INSN(umov, 0, CPU_386|CPU_Undoc); }
#line 3553 "x86id.c"
yy264:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3217 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F0B, CPU_286); }
#line 3559 "x86id.c"
yy266:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3218 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0FB9, CPU_286|CPU_Undoc); }
#line 3565 "x86id.c"
yy268:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy269;
	if(yych != 'm')	goto yy239;
yy269:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy270;
	if(yych != 'i')	goto yy239;
yy270:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy271;
	if(yych != 's')	goto yy239;
yy271:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy274;
		if(yych <= 'R')	goto yy239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy274;
		} else {
			if(yych != 's')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3395 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF32E, CPU_SSE); }
#line 3592 "x86id.c"
yy274:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3447 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF22E, CPU_SSE2); }
#line 3598 "x86id.c"
yy276:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy292;
	if(yych == 'i')	goto yy292;
	goto yy239;
yy277:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy287;
	if(yych == 'i')	goto yy287;
	goto yy239;
yy278:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'M')	goto yy279;
		if(yych <= 'R')	goto yy239;
		goto yy280;
	} else {
		if(yych <= 'm'){
			if(yych <= 'l')	goto yy239;
		} else {
			if(yych == 's')	goto yy280;
			goto yy239;
		}
	}
yy279:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy284;
	if(yych == 's')	goto yy284;
	goto yy239;
yy280:	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy281;
	if(yych != 'h')	goto yy239;
yy281:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy282;
	if(yych != 'r')	goto yy239;
yy282:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3542 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F37, CPU_686|CPU_Cyrix|CPU_SMM); }
#line 3635 "x86id.c"
yy284:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy285;
	if(yych != 'r')	goto yy239;
yy285:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3195 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F30, CPU_586|CPU_Priv); }
#line 3644 "x86id.c"
yy287:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy288;
	if(yych != 'n')	goto yy239;
yy288:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy289;
	if(yych != 'v')	goto yy239;
yy289:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy290;
	if(yych != 'd')	goto yy239;
yy290:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3190 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F09, CPU_486|CPU_Priv); }
#line 3659 "x86id.c"
yy292:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy293;
	if(yych != 't')	goto yy239;
yy293:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3183 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x009B, CPU_Any); }
#line 3668 "x86id.c"
yy295:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy296;
	if(yych != 'r')	goto yy239;
yy296:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych == 'R')	goto yy297;
		if(yych <= 'V')	goto yy239;
		goto yy299;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy239;
		} else {
			if(yych == 'w')	goto yy299;
			goto yy239;
		}
	}
yy297:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3098 "./modules/arch/x86/x86id.re"
{ RET_INSN(prot286, 0x0400, CPU_286|CPU_Prot); }
#line 3690 "x86id.c"
yy299:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3099 "./modules/arch/x86/x86id.re"
{ RET_INSN(prot286, 0x0500, CPU_286|CPU_Prot); }
#line 3696 "x86id.c"
yy301:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy302;
	if(yych != 't')	goto yy239;
yy302:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3076 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00F4, CPU_Priv); }
#line 3705 "x86id.c"
yy304:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy305;
		if(yych <= 'D')	goto yy238;
		goto yy378;
	} else {
		if(yych == 'e')	goto yy378;
		goto yy238;
	}
yy305:
#line 2907 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x07, CPU_Any); }
#line 3718 "x86id.c"
yy306:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy307;
		if(yych <= 'D')	goto yy238;
		goto yy376;
	} else {
		if(yych == 'e')	goto yy376;
		goto yy238;
	}
yy307:
#line 2894 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x02, CPU_Any); }
#line 3731 "x86id.c"
yy308:	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych <= '\000')	goto yy309;
		if(yych <= 'W')	goto yy238;
		goto yy373;
	} else {
		if(yych == 'x')	goto yy373;
		goto yy238;
	}
yy309:
#line 2895 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x02, CPU_Any); }
#line 3744 "x86id.c"
yy310:	yych = *++YYCURSOR;
	if(yych <= 'C'){
		if(yych <= '\000')	goto yy311;
		if(yych <= 'B')	goto yy238;
		goto yy369;
	} else {
		if(yych == 'c')	goto yy369;
		goto yy238;
	}
yy311:
#line 2900 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x04, CPU_Any); }
#line 3757 "x86id.c"
yy312:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy313;
		if(yych <= 'D')	goto yy238;
		goto yy367;
	} else {
		if(yych == 'e')	goto yy367;
		goto yy238;
	}
yy313:
#line 2921 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x0F, CPU_Any); }
#line 3770 "x86id.c"
yy314:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy315;
		if(yych <= 'D')	goto yy238;
		goto yy365;
	} else {
		if(yych == 'e')	goto yy365;
		goto yy238;
	}
yy315:
#line 2914 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x0C, CPU_Any); }
#line 3783 "x86id.c"
yy316:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy363;
	if(yych == 'p')	goto yy363;
	goto yy239;
yy317:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy337;
	case 'B':	case 'b':	goto yy339;
	case 'C':	case 'c':	goto yy341;
	case 'E':	case 'e':	goto yy343;
	case 'G':	case 'g':	goto yy351;
	case 'L':	case 'l':	goto yy353;
	case 'O':	case 'o':	goto yy335;
	case 'P':	case 'p':	goto yy349;
	case 'S':	case 's':	goto yy347;
	case 'Z':	case 'z':	goto yy345;
	default:	goto yy239;
	}
yy318:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2892 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x00, CPU_Any); }
#line 3807 "x86id.c"
yy320:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= 'D'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'E')	goto yy331;
			if(yych <= 'N')	goto yy238;
			goto yy333;
		}
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy238;
			goto yy331;
		} else {
			if(yych == 'o')	goto yy333;
			goto yy238;
		}
	}

#line 2910 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x0A, CPU_Any); }
#line 3829 "x86id.c"
yy322:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy327;
	if(yych == 'c')	goto yy327;
	goto yy239;
yy323:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2908 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x08, CPU_Any); }
#line 3839 "x86id.c"
yy325:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2901 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x04, CPU_Any); }
#line 3845 "x86id.c"
yy327:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy328;
	if(yych != 'x')	goto yy239;
yy328:	yych = *++YYCURSOR;
	if(yych == 'Z')	goto yy329;
	if(yych != 'z')	goto yy239;
yy329:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2924 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is an instruction in 64-bit mode"),
			      oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    RET_INSN(jcxz, 64, CPU_Hammer|CPU_64);
	}
#line 3865 "x86id.c"
yy331:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2911 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x0A, CPU_Any); }
#line 3871 "x86id.c"
yy333:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2913 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x0B, CPU_Any); }
#line 3877 "x86id.c"
yy335:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2893 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x01, CPU_Any); }
#line 3883 "x86id.c"
yy337:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy338;
		if(yych <= 'D')	goto yy238;
		goto yy361;
	} else {
		if(yych == 'e')	goto yy361;
		goto yy238;
	}
yy338:
#line 2905 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x06, CPU_Any); }
#line 3896 "x86id.c"
yy339:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy340;
		if(yych <= 'D')	goto yy238;
		goto yy359;
	} else {
		if(yych == 'e')	goto yy359;
		goto yy238;
	}
yy340:
#line 2897 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x03, CPU_Any); }
#line 3909 "x86id.c"
yy341:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2898 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x03, CPU_Any); }
#line 3915 "x86id.c"
yy343:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2902 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x05, CPU_Any); }
#line 3921 "x86id.c"
yy345:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2903 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x05, CPU_Any); }
#line 3927 "x86id.c"
yy347:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2909 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x09, CPU_Any); }
#line 3933 "x86id.c"
yy349:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2912 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x0B, CPU_Any); }
#line 3939 "x86id.c"
yy351:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy352;
		if(yych <= 'D')	goto yy238;
		goto yy357;
	} else {
		if(yych == 'e')	goto yy357;
		goto yy238;
	}
yy352:
#line 2919 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x0E, CPU_Any); }
#line 3952 "x86id.c"
yy353:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy354;
		if(yych <= 'D')	goto yy238;
		goto yy355;
	} else {
		if(yych == 'e')	goto yy355;
		goto yy238;
	}
yy354:
#line 2916 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x0D, CPU_Any); }
#line 3965 "x86id.c"
yy355:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2920 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x0F, CPU_Any); }
#line 3971 "x86id.c"
yy357:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2915 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x0C, CPU_Any); }
#line 3977 "x86id.c"
yy359:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2906 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x07, CPU_Any); }
#line 3983 "x86id.c"
yy361:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2896 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x02, CPU_Any); }
#line 3989 "x86id.c"
yy363:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2885 "./modules/arch/x86/x86id.re"
{ RET_INSN(jmp, 0, CPU_Any); }
#line 3995 "x86id.c"
yy365:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2918 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x0E, CPU_Any); }
#line 4001 "x86id.c"
yy367:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2917 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x0D, CPU_Any); }
#line 4007 "x86id.c"
yy369:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy370;
	if(yych != 'x')	goto yy239;
yy370:	yych = *++YYCURSOR;
	if(yych == 'Z')	goto yy371;
	if(yych != 'z')	goto yy239;
yy371:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2923 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcxz, 32, CPU_386); }
#line 4019 "x86id.c"
yy373:	yych = *++YYCURSOR;
	if(yych == 'Z')	goto yy374;
	if(yych != 'z')	goto yy239;
yy374:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2922 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcxz, 16, CPU_Any); }
#line 4028 "x86id.c"
yy376:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2904 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x06, CPU_Any); }
#line 4034 "x86id.c"
yy378:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2899 "./modules/arch/x86/x86id.re"
{ RET_INSN(jcc, 0x03, CPU_Any); }
#line 4040 "x86id.c"
yy380:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy426;
	if(yych == 't')	goto yy426;
	goto yy239;
yy381:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy423;
	if(yych == 'i')	goto yy423;
	goto yy239;
yy382:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy420;
	if(yych == 'u')	goto yy420;
	goto yy239;
yy383:	yych = *++YYCURSOR;
	if(yych <= 'V'){
		if(yych <= 'R'){
			if(yych <= '\000')	goto yy384;
			if(yych == 'C')	goto yy395;
			goto yy238;
		} else {
			if(yych <= 'S')	goto yy397;
			if(yych <= 'T')	goto yy398;
			if(yych <= 'U')	goto yy238;
			goto yy400;
		}
	} else {
		if(yych <= 's'){
			if(yych == 'c')	goto yy395;
			if(yych <= 'r')	goto yy238;
			goto yy397;
		} else {
			if(yych <= 't')	goto yy398;
			if(yych == 'v')	goto yy400;
			goto yy238;
		}
	}
yy384:
#line 2719 "./modules/arch/x86/x86id.re"
{ RET_INSN(in, 0, CPU_Any); }
#line 4079 "x86id.c"
yy385:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy386;
	if(yych != 'e')	goto yy239;
yy386:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy387;
	if(yych != 't')	goto yy239;
yy387:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'D'){
			if(yych <= '\000')	goto yy388;
			if(yych <= 'C')	goto yy238;
			goto yy391;
		} else {
			if(yych == 'Q')	goto yy393;
			if(yych <= 'V')	goto yy238;
			goto yy389;
		}
	} else {
		if(yych <= 'p'){
			if(yych == 'd')	goto yy391;
			goto yy238;
		} else {
			if(yych <= 'q')	goto yy393;
			if(yych == 'w')	goto yy389;
			goto yy238;
		}
	}
yy388:
#line 3056 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00CF, CPU_Any); }
#line 4110 "x86id.c"
yy389:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3057 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x10CF, CPU_Any); }
#line 4116 "x86id.c"
yy391:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3058 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x20CF, CPU_386); }
#line 4122 "x86id.c"
yy393:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3059 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is an instruction in 64-bit mode"),
			      oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    RET_INSN(onebyte, 0x40CF, CPU_Hammer|CPU_64);
	}
#line 4136 "x86id.c"
yy395:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2790 "./modules/arch/x86/x86id.re"
{ RET_INSN(incdec, 0x0040, CPU_Any); }
#line 4142 "x86id.c"
yy397:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'C'){
			if(yych == 'B')	goto yy414;
			goto yy239;
		} else {
			if(yych <= 'D')	goto yy416;
			if(yych <= 'V')	goto yy239;
			goto yy418;
		}
	} else {
		if(yych <= 'c'){
			if(yych == 'b')	goto yy414;
			goto yy239;
		} else {
			if(yych <= 'd')	goto yy416;
			if(yych == 'w')	goto yy418;
			goto yy239;
		}
	}
yy398:	yych = *++YYCURSOR;
	if(yych <= '3'){
		if(yych <= '/'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= '0')	goto yy407;
			if(yych <= '2')	goto yy238;
			goto yy408;
		}
	} else {
		if(yych <= 'O'){
			if(yych <= 'N')	goto yy238;
			goto yy410;
		} else {
			if(yych == 'o')	goto yy410;
			goto yy238;
		}
	}

#line 3046 "./modules/arch/x86/x86id.re"
{ RET_INSN(int, 0, CPU_Any); }
#line 4184 "x86id.c"
yy400:	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych == 'D')	goto yy401;
		if(yych <= 'K')	goto yy239;
		goto yy403;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 'l')	goto yy403;
			goto yy239;
		}
	}
yy401:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3189 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F08, CPU_486|CPU_Priv); }
#line 4203 "x86id.c"
yy403:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy404;
	if(yych != 'p')	goto yy239;
yy404:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy405;
	if(yych != 'g')	goto yy239;
yy405:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3191 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x070F01, CPU_486|CPU_Priv); }
#line 4215 "x86id.c"
yy407:	yych = *++YYCURSOR;
	if(yych == '3')	goto yy412;
	goto yy239;
yy408:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3047 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00CC, CPU_Any); }
#line 4224 "x86id.c"
yy410:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3049 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(onebyte, 0x00CE, CPU_Any);
	}
#line 4236 "x86id.c"
yy412:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3048 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00CC, CPU_Any); }
#line 4242 "x86id.c"
yy414:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2983 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x006C, CPU_Any); }
#line 4248 "x86id.c"
yy416:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2985 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x206D, CPU_386); }
#line 4254 "x86id.c"
yy418:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2984 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x106D, CPU_Any); }
#line 4260 "x86id.c"
yy420:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy421;
	if(yych != 'l')	goto yy239;
yy421:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2869 "./modules/arch/x86/x86id.re"
{ RET_INSN(imul, 0, CPU_Any); }
#line 4269 "x86id.c"
yy423:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy424;
	if(yych != 'v')	goto yy239;
yy424:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2871 "./modules/arch/x86/x86id.re"
{ RET_INSN(f6, 0x07, CPU_Any); }
#line 4278 "x86id.c"
yy426:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy427;
	if(yych != 's')	goto yy239;
yy427:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3545 "./modules/arch/x86/x86id.re"
{ RET_INSN(ibts, 0, CPU_386|CPU_Undoc|CPU_Obs); }
#line 4287 "x86id.c"
yy429:	yych = *++YYCURSOR;
	if(yych <= 'V'){
		if(yych <= 'M'){
			if(yych <= 'B')	goto yy239;
			if(yych <= 'C')	goto yy773;
			if(yych <= 'D')	goto yy774;
			goto yy239;
		} else {
			if(yych <= 'N')	goto yy775;
			if(yych <= 'T')	goto yy239;
			if(yych <= 'U')	goto yy772;
			goto yy776;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'b')	goto yy239;
			if(yych <= 'c')	goto yy773;
			if(yych <= 'd')	goto yy774;
			goto yy239;
		} else {
			if(yych <= 't'){
				if(yych <= 'n')	goto yy775;
				goto yy239;
			} else {
				if(yych <= 'u')	goto yy772;
				if(yych <= 'v')	goto yy776;
				goto yy239;
			}
		}
	}
yy430:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy766;
	if(yych == 'i')	goto yy766;
	goto yy239;
yy431:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy761;
	if(yych == 'x')	goto yy761;
	goto yy239;
yy432:	yych = *++YYCURSOR;
	switch(yych){
	case '2':	goto yy691;
	case 'A':	case 'a':	goto yy692;
	case 'C':	case 'c':	goto yy693;
	case 'M':	case 'm':	goto yy694;
	case 'N':	case 'n':	goto yy695;
	case 'P':	case 'p':	goto yy696;
	case 'R':	case 'r':	goto yy697;
	case 'S':	case 's':	goto yy698;
	default:	goto yy239;
	}
yy433:	yych = *++YYCURSOR;
	if(yych <= 'M'){
		if(yych == '2')	goto yy681;
		goto yy239;
	} else {
		if(yych <= 'N')	goto yy680;
		if(yych == 'n')	goto yy680;
		goto yy239;
	}
yy434:	yych = *++YYCURSOR;
	if(yych <= 'V'){
		if(yych <= 'I'){
			if(yych == 'A')	goto yy602;
			if(yych <= 'H')	goto yy239;
			goto yy604;
		} else {
			if(yych <= 'O'){
				if(yych <= 'N')	goto yy239;
				goto yy605;
			} else {
				if(yych <= 'T')	goto yy239;
				if(yych <= 'U')	goto yy603;
				goto yy606;
			}
		}
	} else {
		if(yych <= 'n'){
			if(yych <= 'a'){
				if(yych <= '`')	goto yy239;
				goto yy602;
			} else {
				if(yych == 'i')	goto yy604;
				goto yy239;
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'o')	goto yy605;
				goto yy239;
			} else {
				if(yych <= 'u')	goto yy603;
				if(yych <= 'v')	goto yy606;
				goto yy239;
			}
		}
	}
yy435:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych == 'P')	goto yy584;
		if(yych <= 'Q')	goto yy239;
		goto yy586;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
			goto yy584;
		} else {
			if(yych == 'r')	goto yy586;
			goto yy239;
		}
	}
yy436:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy564;
	if(yych == 'e')	goto yy564;
	goto yy239;
yy437:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy495;
	case 'H':	case 'h':	goto yy496;
	case 'L':	case 'l':	goto yy492;
	case 'R':	case 'r':	goto yy493;
	case 'U':	case 'u':	goto yy494;
	case 'W':	case 'w':	goto yy497;
	default:	goto yy239;
	}
yy438:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'N')	goto yy444;
		if(yych <= 'R')	goto yy239;
		goto yy443;
	} else {
		if(yych <= 'n'){
			if(yych <= 'm')	goto yy239;
			goto yy444;
		} else {
			if(yych == 's')	goto yy443;
			goto yy239;
		}
	}
yy439:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy440;
	if(yych != 'o')	goto yy239;
yy440:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy441;
	if(yych != 'r')	goto yy239;
yy441:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3316 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xEF, CPU_MMX); }
#line 4436 "x86id.c"
yy443:	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy476;
	if(yych == 'h')	goto yy476;
	goto yy239;
yy444:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy445;
	if(yych != 'p')	goto yy239;
yy445:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy446;
	if(yych != 'c')	goto yy239;
yy446:	yych = *++YYCURSOR;
	if(yych == 'K')	goto yy447;
	if(yych != 'k')	goto yy239;
yy447:	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych == 'H')	goto yy448;
		if(yych <= 'K')	goto yy239;
		goto yy449;
	} else {
		if(yych <= 'h'){
			if(yych <= 'g')	goto yy239;
		} else {
			if(yych == 'l')	goto yy449;
			goto yy239;
		}
	}
yy448:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'D'){
			if(yych == 'B')	goto yy463;
			if(yych <= 'C')	goto yy239;
			goto yy464;
		} else {
			if(yych == 'Q')	goto yy465;
			if(yych <= 'V')	goto yy239;
			goto yy466;
		}
	} else {
		if(yych <= 'd'){
			if(yych == 'b')	goto yy463;
			if(yych <= 'c')	goto yy239;
			goto yy464;
		} else {
			if(yych <= 'q'){
				if(yych <= 'p')	goto yy239;
				goto yy465;
			} else {
				if(yych == 'w')	goto yy466;
				goto yy239;
			}
		}
	}
yy449:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'D'){
			if(yych == 'B')	goto yy450;
			if(yych <= 'C')	goto yy239;
			goto yy451;
		} else {
			if(yych == 'Q')	goto yy452;
			if(yych <= 'V')	goto yy239;
			goto yy453;
		}
	} else {
		if(yych <= 'd'){
			if(yych == 'b')	goto yy450;
			if(yych <= 'c')	goto yy239;
			goto yy451;
		} else {
			if(yych <= 'q'){
				if(yych <= 'p')	goto yy239;
				goto yy452;
			} else {
				if(yych == 'w')	goto yy453;
				goto yy239;
			}
		}
	}
yy450:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy461;
	if(yych == 'w')	goto yy461;
	goto yy239;
yy451:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy459;
	if(yych == 'q')	goto yy459;
	goto yy239;
yy452:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy456;
	if(yych == 'd')	goto yy456;
	goto yy239;
yy453:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy454;
	if(yych != 'd')	goto yy239;
yy454:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3314 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x61, CPU_MMX); }
#line 4535 "x86id.c"
yy456:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy457;
	if(yych != 'q')	goto yy239;
yy457:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3477 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x666C, CPU_SSE2); }
#line 4544 "x86id.c"
yy459:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3315 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x62, CPU_MMX); }
#line 4550 "x86id.c"
yy461:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3313 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x60, CPU_MMX); }
#line 4556 "x86id.c"
yy463:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy474;
	if(yych == 'w')	goto yy474;
	goto yy239;
yy464:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy472;
	if(yych == 'q')	goto yy472;
	goto yy239;
yy465:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy469;
	if(yych == 'd')	goto yy469;
	goto yy239;
yy466:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy467;
	if(yych != 'd')	goto yy239;
yy467:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3311 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x69, CPU_MMX); }
#line 4577 "x86id.c"
yy469:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy470;
	if(yych != 'q')	goto yy239;
yy470:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3476 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x666D, CPU_SSE2); }
#line 4586 "x86id.c"
yy472:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3312 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x6A, CPU_MMX); }
#line 4592 "x86id.c"
yy474:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3310 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x68, CPU_MMX); }
#line 4598 "x86id.c"
yy476:	yych = *++YYCURSOR;
	if(yych <= 'F'){
		if(yych <= '@'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'A')	goto yy478;
			if(yych <= 'E')	goto yy238;
			goto yy480;
		}
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy238;
			goto yy478;
		} else {
			if(yych == 'f')	goto yy480;
			goto yy238;
		}
	}

#line 2671 "./modules/arch/x86/x86id.re"
{ RET_INSN(push, 0, CPU_Any); }
#line 4620 "x86id.c"
yy478:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'C'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'D')	goto yy488;
			if(yych <= 'V')	goto yy238;
			goto yy490;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy238;
			goto yy488;
		} else {
			if(yych == 'w')	goto yy490;
			goto yy238;
		}
	}

#line 2672 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(onebyte, 0x0060, CPU_186);
	}
#line 4648 "x86id.c"
yy480:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'D'){
			if(yych <= '\000')	goto yy481;
			if(yych <= 'C')	goto yy238;
			goto yy482;
		} else {
			if(yych == 'Q')	goto yy484;
			if(yych <= 'V')	goto yy238;
			goto yy486;
		}
	} else {
		if(yych <= 'p'){
			if(yych == 'd')	goto yy482;
			goto yy238;
		} else {
			if(yych <= 'q')	goto yy484;
			if(yych == 'w')	goto yy486;
			goto yy238;
		}
	}
yy481:
#line 2761 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x009C, CPU_Any); }
#line 4673 "x86id.c"
yy482:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2762 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x209C, CPU_386); }
#line 4679 "x86id.c"
yy484:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2764 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is an instruction in 64-bit mode"),
			      oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    RET_INSN(onebyte, 0x409C, CPU_Hammer|CPU_64);
	}
#line 4693 "x86id.c"
yy486:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2763 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x109C, CPU_Any); }
#line 4699 "x86id.c"
yy488:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2679 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(onebyte, 0x2060, CPU_386);
	}
#line 4711 "x86id.c"
yy490:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2686 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(onebyte, 0x1060, CPU_186);
	}
#line 4723 "x86id.c"
yy492:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy555;
	if(yych == 'l')	goto yy555;
	goto yy239;
yy493:	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych == 'A')	goto yy541;
		if(yych <= 'K')	goto yy239;
		goto yy542;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy239;
			goto yy541;
		} else {
			if(yych == 'l')	goto yy542;
			goto yy239;
		}
	}
yy494:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy518;
	if(yych == 'b')	goto yy518;
	goto yy239;
yy495:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy514;
	if(yych == 'd')	goto yy514;
	goto yy239;
yy496:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy502;
	if(yych == 'u')	goto yy502;
	goto yy239;
yy497:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy498;
	if(yych != 'a')	goto yy239;
yy498:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy499;
	if(yych != 'p')	goto yy239;
yy499:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy500;
	if(yych != 'd')	goto yy239;
yy500:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3505 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0xBB, CPU_Athlon|CPU_3DNow); }
#line 4768 "x86id.c"
yy502:	yych = *++YYCURSOR;
	if(yych == 'F')	goto yy503;
	if(yych != 'f')	goto yy239;
yy503:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'H'){
			if(yych == 'D')	goto yy504;
			if(yych <= 'G')	goto yy239;
			goto yy506;
		} else {
			if(yych == 'L')	goto yy507;
			if(yych <= 'V')	goto yy239;
			goto yy508;
		}
	} else {
		if(yych <= 'h'){
			if(yych == 'd')	goto yy504;
			if(yych <= 'g')	goto yy239;
			goto yy506;
		} else {
			if(yych <= 'l'){
				if(yych <= 'k')	goto yy239;
				goto yy507;
			} else {
				if(yych == 'w')	goto yy508;
				goto yy239;
			}
		}
	}
yy504:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3471 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssessimm, 0x6670, CPU_SSE2); }
#line 4803 "x86id.c"
yy506:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy512;
	if(yych == 'w')	goto yy512;
	goto yy239;
yy507:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy510;
	if(yych == 'w')	goto yy510;
	goto yy239;
yy508:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3383 "./modules/arch/x86/x86id.re"
{ RET_INSN(pshufw, 0, CPU_P3|CPU_MMX); }
#line 4817 "x86id.c"
yy510:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3473 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssessimm, 0xF270, CPU_SSE2); }
#line 4823 "x86id.c"
yy512:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3472 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssessimm, 0xF370, CPU_SSE2); }
#line 4829 "x86id.c"
yy514:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy515;
	if(yych != 'b')	goto yy239;
yy515:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy516;
	if(yych != 'w')	goto yy239;
yy516:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3382 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xF6, CPU_P3|CPU_MMX); }
#line 4841 "x86id.c"
yy518:	yych = *++YYCURSOR;
	switch(yych){
	case 'B':	case 'b':	goto yy519;
	case 'D':	case 'd':	goto yy523;
	case 'Q':	case 'q':	goto yy525;
	case 'S':	case 's':	goto yy527;
	case 'U':	case 'u':	goto yy528;
	case 'W':	case 'w':	goto yy521;
	default:	goto yy239;
	}
yy519:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3302 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xF8, CPU_MMX); }
#line 4857 "x86id.c"
yy521:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3303 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xF9, CPU_MMX); }
#line 4863 "x86id.c"
yy523:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3304 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xFA, CPU_MMX); }
#line 4869 "x86id.c"
yy525:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3305 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xFB, CPU_MMX); }
#line 4875 "x86id.c"
yy527:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'H'){
			if(yych == 'B')	goto yy534;
			goto yy239;
		} else {
			if(yych <= 'I')	goto yy536;
			if(yych <= 'V')	goto yy239;
			goto yy537;
		}
	} else {
		if(yych <= 'h'){
			if(yych == 'b')	goto yy534;
			goto yy239;
		} else {
			if(yych <= 'i')	goto yy536;
			if(yych == 'w')	goto yy537;
			goto yy239;
		}
	}
yy528:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy529;
	if(yych != 's')	goto yy239;
yy529:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych == 'B')	goto yy530;
		if(yych <= 'V')	goto yy239;
		goto yy532;
	} else {
		if(yych <= 'b'){
			if(yych <= 'a')	goto yy239;
		} else {
			if(yych == 'w')	goto yy532;
			goto yy239;
		}
	}
yy530:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3308 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xD8, CPU_MMX); }
#line 4917 "x86id.c"
yy532:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3309 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xD9, CPU_MMX); }
#line 4923 "x86id.c"
yy534:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3306 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xE8, CPU_MMX); }
#line 4929 "x86id.c"
yy536:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy539;
	if(yych == 'w')	goto yy539;
	goto yy239;
yy537:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3307 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xE9, CPU_MMX); }
#line 4939 "x86id.c"
yy539:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3531 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixmmx, 0x55, CPU_Cyrix|CPU_MMX); }
#line 4945 "x86id.c"
yy541:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych == 'D')	goto yy553;
		if(yych <= 'V')	goto yy239;
		goto yy551;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy553;
		} else {
			if(yych == 'w')	goto yy551;
			goto yy239;
		}
	}
yy542:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'P'){
			if(yych == 'D')	goto yy545;
			goto yy239;
		} else {
			if(yych <= 'Q')	goto yy547;
			if(yych <= 'V')	goto yy239;
		}
	} else {
		if(yych <= 'p'){
			if(yych == 'd')	goto yy545;
			goto yy239;
		} else {
			if(yych <= 'q')	goto yy547;
			if(yych != 'w')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3299 "./modules/arch/x86/x86id.re"
{ RET_INSN(pshift, 0x0271D1, CPU_MMX); }
#line 4983 "x86id.c"
yy545:	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych <= '\000')	goto yy546;
		if(yych <= 'P')	goto yy238;
		goto yy549;
	} else {
		if(yych == 'q')	goto yy549;
		goto yy238;
	}
yy546:
#line 3300 "./modules/arch/x86/x86id.re"
{ RET_INSN(pshift, 0x0272D2, CPU_MMX); }
#line 4996 "x86id.c"
yy547:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3301 "./modules/arch/x86/x86id.re"
{ RET_INSN(pshift, 0x0273D3, CPU_MMX); }
#line 5002 "x86id.c"
yy549:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3475 "./modules/arch/x86/x86id.re"
{ RET_INSN(pslrldq, 0x03, CPU_SSE2); }
#line 5008 "x86id.c"
yy551:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3297 "./modules/arch/x86/x86id.re"
{ RET_INSN(pshift, 0x0471E1, CPU_MMX); }
#line 5014 "x86id.c"
yy553:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3298 "./modules/arch/x86/x86id.re"
{ RET_INSN(pshift, 0x0472E2, CPU_MMX); }
#line 5020 "x86id.c"
yy555:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'P'){
			if(yych == 'D')	goto yy558;
			goto yy239;
		} else {
			if(yych <= 'Q')	goto yy560;
			if(yych <= 'V')	goto yy239;
		}
	} else {
		if(yych <= 'p'){
			if(yych == 'd')	goto yy558;
			goto yy239;
		} else {
			if(yych <= 'q')	goto yy560;
			if(yych != 'w')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3294 "./modules/arch/x86/x86id.re"
{ RET_INSN(pshift, 0x0671F1, CPU_MMX); }
#line 5044 "x86id.c"
yy558:	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych <= '\000')	goto yy559;
		if(yych <= 'P')	goto yy238;
		goto yy562;
	} else {
		if(yych == 'q')	goto yy562;
		goto yy238;
	}
yy559:
#line 3295 "./modules/arch/x86/x86id.re"
{ RET_INSN(pshift, 0x0672F2, CPU_MMX); }
#line 5057 "x86id.c"
yy560:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3296 "./modules/arch/x86/x86id.re"
{ RET_INSN(pshift, 0x0673F3, CPU_MMX); }
#line 5063 "x86id.c"
yy562:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3474 "./modules/arch/x86/x86id.re"
{ RET_INSN(pslrldq, 0x07, CPU_SSE2); }
#line 5069 "x86id.c"
yy564:	yych = *++YYCURSOR;
	if(yych == 'F')	goto yy565;
	if(yych != 'f')	goto yy239;
yy565:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy566;
	if(yych != 'e')	goto yy239;
yy566:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy567;
	if(yych != 't')	goto yy239;
yy567:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy568;
	if(yych != 'c')	goto yy239;
yy568:	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy569;
	if(yych != 'h')	goto yy239;
yy569:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'N'){
			if(yych <= '\000')	goto yy570;
			if(yych <= 'M')	goto yy238;
			goto yy571;
		} else {
			if(yych == 'T')	goto yy572;
			if(yych <= 'V')	goto yy238;
			goto yy573;
		}
	} else {
		if(yych <= 's'){
			if(yych == 'n')	goto yy571;
			goto yy238;
		} else {
			if(yych <= 't')	goto yy572;
			if(yych == 'w')	goto yy573;
			goto yy238;
		}
	}
yy570:
#line 3479 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x000F0D, CPU_3DNow); }
#line 5109 "x86id.c"
yy571:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy581;
	if(yych == 't')	goto yy581;
	goto yy239;
yy572:	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy239;
	if(yych <= '0')	goto yy575;
	if(yych <= '1')	goto yy577;
	if(yych <= '2')	goto yy579;
	goto yy239;
yy573:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3480 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x010F0D, CPU_3DNow); }
#line 5125 "x86id.c"
yy575:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3379 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x010F18, CPU_P3); }
#line 5131 "x86id.c"
yy577:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3380 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x020F18, CPU_P3); }
#line 5137 "x86id.c"
yy579:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3381 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x030F18, CPU_P3); }
#line 5143 "x86id.c"
yy581:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy582;
	if(yych != 'a')	goto yy239;
yy582:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3378 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x000F18, CPU_P3); }
#line 5152 "x86id.c"
yy584:	yych = *++YYCURSOR;
	if(yych <= 'F'){
		if(yych <= '@'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'A')	goto yy588;
			if(yych <= 'E')	goto yy238;
			goto yy590;
		}
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy238;
			goto yy588;
		} else {
			if(yych == 'f')	goto yy590;
			goto yy238;
		}
	}

#line 2694 "./modules/arch/x86/x86id.re"
{ RET_INSN(pop, 0, CPU_Any); }
#line 5174 "x86id.c"
yy586:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3293 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xEB, CPU_MMX); }
#line 5180 "x86id.c"
yy588:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'C'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'D')	goto yy598;
			if(yych <= 'V')	goto yy238;
			goto yy600;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy238;
			goto yy598;
		} else {
			if(yych == 'w')	goto yy600;
			goto yy238;
		}
	}

#line 2695 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(onebyte, 0x0061, CPU_186);
	}
#line 5208 "x86id.c"
yy590:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'D'){
			if(yych <= '\000')	goto yy591;
			if(yych <= 'C')	goto yy238;
			goto yy592;
		} else {
			if(yych == 'Q')	goto yy596;
			if(yych <= 'V')	goto yy238;
			goto yy594;
		}
	} else {
		if(yych <= 'p'){
			if(yych == 'd')	goto yy592;
			goto yy238;
		} else {
			if(yych <= 'q')	goto yy596;
			if(yych == 'w')	goto yy594;
			goto yy238;
		}
	}
yy591:
#line 2773 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x009D, CPU_Any); }
#line 5233 "x86id.c"
yy592:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2774 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x209D, CPU_386); }
#line 5239 "x86id.c"
yy594:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2775 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x109D, CPU_Any); }
#line 5245 "x86id.c"
yy596:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2776 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is an instruction in 64-bit mode"),
			      oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    RET_INSN(onebyte, 0x409D, CPU_Hammer|CPU_64);
	}
#line 5259 "x86id.c"
yy598:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2702 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(onebyte, 0x2061, CPU_386);
	}
#line 5271 "x86id.c"
yy600:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2709 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(onebyte, 0x1061, CPU_186);
	}
#line 5283 "x86id.c"
yy602:	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych <= 'D'){
			if(yych <= 'B')	goto yy239;
			if(yych <= 'C')	goto yy659;
			goto yy660;
		} else {
			if(yych == 'G')	goto yy661;
			if(yych <= 'W')	goto yy239;
			goto yy662;
		}
	} else {
		if(yych <= 'f'){
			if(yych <= 'b')	goto yy239;
			if(yych <= 'c')	goto yy659;
			if(yych <= 'd')	goto yy660;
			goto yy239;
		} else {
			if(yych <= 'g')	goto yy661;
			if(yych == 'x')	goto yy662;
			goto yy239;
		}
	}
yy603:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy636;
	if(yych == 'l')	goto yy636;
	goto yy239;
yy604:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy629;
	if(yych == 'n')	goto yy629;
	goto yy239;
yy605:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy623;
	if(yych == 'v')	goto yy623;
	goto yy239;
yy606:	yych = *++YYCURSOR;
	if(yych <= 'Z'){
		if(yych <= 'L'){
			if(yych == 'G')	goto yy607;
			if(yych <= 'K')	goto yy239;
			goto yy608;
		} else {
			if(yych == 'N')	goto yy609;
			if(yych <= 'Y')	goto yy239;
			goto yy610;
		}
	} else {
		if(yych <= 'l'){
			if(yych == 'g')	goto yy607;
			if(yych <= 'k')	goto yy239;
			goto yy608;
		} else {
			if(yych <= 'n'){
				if(yych <= 'm')	goto yy239;
				goto yy609;
			} else {
				if(yych == 'z')	goto yy610;
				goto yy239;
			}
		}
	}
yy607:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy619;
	if(yych == 'e')	goto yy619;
	goto yy239;
yy608:	yych = *++YYCURSOR;
	if(yych == 'Z')	goto yy616;
	if(yych == 'z')	goto yy616;
	goto yy239;
yy609:	yych = *++YYCURSOR;
	if(yych == 'Z')	goto yy613;
	if(yych == 'z')	goto yy613;
	goto yy239;
yy610:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy611;
	if(yych != 'b')	goto yy239;
yy611:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3530 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixmmx, 0x58, CPU_Cyrix|CPU_MMX); }
#line 5365 "x86id.c"
yy613:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy614;
	if(yych != 'b')	goto yy239;
yy614:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3529 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixmmx, 0x5A, CPU_Cyrix|CPU_MMX); }
#line 5374 "x86id.c"
yy616:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy617;
	if(yych != 'b')	goto yy239;
yy617:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3528 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixmmx, 0x5B, CPU_Cyrix|CPU_MMX); }
#line 5383 "x86id.c"
yy619:	yych = *++YYCURSOR;
	if(yych == 'Z')	goto yy620;
	if(yych != 'z')	goto yy239;
yy620:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy621;
	if(yych != 'b')	goto yy239;
yy621:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3527 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixmmx, 0x5C, CPU_Cyrix|CPU_MMX); }
#line 5395 "x86id.c"
yy623:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy624;
	if(yych != 'm')	goto yy239;
yy624:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy625;
	if(yych != 's')	goto yy239;
yy625:	yych = *++YYCURSOR;
	if(yych == 'K')	goto yy626;
	if(yych != 'k')	goto yy239;
yy626:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy627;
	if(yych != 'b')	goto yy239;
yy627:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3376 "./modules/arch/x86/x86id.re"
{ RET_INSN(pmovmskb, 0, CPU_SSE); }
#line 5413 "x86id.c"
yy629:	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'S')	goto yy630;
		if(yych <= 'T')	goto yy239;
		goto yy631;
	} else {
		if(yych <= 's'){
			if(yych <= 'r')	goto yy239;
		} else {
			if(yych == 'u')	goto yy631;
			goto yy239;
		}
	}
yy630:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy634;
	if(yych == 'w')	goto yy634;
	goto yy239;
yy631:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy632;
	if(yych != 'b')	goto yy239;
yy632:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3375 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xDA, CPU_P3|CPU_MMX); }
#line 5439 "x86id.c"
yy634:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3374 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xEA, CPU_P3|CPU_MMX); }
#line 5445 "x86id.c"
yy636:	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'K'){
			if(yych != 'H')	goto yy239;
		} else {
			if(yych <= 'L')	goto yy638;
			if(yych <= 'T')	goto yy239;
			goto yy639;
		}
	} else {
		if(yych <= 'k'){
			if(yych != 'h')	goto yy239;
		} else {
			if(yych <= 'l')	goto yy638;
			if(yych == 'u')	goto yy639;
			goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'T'){
			if(yych == 'R')	goto yy645;
			goto yy239;
		} else {
			if(yych <= 'U')	goto yy646;
			if(yych <= 'V')	goto yy239;
			goto yy647;
		}
	} else {
		if(yych <= 't'){
			if(yych == 'r')	goto yy645;
			goto yy239;
		} else {
			if(yych <= 'u')	goto yy646;
			if(yych == 'w')	goto yy647;
			goto yy239;
		}
	}
yy638:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy643;
	if(yych == 'w')	goto yy643;
	goto yy239;
yy639:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy640;
	if(yych != 'd')	goto yy239;
yy640:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy641;
	if(yych != 'q')	goto yy239;
yy641:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3470 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xF4, CPU_SSE2); }
#line 5499 "x86id.c"
yy643:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3292 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xD5, CPU_MMX); }
#line 5505 "x86id.c"
yy645:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych == 'I')	goto yy652;
		if(yych <= 'V')	goto yy239;
		goto yy651;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy239;
			goto yy652;
		} else {
			if(yych == 'w')	goto yy651;
			goto yy239;
		}
	}
yy646:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy649;
	if(yych == 'w')	goto yy649;
	goto yy239;
yy647:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3291 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xE5, CPU_MMX); }
#line 5529 "x86id.c"
yy649:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3377 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xE4, CPU_P3|CPU_MMX); }
#line 5535 "x86id.c"
yy651:	yych = *++YYCURSOR;
	if(yych <= 'C'){
		if(yych == 'A')	goto yy655;
		if(yych <= 'B')	goto yy239;
		goto yy657;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy239;
			goto yy655;
		} else {
			if(yych == 'c')	goto yy657;
			goto yy239;
		}
	}
yy652:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy653;
	if(yych != 'w')	goto yy239;
yy653:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3525 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixmmx, 0x5D, CPU_Cyrix|CPU_MMX); }
#line 5558 "x86id.c"
yy655:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3504 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0xB7, CPU_3DNow); }
#line 5564 "x86id.c"
yy657:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3526 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixmmx, 0x59, CPU_Cyrix|CPU_MMX); }
#line 5570 "x86id.c"
yy659:	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy675;
	if(yych == 'h')	goto yy675;
	goto yy239;
yy660:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy671;
	if(yych == 'd')	goto yy671;
	goto yy239;
yy661:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy669;
	if(yych == 'w')	goto yy669;
	goto yy239;
yy662:	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'S')	goto yy663;
		if(yych <= 'T')	goto yy239;
		goto yy664;
	} else {
		if(yych <= 's'){
			if(yych <= 'r')	goto yy239;
		} else {
			if(yych == 'u')	goto yy664;
			goto yy239;
		}
	}
yy663:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy667;
	if(yych == 'w')	goto yy667;
	goto yy239;
yy664:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy665;
	if(yych != 'b')	goto yy239;
yy665:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3373 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xDE, CPU_P3|CPU_MMX); }
#line 5608 "x86id.c"
yy667:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3372 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xEE, CPU_P3|CPU_MMX); }
#line 5614 "x86id.c"
yy669:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3524 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixmmx, 0x52, CPU_Cyrix|CPU_MMX); }
#line 5620 "x86id.c"
yy671:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy672;
	if(yych != 'w')	goto yy239;
yy672:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy673;
	if(yych != 'd')	goto yy239;
yy673:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3290 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xF5, CPU_MMX); }
#line 5632 "x86id.c"
yy675:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy676;
	if(yych != 'r')	goto yy239;
yy676:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy677;
	if(yych != 'i')	goto yy239;
yy677:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy678;
	if(yych != 'w')	goto yy239;
yy678:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3523 "./modules/arch/x86/x86id.re"
{ RET_INSN(pmachriw, 0, CPU_Cyrix|CPU_MMX); }
#line 5647 "x86id.c"
yy680:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy687;
	if(yych == 's')	goto yy687;
	goto yy239;
yy681:	yych = *++YYCURSOR;
	if(yych == 'F')	goto yy682;
	if(yych != 'f')	goto yy239;
yy682:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych == 'D')	goto yy683;
		if(yych <= 'V')	goto yy239;
		goto yy685;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 'w')	goto yy685;
			goto yy239;
		}
	}
yy683:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3502 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0x0D, CPU_3DNow); }
#line 5673 "x86id.c"
yy685:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3503 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0x0C, CPU_Athlon|CPU_3DNow); }
#line 5679 "x86id.c"
yy687:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy688;
	if(yych != 'r')	goto yy239;
yy688:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy689;
	if(yych != 'w')	goto yy239;
yy689:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3371 "./modules/arch/x86/x86id.re"
{ RET_INSN(pinsrw, 0, CPU_P3|CPU_MMX); }
#line 5691 "x86id.c"
yy691:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy756;
	if(yych == 'i')	goto yy756;
	goto yy239;
yy692:	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= 'B')	goto yy239;
		if(yych <= 'C')	goto yy750;
		goto yy751;
	} else {
		if(yych <= 'b')	goto yy239;
		if(yych <= 'c')	goto yy750;
		if(yych <= 'd')	goto yy751;
		goto yy239;
	}
yy693:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy740;
	if(yych == 'm')	goto yy740;
	goto yy239;
yy694:	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'H'){
			if(yych == 'A')	goto yy731;
			goto yy239;
		} else {
			if(yych <= 'I')	goto yy732;
			if(yych <= 'T')	goto yy239;
			goto yy733;
		}
	} else {
		if(yych <= 'h'){
			if(yych == 'a')	goto yy731;
			goto yy239;
		} else {
			if(yych <= 'i')	goto yy732;
			if(yych == 'u')	goto yy733;
			goto yy239;
		}
	}
yy695:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy727;
	if(yych == 'a')	goto yy727;
	goto yy239;
yy696:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy722;
	if(yych == 'n')	goto yy722;
	goto yy239;
yy697:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'C')	goto yy704;
		if(yych <= 'R')	goto yy239;
		goto yy705;
	} else {
		if(yych <= 'c'){
			if(yych <= 'b')	goto yy239;
			goto yy704;
		} else {
			if(yych == 's')	goto yy705;
			goto yy239;
		}
	}
yy698:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy699;
	if(yych != 'u')	goto yy239;
yy699:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy700;
	if(yych != 'b')	goto yy239;
yy700:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= '\000')	goto yy701;
		if(yych <= 'Q')	goto yy238;
		goto yy702;
	} else {
		if(yych == 'r')	goto yy702;
		goto yy238;
	}
yy701:
#line 3500 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0x9A, CPU_3DNow); }
#line 5771 "x86id.c"
yy702:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3501 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0xAA, CPU_3DNow); }
#line 5777 "x86id.c"
yy704:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy714;
	if(yych == 'p')	goto yy714;
	goto yy239;
yy705:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy706;
	if(yych != 'q')	goto yy239;
yy706:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych == 'I')	goto yy707;
		if(yych <= 'Q')	goto yy239;
		goto yy708;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy239;
		} else {
			if(yych == 'r')	goto yy708;
			goto yy239;
		}
	}
yy707:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy711;
	if(yych == 't')	goto yy711;
	goto yy239;
yy708:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy709;
	if(yych != 't')	goto yy239;
yy709:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3499 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0x97, CPU_3DNow); }
#line 5810 "x86id.c"
yy711:	yych = *++YYCURSOR;
	if(yych != '1')	goto yy239;
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3498 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0xA7, CPU_3DNow); }
#line 5818 "x86id.c"
yy714:	yych = *++YYCURSOR;
	if(yych <= 'I'){
		if(yych <= '\000')	goto yy715;
		if(yych <= 'H')	goto yy238;
		goto yy716;
	} else {
		if(yych == 'i')	goto yy716;
		goto yy238;
	}
yy715:
#line 3495 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0x96, CPU_3DNow); }
#line 5831 "x86id.c"
yy716:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy717;
	if(yych != 't')	goto yy239;
yy717:	yych = *++YYCURSOR;
	if(yych <= '0')	goto yy239;
	if(yych <= '1')	goto yy718;
	if(yych <= '2')	goto yy720;
	goto yy239;
yy718:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3496 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0xA6, CPU_3DNow); }
#line 5845 "x86id.c"
yy720:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3497 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0xB6, CPU_3DNow); }
#line 5851 "x86id.c"
yy722:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy723;
	if(yych != 'a')	goto yy239;
yy723:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy724;
	if(yych != 'c')	goto yy239;
yy724:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy725;
	if(yych != 'c')	goto yy239;
yy725:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3494 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0x8E, CPU_Athlon|CPU_3DNow); }
#line 5866 "x86id.c"
yy727:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy728;
	if(yych != 'c')	goto yy239;
yy728:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy729;
	if(yych != 'c')	goto yy239;
yy729:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3493 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0x8A, CPU_Athlon|CPU_3DNow); }
#line 5878 "x86id.c"
yy731:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy738;
	if(yych == 'x')	goto yy738;
	goto yy239;
yy732:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy736;
	if(yych == 'n')	goto yy736;
	goto yy239;
yy733:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy734;
	if(yych != 'l')	goto yy239;
yy734:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3492 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0xB4, CPU_3DNow); }
#line 5895 "x86id.c"
yy736:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3491 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0x94, CPU_3DNow); }
#line 5901 "x86id.c"
yy738:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3490 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0xA4, CPU_3DNow); }
#line 5907 "x86id.c"
yy740:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy741;
	if(yych != 'p')	goto yy239;
yy741:	yych = *++YYCURSOR;
	if(yych <= 'G'){
		if(yych == 'E')	goto yy742;
		if(yych <= 'F')	goto yy239;
		goto yy743;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy239;
		} else {
			if(yych == 'g')	goto yy743;
			goto yy239;
		}
	}
yy742:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy748;
	if(yych == 'q')	goto yy748;
	goto yy239;
yy743:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych == 'E')	goto yy744;
		if(yych <= 'S')	goto yy239;
		goto yy746;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy239;
		} else {
			if(yych == 't')	goto yy746;
			goto yy239;
		}
	}
yy744:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3488 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0x90, CPU_3DNow); }
#line 5946 "x86id.c"
yy746:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3489 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0xA0, CPU_3DNow); }
#line 5952 "x86id.c"
yy748:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3487 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0xB0, CPU_3DNow); }
#line 5958 "x86id.c"
yy750:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy754;
	if(yych == 'c')	goto yy754;
	goto yy239;
yy751:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy752;
	if(yych != 'd')	goto yy239;
yy752:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3486 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0x9E, CPU_3DNow); }
#line 5971 "x86id.c"
yy754:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3485 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0xAE, CPU_3DNow); }
#line 5977 "x86id.c"
yy756:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych == 'D')	goto yy757;
		if(yych <= 'V')	goto yy239;
		goto yy759;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 'w')	goto yy759;
			goto yy239;
		}
	}
yy757:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3483 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0x1D, CPU_3DNow); }
#line 5996 "x86id.c"
yy759:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3484 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0x1C, CPU_Athlon|CPU_3DNow); }
#line 6002 "x86id.c"
yy761:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy762;
	if(yych != 't')	goto yy239;
yy762:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy763;
	if(yych != 'r')	goto yy239;
yy763:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy764;
	if(yych != 'w')	goto yy239;
yy764:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3370 "./modules/arch/x86/x86id.re"
{ RET_INSN(pextrw, 0, CPU_P3|CPU_MMX); }
#line 6017 "x86id.c"
yy766:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy767;
	if(yych != 's')	goto yy239;
yy767:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy768;
	if(yych != 't')	goto yy239;
yy768:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy769;
	if(yych != 'i')	goto yy239;
yy769:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy770;
	if(yych != 'b')	goto yy239;
yy770:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3522 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixmmx, 0x54, CPU_Cyrix|CPU_MMX); }
#line 6035 "x86id.c"
yy772:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy848;
	if(yych == 's')	goto yy848;
	goto yy239;
yy773:	yych = *++YYCURSOR;
	if(yych <= 'M'){
		if(yych == 'K')	goto yy816;
		if(yych <= 'L')	goto yy239;
		goto yy817;
	} else {
		if(yych <= 'k'){
			if(yych <= 'j')	goto yy239;
			goto yy816;
		} else {
			if(yych == 'm')	goto yy817;
			goto yy239;
		}
	}
yy774:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy793;
	if(yych == 'd')	goto yy793;
	goto yy239;
yy775:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy789;
	if(yych == 'd')	goto yy789;
	goto yy239;
yy776:	yych = *++YYCURSOR;
	if(yych <= 'G'){
		if(yych == 'E')	goto yy777;
		if(yych <= 'F')	goto yy239;
		goto yy778;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy239;
		} else {
			if(yych == 'g')	goto yy778;
			goto yy239;
		}
	}
yy777:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy787;
	if(yych == 'b')	goto yy787;
	goto yy239;
yy778:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'T'){
			if(yych != 'B')	goto yy239;
		} else {
			if(yych <= 'U')	goto yy783;
			if(yych <= 'V')	goto yy239;
			goto yy781;
		}
	} else {
		if(yych <= 't'){
			if(yych != 'b')	goto yy239;
		} else {
			if(yych <= 'u')	goto yy783;
			if(yych == 'w')	goto yy781;
			goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3368 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xE0, CPU_P3|CPU_MMX); }
#line 6102 "x86id.c"
yy781:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3369 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xE3, CPU_P3|CPU_MMX); }
#line 6108 "x86id.c"
yy783:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy784;
	if(yych != 's')	goto yy239;
yy784:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy785;
	if(yych != 'b')	goto yy239;
yy785:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3482 "./modules/arch/x86/x86id.re"
{ RET_INSN(now3d, 0xBF, CPU_3DNow); }
#line 6120 "x86id.c"
yy787:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3521 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixmmx, 0x50, CPU_Cyrix|CPU_MMX); }
#line 6126 "x86id.c"
yy789:	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= '\000')	goto yy790;
		if(yych <= 'M')	goto yy238;
		goto yy791;
	} else {
		if(yych == 'n')	goto yy791;
		goto yy238;
	}
yy790:
#line 3282 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xDB, CPU_MMX); }
#line 6139 "x86id.c"
yy791:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3283 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xDF, CPU_MMX); }
#line 6145 "x86id.c"
yy793:	yych = *++YYCURSOR;
	switch(yych){
	case 'B':	case 'b':	goto yy794;
	case 'D':	case 'd':	goto yy798;
	case 'Q':	case 'q':	goto yy800;
	case 'S':	case 's':	goto yy802;
	case 'U':	case 'u':	goto yy803;
	case 'W':	case 'w':	goto yy796;
	default:	goto yy239;
	}
yy794:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3274 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xFC, CPU_MMX); }
#line 6161 "x86id.c"
yy796:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3275 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xFD, CPU_MMX); }
#line 6167 "x86id.c"
yy798:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3276 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xFE, CPU_MMX); }
#line 6173 "x86id.c"
yy800:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3277 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xD4, CPU_MMX); }
#line 6179 "x86id.c"
yy802:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'H'){
			if(yych == 'B')	goto yy809;
			goto yy239;
		} else {
			if(yych <= 'I')	goto yy811;
			if(yych <= 'V')	goto yy239;
			goto yy812;
		}
	} else {
		if(yych <= 'h'){
			if(yych == 'b')	goto yy809;
			goto yy239;
		} else {
			if(yych <= 'i')	goto yy811;
			if(yych == 'w')	goto yy812;
			goto yy239;
		}
	}
yy803:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy804;
	if(yych != 's')	goto yy239;
yy804:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych == 'B')	goto yy805;
		if(yych <= 'V')	goto yy239;
		goto yy807;
	} else {
		if(yych <= 'b'){
			if(yych <= 'a')	goto yy239;
		} else {
			if(yych == 'w')	goto yy807;
			goto yy239;
		}
	}
yy805:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3280 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xDC, CPU_MMX); }
#line 6221 "x86id.c"
yy807:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3281 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xDD, CPU_MMX); }
#line 6227 "x86id.c"
yy809:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3278 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xEC, CPU_MMX); }
#line 6233 "x86id.c"
yy811:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy814;
	if(yych == 'w')	goto yy814;
	goto yy239;
yy812:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3279 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0xED, CPU_MMX); }
#line 6243 "x86id.c"
yy814:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3520 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixmmx, 0x51, CPU_Cyrix|CPU_MMX); }
#line 6249 "x86id.c"
yy816:	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'S')	goto yy835;
		if(yych <= 'T')	goto yy239;
		goto yy836;
	} else {
		if(yych <= 's'){
			if(yych <= 'r')	goto yy239;
			goto yy835;
		} else {
			if(yych == 'u')	goto yy836;
			goto yy239;
		}
	}
yy817:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy818;
	if(yych != 'p')	goto yy239;
yy818:	yych = *++YYCURSOR;
	if(yych <= 'G'){
		if(yych == 'E')	goto yy819;
		if(yych <= 'F')	goto yy239;
		goto yy820;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy239;
		} else {
			if(yych == 'g')	goto yy820;
			goto yy239;
		}
	}
yy819:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy828;
	if(yych == 'q')	goto yy828;
	goto yy239;
yy820:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy821;
	if(yych != 't')	goto yy239;
yy821:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'C'){
			if(yych != 'B')	goto yy239;
		} else {
			if(yych <= 'D')	goto yy824;
			if(yych <= 'V')	goto yy239;
			goto yy826;
		}
	} else {
		if(yych <= 'c'){
			if(yych != 'b')	goto yy239;
		} else {
			if(yych <= 'd')	goto yy824;
			if(yych == 'w')	goto yy826;
			goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3287 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x64, CPU_MMX); }
#line 6310 "x86id.c"
yy824:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3289 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x66, CPU_MMX); }
#line 6316 "x86id.c"
yy826:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3288 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x65, CPU_MMX); }
#line 6322 "x86id.c"
yy828:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'C'){
			if(yych != 'B')	goto yy239;
		} else {
			if(yych <= 'D')	goto yy831;
			if(yych <= 'V')	goto yy239;
			goto yy833;
		}
	} else {
		if(yych <= 'c'){
			if(yych != 'b')	goto yy239;
		} else {
			if(yych <= 'd')	goto yy831;
			if(yych == 'w')	goto yy833;
			goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3284 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x74, CPU_MMX); }
#line 6346 "x86id.c"
yy831:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3286 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x76, CPU_MMX); }
#line 6352 "x86id.c"
yy833:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3285 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x75, CPU_MMX); }
#line 6358 "x86id.c"
yy835:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy841;
	if(yych == 's')	goto yy841;
	goto yy239;
yy836:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy837;
	if(yych != 's')	goto yy239;
yy837:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy838;
	if(yych != 'w')	goto yy239;
yy838:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy839;
	if(yych != 'b')	goto yy239;
yy839:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3273 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x67, CPU_MMX); }
#line 6377 "x86id.c"
yy841:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych == 'D')	goto yy842;
		if(yych <= 'V')	goto yy239;
		goto yy843;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 'w')	goto yy843;
			goto yy239;
		}
	}
yy842:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy846;
	if(yych == 'w')	goto yy846;
	goto yy239;
yy843:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy844;
	if(yych != 'b')	goto yy239;
yy844:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3272 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x63, CPU_MMX); }
#line 6403 "x86id.c"
yy846:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3271 "./modules/arch/x86/x86id.re"
{ RET_INSN(mmxsse2, 0x6B, CPU_MMX); }
#line 6409 "x86id.c"
yy848:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy849;
	if(yych != 'e')	goto yy239;
yy849:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3266 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xF390, CPU_P4); }
#line 6418 "x86id.c"
yy851:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2641 "./modules/arch/x86/x86id.re"
{ data[0] = 0x6505; return YASM_ARCH_CHECK_ID_SEGREG; }
#line 6424 "x86id.c"
yy853:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2561 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG8 | 7; return YASM_ARCH_CHECK_ID_REG; }
#line 6430 "x86id.c"
yy855:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2557 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG8 | 3; return YASM_ARCH_CHECK_ID_REG; }
#line 6436 "x86id.c"
yy857:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy881;
	if(yych == 'u')	goto yy881;
	goto yy239;
yy858:	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych <= '\000')	goto yy859;
		if(yych <= 'K')	goto yy238;
		goto yy879;
	} else {
		if(yych == 'l')	goto yy879;
		goto yy238;
	}
yy859:
#line 2532 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG16 | 5; return YASM_ARCH_CHECK_ID_REG; }
#line 6453 "x86id.c"
yy860:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'Q'){
			if(yych == 'F')	goto yy871;
			goto yy239;
		} else {
			if(yych <= 'R')	goto yy873;
			if(yych <= 'V')	goto yy239;
			goto yy875;
		}
	} else {
		if(yych <= 'q'){
			if(yych == 'f')	goto yy871;
			goto yy239;
		} else {
			if(yych <= 'r')	goto yy873;
			if(yych == 'w')	goto yy875;
			goto yy239;
		}
	}
yy861:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= 'C'){
			if(yych <= '\000')	goto yy862;
			if(yych <= 'B')	goto yy238;
			goto yy865;
		} else {
			if(yych <= 'Q')	goto yy238;
			if(yych <= 'R')	goto yy867;
			goto yy869;
		}
	} else {
		if(yych <= 'q'){
			if(yych == 'c')	goto yy865;
			goto yy238;
		} else {
			if(yych <= 'r')	goto yy867;
			if(yych <= 's')	goto yy869;
			goto yy238;
		}
	}
yy862:
#line 3041 "./modules/arch/x86/x86id.re"
{ RET_INSN(bittest, 0x04A3, CPU_386); }
#line 6498 "x86id.c"
yy863:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2530 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG16 | 3; return YASM_ARCH_CHECK_ID_REG; }
#line 6504 "x86id.c"
yy865:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3042 "./modules/arch/x86/x86id.re"
{ RET_INSN(bittest, 0x07BB, CPU_386); }
#line 6510 "x86id.c"
yy867:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3043 "./modules/arch/x86/x86id.re"
{ RET_INSN(bittest, 0x06B3, CPU_386); }
#line 6516 "x86id.c"
yy869:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3044 "./modules/arch/x86/x86id.re"
{ RET_INSN(bittest, 0x05AB, CPU_386); }
#line 6522 "x86id.c"
yy871:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3039 "./modules/arch/x86/x86id.re"
{ RET_INSN(bsfr, 0xBC, CPU_386); }
#line 6528 "x86id.c"
yy873:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3040 "./modules/arch/x86/x86id.re"
{ RET_INSN(bsfr, 0xBD, CPU_386); }
#line 6534 "x86id.c"
yy875:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy876;
	if(yych != 'a')	goto yy239;
yy876:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy877;
	if(yych != 'p')	goto yy239;
yy877:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3185 "./modules/arch/x86/x86id.re"
{ RET_INSN(bswap, 0, CPU_486); }
#line 6546 "x86id.c"
yy879:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2571 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG8X | 5;
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 6560 "x86id.c"
yy881:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy882;
	if(yych != 'n')	goto yy239;
yy882:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy883;
	if(yych != 'd')	goto yy239;
yy883:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3069 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(bound, 0, CPU_186);
	}
#line 6578 "x86id.c"
yy885:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy914;
	if(yych == 'x')	goto yy914;
	goto yy239;
yy886:	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych == 'P')	goto yy912;
		if(yych <= 'W')	goto yy239;
		goto yy910;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
			goto yy912;
		} else {
			if(yych == 'x')	goto yy910;
			goto yy239;
		}
	}
yy887:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy908;
	if(yych == 'x')	goto yy908;
	goto yy239;
yy888:	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych == 'I')	goto yy906;
		if(yych <= 'W')	goto yy239;
		goto yy904;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy239;
			goto yy906;
		} else {
			if(yych == 'x')	goto yy904;
			goto yy239;
		}
	}
yy889:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy901;
	if(yych == 'm')	goto yy901;
	goto yy239;
yy890:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy897;
	if(yych == 't')	goto yy897;
	goto yy239;
yy891:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= 'H'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'I')	goto yy895;
			if(yych <= 'O')	goto yy238;
			goto yy893;
		}
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy238;
			goto yy895;
		} else {
			if(yych == 'p')	goto yy893;
			goto yy238;
		}
	}

#line 2618 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64)
		yasm__warning(YASM_WARN_GENERAL, lindex,
		    N_("`%s' segment register ignored in 64-bit mode"), oid);
	    data[0] = 0x2600;
	    return YASM_ARCH_CHECK_ID_SEGREG;
	}
#line 6650 "x86id.c"
yy893:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2504 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG32 | 4; return YASM_ARCH_CHECK_ID_REG; }
#line 6656 "x86id.c"
yy895:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2506 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG32 | 6; return YASM_ARCH_CHECK_ID_REG; }
#line 6662 "x86id.c"
yy897:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy898;
	if(yych != 'e')	goto yy239;
yy898:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy899;
	if(yych != 'r')	goto yy239;
yy899:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2889 "./modules/arch/x86/x86id.re"
{ RET_INSN(enter, 0, CPU_186); }
#line 6674 "x86id.c"
yy901:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy902;
	if(yych != 's')	goto yy239;
yy902:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3268 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F77, CPU_MMX); }
#line 6683 "x86id.c"
yy904:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2502 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG32 | 2; return YASM_ARCH_CHECK_ID_REG; }
#line 6689 "x86id.c"
yy906:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2507 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG32 | 7; return YASM_ARCH_CHECK_ID_REG; }
#line 6695 "x86id.c"
yy908:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2501 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG32 | 1; return YASM_ARCH_CHECK_ID_REG; }
#line 6701 "x86id.c"
yy910:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2503 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG32 | 3; return YASM_ARCH_CHECK_ID_REG; }
#line 6707 "x86id.c"
yy912:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2505 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG32 | 5; return YASM_ARCH_CHECK_ID_REG; }
#line 6713 "x86id.c"
yy914:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2500 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG32 | 0; return YASM_ARCH_CHECK_ID_REG; }
#line 6719 "x86id.c"
yy916:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy945;
	if(yych == 'd')	goto yy945;
	goto yy239;
yy917:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy942;
	if(yych == 't')	goto yy942;
	goto yy239;
yy918:	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy939;
	if(yych == 'h')	goto yy939;
	goto yy239;
yy919:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy935;
	if(yych == 'a')	goto yy935;
	goto yy239;
yy920:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy929;
	if(yych == 'm')	goto yy929;
	goto yy239;
yy921:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy922;
	if(yych != 'r')	goto yy239;
yy922:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy923;
		if(yych <= 'O')	goto yy238;
		goto yy924;
	} else {
		if(yych == 'p')	goto yy924;
		goto yy238;
	}
yy923:
#line 2798 "./modules/arch/x86/x86id.re"
{ RET_INSN(arith, 0x0630, CPU_Any); }
#line 6755 "x86id.c"
yy924:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy927;
		if(yych <= 'R')	goto yy239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy927;
		} else {
			if(yych != 's')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3398 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x57, CPU_SSE); }
#line 6773 "x86id.c"
yy927:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3450 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x6657, CPU_SSE2); }
#line 6779 "x86id.c"
yy929:	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy239;
	if(yych == '1')	goto yy932;
	if(yych >= ':')	goto yy239;
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;
yy931:
#line 2388 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64 &&
		(oid[3] == '8' || oid[3] == '9')) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_XMMREG | (oid[3]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 6798 "x86id.c"
yy932:	yych = *++YYCURSOR;
	if(yych <= '\000')	goto yy931;
	if(yych <= '/')	goto yy238;
	if(yych >= '6')	goto yy238;
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2398 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG64 | (10+oid[4]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 6816 "x86id.c"
yy935:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy936;
	if(yych != 't')	goto yy239;
yy936:	yych = *++YYCURSOR;
	if(yych <= 'B'){
		if(yych <= '\000')	goto yy937;
		if(yych <= 'A')	goto yy238;
		goto yy938;
	} else {
		if(yych == 'b')	goto yy938;
		goto yy238;
	}
yy937:
#line 3037 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00D7, CPU_Any); }
#line 6832 "x86id.c"
yy938:	yych = *++YYCURSOR;
	if(yych <= '\000')	goto yy937;
	goto yy238;
yy939:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy940;
	if(yych != 'g')	goto yy239;
yy940:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2717 "./modules/arch/x86/x86id.re"
{ RET_INSN(xchg, 0, CPU_Any); }
#line 6844 "x86id.c"
yy942:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy943;
	if(yych != 's')	goto yy239;
yy943:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3557 "./modules/arch/x86/x86id.re"
{ RET_INSN(xbts, 0, CPU_386|CPU_Undoc|CPU_Obs); }
#line 6853 "x86id.c"
yy945:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy946;
	if(yych != 'd')	goto yy239;
yy946:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3186 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmpxchgxadd, 0xC0, CPU_486); }
#line 6862 "x86id.c"
yy948:	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych == 'S')	goto yy1074;
		if(yych <= 'W')	goto yy239;
		goto yy1075;
	} else {
		if(yych <= 's'){
			if(yych <= 'r')	goto yy239;
			goto yy1074;
		} else {
			if(yych == 'x')	goto yy1075;
			goto yy239;
		}
	}
yy949:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1069;
	if(yych == 'e')	goto yy1069;
	goto yy239;
yy950:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1058;
	if(yych == 'n')	goto yy1058;
	goto yy239;
yy951:	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy239;
	if(yych <= '7')	goto yy1056;
	goto yy239;
yy952:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy966;
	if(yych == 'v')	goto yy966;
	goto yy239;
yy953:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy954;
	if(yych != 'l')	goto yy239;
yy954:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= 'O'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'P')	goto yy956;
			if(yych <= 'R')	goto yy238;
			goto yy957;
		}
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy238;
			goto yy956;
		} else {
			if(yych == 's')	goto yy957;
			goto yy238;
		}
	}

#line 2868 "./modules/arch/x86/x86id.re"
{ RET_INSN(f6, 0x04, CPU_Any); }
#line 6917 "x86id.c"
yy956:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy964;
		if(yych <= 'R')	goto yy239;
		goto yy962;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy964;
		} else {
			if(yych == 's')	goto yy962;
			goto yy239;
		}
	}
yy957:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy960;
		if(yych <= 'R')	goto yy239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy960;
		} else {
			if(yych != 's')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3366 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF359, CPU_SSE); }
#line 6949 "x86id.c"
yy960:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3440 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF259, CPU_SSE2); }
#line 6955 "x86id.c"
yy962:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3365 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x59, CPU_SSE); }
#line 6961 "x86id.c"
yy964:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3439 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x6659, CPU_SSE2); }
#line 6967 "x86id.c"
yy966:	yych = *++YYCURSOR;
	if(yych <= 'Z'){
		if(yych <= 'L'){
			if(yych <= 'C'){
				if(yych <= '\000')	goto yy967;
				if(yych == 'A')	goto yy968;
				goto yy238;
			} else {
				if(yych <= 'G'){
					if(yych <= 'D')	goto yy969;
					goto yy238;
				} else {
					if(yych <= 'H')	goto yy971;
					if(yych <= 'K')	goto yy238;
					goto yy972;
				}
			}
		} else {
			if(yych <= 'R'){
				if(yych <= 'N'){
					if(yych <= 'M')	goto yy973;
					goto yy974;
				} else {
					if(yych == 'Q')	goto yy975;
					goto yy238;
				}
			} else {
				if(yych <= 'T'){
					if(yych <= 'S')	goto yy977;
					goto yy238;
				} else {
					if(yych <= 'U')	goto yy978;
					if(yych <= 'Y')	goto yy238;
					goto yy979;
				}
			}
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'd'){
				if(yych == 'a')	goto yy968;
				if(yych <= 'c')	goto yy238;
				goto yy969;
			} else {
				if(yych <= 'h'){
					if(yych <= 'g')	goto yy238;
					goto yy971;
				} else {
					if(yych <= 'k')	goto yy238;
					if(yych <= 'l')	goto yy972;
					goto yy973;
				}
			}
		} else {
			if(yych <= 's'){
				if(yych <= 'p'){
					if(yych <= 'n')	goto yy974;
					goto yy238;
				} else {
					if(yych <= 'q')	goto yy975;
					if(yych <= 'r')	goto yy238;
					goto yy977;
				}
			} else {
				if(yych <= 'u'){
					if(yych <= 't')	goto yy238;
					goto yy978;
				} else {
					if(yych == 'z')	goto yy979;
					goto yy238;
				}
			}
		}
	}
yy967:
#line 2657 "./modules/arch/x86/x86id.re"
{ RET_INSN(mov, 0, CPU_Any); }
#line 7045 "x86id.c"
yy968:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1051;
	if(yych == 'p')	goto yy1051;
	goto yy239;
yy969:	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych <= '\000')	goto yy970;
		if(yych <= 'P')	goto yy238;
		goto yy1043;
	} else {
		if(yych == 'q')	goto yy1043;
		goto yy238;
	}
yy970:
#line 3269 "./modules/arch/x86/x86id.re"
{ RET_INSN(movd, 0, CPU_MMX); }
#line 7062 "x86id.c"
yy971:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych == 'L')	goto yy1034;
		if(yych <= 'O')	goto yy239;
		goto yy1035;
	} else {
		if(yych <= 'l'){
			if(yych <= 'k')	goto yy239;
			goto yy1034;
		} else {
			if(yych == 'p')	goto yy1035;
			goto yy239;
		}
	}
yy972:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych == 'H')	goto yy1025;
		if(yych <= 'O')	goto yy239;
		goto yy1026;
	} else {
		if(yych <= 'h'){
			if(yych <= 'g')	goto yy239;
			goto yy1025;
		} else {
			if(yych == 'p')	goto yy1026;
			goto yy239;
		}
	}
yy973:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1018;
	if(yych == 's')	goto yy1018;
	goto yy239;
yy974:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1005;
	if(yych == 't')	goto yy1005;
	goto yy239;
yy975:	yych = *++YYCURSOR;
	if(yych <= '\000')	goto yy976;
	if(yych == '2')	goto yy1001;
	goto yy238;
yy976:
#line 3270 "./modules/arch/x86/x86id.re"
{ RET_INSN(movq, 0, CPU_MMX); }
#line 7106 "x86id.c"
yy977:	yych = *++YYCURSOR;
	switch(yych){
	case 'B':	case 'b':	goto yy989;
	case 'D':	case 'd':	goto yy993;
	case 'Q':	case 'q':	goto yy995;
	case 'S':	case 's':	goto yy997;
	case 'W':	case 'w':	goto yy991;
	case 'X':	case 'x':	goto yy987;
	default:	goto yy239;
	}
yy978:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy982;
	if(yych == 'p')	goto yy982;
	goto yy239;
yy979:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy980;
	if(yych != 'x')	goto yy239;
yy980:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2669 "./modules/arch/x86/x86id.re"
{ RET_INSN(movszx, 0xB6, CPU_386); }
#line 7129 "x86id.c"
yy982:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy983;
		if(yych <= 'R')	goto yy239;
		goto yy985;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy985;
			goto yy239;
		}
	}
yy983:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3438 "./modules/arch/x86/x86id.re"
{ RET_INSN(movaupd, 0x10, CPU_SSE2); }
#line 7148 "x86id.c"
yy985:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3364 "./modules/arch/x86/x86id.re"
{ RET_INSN(movaups, 0x10, CPU_SSE); }
#line 7154 "x86id.c"
yy987:	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= '\000')	goto yy988;
		if(yych <= 'C')	goto yy238;
		goto yy999;
	} else {
		if(yych == 'd')	goto yy999;
		goto yy238;
	}
yy988:
#line 2659 "./modules/arch/x86/x86id.re"
{ RET_INSN(movszx, 0xBE, CPU_386); }
#line 7167 "x86id.c"
yy989:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3001 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00A4, CPU_Any); }
#line 7173 "x86id.c"
yy991:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3002 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x10A5, CPU_Any); }
#line 7179 "x86id.c"
yy993:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3003 "./modules/arch/x86/x86id.re"
{ RET_INSN(movsd, 0, CPU_Any); }
#line 7185 "x86id.c"
yy995:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3004 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is an instruction in 64-bit mode"),
			      oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    RET_INSN(onebyte, 0x40A5, CPU_Any);
	}
#line 7199 "x86id.c"
yy997:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3363 "./modules/arch/x86/x86id.re"
{ RET_INSN(movss, 0, CPU_SSE); }
#line 7205 "x86id.c"
yy999:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2660 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is an instruction in 64-bit mode"),
			      oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    RET_INSN(movsxd, 0, CPU_Hammer|CPU_64);
	}
#line 7219 "x86id.c"
yy1001:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1002;
	if(yych != 'd')	goto yy239;
yy1002:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy1003;
	if(yych != 'q')	goto yy239;
yy1003:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3469 "./modules/arch/x86/x86id.re"
{ RET_INSN(movq2dq, 0, CPU_SSE2); }
#line 7231 "x86id.c"
yy1005:	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych <= 'H'){
			if(yych != 'D')	goto yy239;
		} else {
			if(yych <= 'I')	goto yy1007;
			if(yych <= 'O')	goto yy239;
			if(yych <= 'P')	goto yy1009;
			goto yy1010;
		}
	} else {
		if(yych <= 'i'){
			if(yych == 'd')	goto yy1006;
			if(yych <= 'h')	goto yy239;
			goto yy1007;
		} else {
			if(yych <= 'o')	goto yy239;
			if(yych <= 'p')	goto yy1009;
			if(yych <= 'q')	goto yy1010;
			goto yy239;
		}
	}
yy1006:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy1016;
	if(yych == 'q')	goto yy1016;
	goto yy239;
yy1007:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3262 "./modules/arch/x86/x86id.re"
{ RET_INSN(movnti, 0, CPU_P4); }
#line 7263 "x86id.c"
yy1009:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1014;
		if(yych <= 'R')	goto yy239;
		goto yy1012;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1014;
		} else {
			if(yych == 's')	goto yy1012;
			goto yy239;
		}
	}
yy1010:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3362 "./modules/arch/x86/x86id.re"
{ RET_INSN(movntq, 0, CPU_SSE); }
#line 7283 "x86id.c"
yy1012:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3361 "./modules/arch/x86/x86id.re"
{ RET_INSN(movntps, 0, CPU_SSE); }
#line 7289 "x86id.c"
yy1014:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3435 "./modules/arch/x86/x86id.re"
{ RET_INSN(movntpddq, 0x2B, CPU_SSE2); }
#line 7295 "x86id.c"
yy1016:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3436 "./modules/arch/x86/x86id.re"
{ RET_INSN(movntpddq, 0xE7, CPU_SSE2); }
#line 7301 "x86id.c"
yy1018:	yych = *++YYCURSOR;
	if(yych == 'K')	goto yy1019;
	if(yych != 'k')	goto yy239;
yy1019:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1020;
	if(yych != 'p')	goto yy239;
yy1020:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1021;
		if(yych <= 'R')	goto yy239;
		goto yy1023;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1023;
			goto yy239;
		}
	}
yy1021:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3434 "./modules/arch/x86/x86id.re"
{ RET_INSN(movmskpd, 0, CPU_SSE2); }
#line 7326 "x86id.c"
yy1023:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3360 "./modules/arch/x86/x86id.re"
{ RET_INSN(movmskps, 0, CPU_SSE); }
#line 7332 "x86id.c"
yy1025:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1031;
	if(yych == 'p')	goto yy1031;
	goto yy239;
yy1026:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1027;
		if(yych <= 'R')	goto yy239;
		goto yy1029;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1029;
			goto yy239;
		}
	}
yy1027:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3433 "./modules/arch/x86/x86id.re"
{ RET_INSN(movhlpd, 0x12, CPU_SSE2); }
#line 7355 "x86id.c"
yy1029:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3359 "./modules/arch/x86/x86id.re"
{ RET_INSN(movhlps, 0x12, CPU_SSE); }
#line 7361 "x86id.c"
yy1031:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1032;
	if(yych != 's')	goto yy239;
yy1032:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3358 "./modules/arch/x86/x86id.re"
{ RET_INSN(movhllhps, 0x16, CPU_SSE); }
#line 7370 "x86id.c"
yy1034:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1040;
	if(yych == 'p')	goto yy1040;
	goto yy239;
yy1035:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1036;
		if(yych <= 'R')	goto yy239;
		goto yy1038;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1038;
			goto yy239;
		}
	}
yy1036:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3432 "./modules/arch/x86/x86id.re"
{ RET_INSN(movhlpd, 0x16, CPU_SSE2); }
#line 7393 "x86id.c"
yy1038:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3357 "./modules/arch/x86/x86id.re"
{ RET_INSN(movhlps, 0x16, CPU_SSE); }
#line 7399 "x86id.c"
yy1040:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1041;
	if(yych != 's')	goto yy239;
yy1041:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3356 "./modules/arch/x86/x86id.re"
{ RET_INSN(movhllhps, 0x12, CPU_SSE); }
#line 7408 "x86id.c"
yy1043:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= '2'){
			if(yych <= '1')	goto yy239;
		} else {
			if(yych == 'A')	goto yy1045;
			goto yy239;
		}
	} else {
		if(yych <= 'a'){
			if(yych <= 'U')	goto yy1047;
			if(yych <= '`')	goto yy239;
			goto yy1045;
		} else {
			if(yych == 'u')	goto yy1047;
			goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy1049;
	if(yych == 'q')	goto yy1049;
	goto yy239;
yy1045:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3466 "./modules/arch/x86/x86id.re"
{ RET_INSN(movdqau, 0x66, CPU_SSE2); }
#line 7436 "x86id.c"
yy1047:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3467 "./modules/arch/x86/x86id.re"
{ RET_INSN(movdqau, 0xF3, CPU_SSE2); }
#line 7442 "x86id.c"
yy1049:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3468 "./modules/arch/x86/x86id.re"
{ RET_INSN(movdq2q, 0, CPU_SSE2); }
#line 7448 "x86id.c"
yy1051:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1052;
		if(yych <= 'R')	goto yy239;
		goto yy1054;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1054;
			goto yy239;
		}
	}
yy1052:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3431 "./modules/arch/x86/x86id.re"
{ RET_INSN(movaupd, 0x28, CPU_SSE2); }
#line 7467 "x86id.c"
yy1054:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3355 "./modules/arch/x86/x86id.re"
{ RET_INSN(movaups, 0x28, CPU_SSE); }
#line 7473 "x86id.c"
yy1056:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2384 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_MMXREG | (oid[2]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 7482 "x86id.c"
yy1058:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy1059;
		if(yych <= 'R')	goto yy239;
		goto yy1060;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
		} else {
			if(yych == 's')	goto yy1060;
			goto yy239;
		}
	}
yy1059:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1067;
		if(yych <= 'R')	goto yy239;
		goto yy1065;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1067;
		} else {
			if(yych == 's')	goto yy1065;
			goto yy239;
		}
	}
yy1060:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1063;
		if(yych <= 'R')	goto yy239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1063;
		} else {
			if(yych != 's')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3354 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF35D, CPU_SSE); }
#line 7527 "x86id.c"
yy1063:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3430 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF25D, CPU_SSE2); }
#line 7533 "x86id.c"
yy1065:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3353 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x5D, CPU_SSE); }
#line 7539 "x86id.c"
yy1067:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3429 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x665D, CPU_SSE2); }
#line 7545 "x86id.c"
yy1069:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1070;
	if(yych != 'n')	goto yy239;
yy1070:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1071;
	if(yych != 'c')	goto yy239;
yy1071:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1072;
	if(yych != 'e')	goto yy239;
yy1072:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3265 "./modules/arch/x86/x86id.re"
{ RET_INSN(threebyte, 0x0FAEF0, CPU_P3); }
#line 7560 "x86id.c"
yy1074:	yych = *++YYCURSOR;
	if(yych == 'K')	goto yy1086;
	if(yych == 'k')	goto yy1086;
	goto yy239;
yy1075:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy1076;
		if(yych <= 'R')	goto yy239;
		goto yy1077;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
		} else {
			if(yych == 's')	goto yy1077;
			goto yy239;
		}
	}
yy1076:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1084;
		if(yych <= 'R')	goto yy239;
		goto yy1082;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1084;
		} else {
			if(yych == 's')	goto yy1082;
			goto yy239;
		}
	}
yy1077:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1080;
		if(yych <= 'R')	goto yy239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1080;
		} else {
			if(yych != 's')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3352 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF35F, CPU_SSE); }
#line 7609 "x86id.c"
yy1080:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3428 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF25F, CPU_SSE2); }
#line 7615 "x86id.c"
yy1082:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3351 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x5F, CPU_SSE); }
#line 7621 "x86id.c"
yy1084:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3427 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x665F, CPU_SSE2); }
#line 7627 "x86id.c"
yy1086:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy1087;
	if(yych != 'm')	goto yy239;
yy1087:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy1088;
	if(yych != 'o')	goto yy239;
yy1088:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy1089;
	if(yych != 'v')	goto yy239;
yy1089:	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych == 'D')	goto yy1090;
		if(yych <= 'P')	goto yy239;
		goto yy1091;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 'q')	goto yy1091;
			goto yy239;
		}
	}
yy1090:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy1093;
	if(yych == 'q')	goto yy1093;
	goto yy239;
yy1091:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3350 "./modules/arch/x86/x86id.re"
{ RET_INSN(maskmovq, 0, CPU_P3|CPU_MMX); }
#line 7659 "x86id.c"
yy1093:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy1094;
	if(yych != 'u')	goto yy239;
yy1094:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3465 "./modules/arch/x86/x86id.re"
{ RET_INSN(maskmovdqu, 0, CPU_SSE2); }
#line 7668 "x86id.c"
yy1096:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'A')	goto yy1127;
		if(yych <= 'R')	goto yy239;
		goto yy1129;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy239;
			goto yy1127;
		} else {
			if(yych == 's')	goto yy1129;
			goto yy239;
		}
	}
yy1097:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1125;
	if(yych == 'c')	goto yy1125;
	goto yy239;
yy1098:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2560 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG8 | 6; return YASM_ARCH_CHECK_ID_REG; }
#line 7692 "x86id.c"
yy1100:	yych = *++YYCURSOR;
	if(yych <= 'V'){
		if(yych <= 'K'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'L')	goto yy1111;
			if(yych <= 'U')	goto yy238;
			goto yy1113;
		}
	} else {
		if(yych <= 'l'){
			if(yych <= 'k')	goto yy238;
			goto yy1111;
		} else {
			if(yych == 'v')	goto yy1113;
			goto yy238;
		}
	}

#line 2534 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG16 | 7; return YASM_ARCH_CHECK_ID_REG; }
#line 7714 "x86id.c"
yy1102:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2556 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG8 | 2; return YASM_ARCH_CHECK_ID_REG; }
#line 7720 "x86id.c"
yy1104:	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy239;
	if(yych <= '7')	goto yy1109;
	goto yy239;
yy1105:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2633 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64)
		yasm__warning(YASM_WARN_GENERAL, lindex,
		    N_("`%s' segment register ignored in 64-bit mode"), oid);
	    data[0] = 0x3e03;
	    return YASM_ARCH_CHECK_ID_SEGREG;
	}
#line 7736 "x86id.c"
yy1107:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2529 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG16 | 2; return YASM_ARCH_CHECK_ID_REG; }
#line 7742 "x86id.c"
yy1109:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2370 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_DRREG | (oid[2]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 7751 "x86id.c"
yy1111:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2589 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG8X | 7;
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 7765 "x86id.c"
yy1113:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= 'O'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'P')	goto yy1115;
			if(yych <= 'R')	goto yy238;
			goto yy1116;
		}
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy238;
			goto yy1115;
		} else {
			if(yych == 's')	goto yy1116;
			goto yy238;
		}
	}

#line 2870 "./modules/arch/x86/x86id.re"
{ RET_INSN(f6, 0x06, CPU_Any); }
#line 7787 "x86id.c"
yy1115:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1123;
		if(yych <= 'R')	goto yy239;
		goto yy1121;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1123;
		} else {
			if(yych == 's')	goto yy1121;
			goto yy239;
		}
	}
yy1116:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1119;
		if(yych <= 'R')	goto yy239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1119;
		} else {
			if(yych != 's')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3348 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF35E, CPU_SSE); }
#line 7819 "x86id.c"
yy1119:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3426 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF25E, CPU_SSE2); }
#line 7825 "x86id.c"
yy1121:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3347 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x5E, CPU_SSE); }
#line 7831 "x86id.c"
yy1123:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3425 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x665E, CPU_SSE2); }
#line 7837 "x86id.c"
yy1125:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2792 "./modules/arch/x86/x86id.re"
{ RET_INSN(incdec, 0x0148, CPU_Any); }
#line 7843 "x86id.c"
yy1127:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2816 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(onebyte, 0x0027, CPU_Any);
	}
#line 7855 "x86id.c"
yy1129:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2823 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(onebyte, 0x002F, CPU_Any);
	}
#line 7867 "x86id.c"
yy1131:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy1470;
	if(yych == 'l')	goto yy1470;
	goto yy239;
yy1132:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy1468;
	if(yych == 'w')	goto yy1468;
	goto yy239;
yy1133:	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych == 'O')	goto yy1464;
		if(yych <= 'P')	goto yy239;
		goto yy1462;
	} else {
		if(yych <= 'o'){
			if(yych <= 'n')	goto yy239;
			goto yy1464;
		} else {
			if(yych == 'q')	goto yy1462;
			goto yy239;
		}
	}
yy1134:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2559 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG8 | 5; return YASM_ARCH_CHECK_ID_REG; }
#line 7895 "x86id.c"
yy1136:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= 'E'){
			if(yych <= 'B'){
				if(yych >= '\001')	goto yy238;
			} else {
				if(yych <= 'C')	goto yy1447;
				if(yych <= 'D')	goto yy1449;
				goto yy238;
			}
		} else {
			if(yych <= 'H'){
				if(yych <= 'F')	goto yy1454;
				goto yy238;
			} else {
				if(yych <= 'I')	goto yy1451;
				if(yych <= 'S')	goto yy238;
				goto yy1453;
			}
		}
	} else {
		if(yych <= 'f'){
			if(yych <= 'c'){
				if(yych <= 'b')	goto yy238;
				goto yy1447;
			} else {
				if(yych <= 'd')	goto yy1449;
				if(yych <= 'e')	goto yy238;
				goto yy1454;
			}
		} else {
			if(yych <= 'i'){
				if(yych <= 'h')	goto yy238;
				goto yy1451;
			} else {
				if(yych == 't')	goto yy1453;
				goto yy238;
			}
		}
	}

#line 2555 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG8 | 1; return YASM_ARCH_CHECK_ID_REG; }
#line 7939 "x86id.c"
yy1138:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= 'C'){
			if(yych <= 'B')	goto yy239;
			goto yy1253;
		} else {
			if(yych <= 'N')	goto yy239;
			if(yych <= 'O')	goto yy1257;
			goto yy1255;
		}
	} else {
		if(yych <= 'n'){
			if(yych == 'c')	goto yy1253;
			goto yy239;
		} else {
			if(yych <= 'o')	goto yy1257;
			if(yych <= 'p')	goto yy1255;
			goto yy239;
		}
	}
yy1139:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy1246;
	if(yych == 'm')	goto yy1246;
	goto yy239;
yy1140:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy1242;
	if(yych == 'u')	goto yy1242;
	goto yy239;
yy1141:	yych = *++YYCURSOR;
	if(yych <= '1'){
		if(yych == '0')	goto yy1240;
		goto yy239;
	} else {
		if(yych <= '4')	goto yy1240;
		if(yych == '8')	goto yy1240;
		goto yy239;
	}
yy1142:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2625 "./modules/arch/x86/x86id.re"
{ data[0] = 0x2e01; return YASM_ARCH_CHECK_ID_SEGREG; }
#line 7982 "x86id.c"
yy1144:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1152;
	if(yych == 't')	goto yy1152;
	goto yy239;
yy1145:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1148;
	if(yych == 'd')	goto yy1148;
	goto yy239;
yy1146:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2528 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG16 | 1; return YASM_ARCH_CHECK_ID_REG; }
#line 7996 "x86id.c"
yy1148:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy1149;
		if(yych <= 'D')	goto yy238;
		goto yy1150;
	} else {
		if(yych == 'e')	goto yy1150;
		goto yy238;
	}
yy1149:
#line 2856 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x1099, CPU_Any); }
#line 8009 "x86id.c"
yy1150:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2846 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x2098, CPU_386); }
#line 8015 "x86id.c"
yy1152:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= 'O'){
			if(yych != 'D')	goto yy239;
		} else {
			if(yych <= 'P')	goto yy1154;
			if(yych <= 'R')	goto yy239;
			if(yych <= 'S')	goto yy1155;
			goto yy1156;
		}
	} else {
		if(yych <= 'p'){
			if(yych == 'd')	goto yy1153;
			if(yych <= 'o')	goto yy239;
			goto yy1154;
		} else {
			if(yych <= 'r')	goto yy239;
			if(yych <= 's')	goto yy1155;
			if(yych <= 't')	goto yy1156;
			goto yy239;
		}
	}
yy1153:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy1233;
	if(yych == 'q')	goto yy1233;
	goto yy239;
yy1154:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= 'H'){
			if(yych == 'D')	goto yy1208;
			goto yy239;
		} else {
			if(yych <= 'I')	goto yy1206;
			if(yych <= 'R')	goto yy239;
			goto yy1207;
		}
	} else {
		if(yych <= 'h'){
			if(yych == 'd')	goto yy1208;
			goto yy239;
		} else {
			if(yych <= 'i')	goto yy1206;
			if(yych == 's')	goto yy1207;
			goto yy239;
		}
	}
yy1155:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= 'H'){
			if(yych == 'D')	goto yy1187;
			goto yy239;
		} else {
			if(yych <= 'I')	goto yy1185;
			if(yych <= 'R')	goto yy239;
			goto yy1186;
		}
	} else {
		if(yych <= 'h'){
			if(yych == 'd')	goto yy1187;
			goto yy239;
		} else {
			if(yych <= 'i')	goto yy1185;
			if(yych == 's')	goto yy1186;
			goto yy239;
		}
	}
yy1156:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy1157;
		if(yych <= 'R')	goto yy239;
		goto yy1158;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
		} else {
			if(yych == 's')	goto yy1158;
			goto yy239;
		}
	}
yy1157:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1169;
		if(yych <= 'R')	goto yy239;
		goto yy1170;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1169;
		} else {
			if(yych == 's')	goto yy1170;
			goto yy239;
		}
	}
yy1158:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1159;
		if(yych <= 'R')	goto yy239;
		goto yy1160;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1160;
			goto yy239;
		}
	}
yy1159:	yych = *++YYCURSOR;
	if(yych == '2')	goto yy1165;
	goto yy239;
yy1160:	yych = *++YYCURSOR;
	if(yych != '2')	goto yy239;
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1162;
	if(yych != 's')	goto yy239;
yy1162:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1163;
	if(yych != 'i')	goto yy239;
yy1163:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3346 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF32C, CPU_SSE); }
#line 8138 "x86id.c"
yy1165:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1166;
	if(yych != 's')	goto yy239;
yy1166:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1167;
	if(yych != 'i')	goto yy239;
yy1167:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3462 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF22C, CPU_SSE2); }
#line 8150 "x86id.c"
yy1169:	yych = *++YYCURSOR;
	if(yych == '2')	goto yy1178;
	goto yy239;
yy1170:	yych = *++YYCURSOR;
	if(yych != '2')	goto yy239;
	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych == 'D')	goto yy1172;
		if(yych <= 'O')	goto yy239;
		goto yy1173;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 'p')	goto yy1173;
			goto yy239;
		}
	}
yy1172:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy1176;
	if(yych == 'q')	goto yy1176;
	goto yy239;
yy1173:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1174;
	if(yych != 'i')	goto yy239;
yy1174:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3345 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x2C, CPU_SSE); }
#line 8181 "x86id.c"
yy1176:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3464 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF35B, CPU_SSE2); }
#line 8187 "x86id.c"
yy1178:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych == 'D')	goto yy1179;
		if(yych <= 'O')	goto yy239;
		goto yy1180;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 'p')	goto yy1180;
			goto yy239;
		}
	}
yy1179:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy1183;
	if(yych == 'q')	goto yy1183;
	goto yy239;
yy1180:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1181;
	if(yych != 'i')	goto yy239;
yy1181:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3461 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x662C, CPU_SSE2); }
#line 8213 "x86id.c"
yy1183:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3463 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x66E6, CPU_SSE2); }
#line 8219 "x86id.c"
yy1185:	yych = *++YYCURSOR;
	if(yych == '2')	goto yy1200;
	goto yy239;
yy1186:	yych = *++YYCURSOR;
	if(yych == '2')	goto yy1194;
	goto yy239;
yy1187:	yych = *++YYCURSOR;
	if(yych != '2')	goto yy239;
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1189;
	if(yych != 's')	goto yy239;
yy1189:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'I')	goto yy1190;
		if(yych <= 'R')	goto yy239;
		goto yy1192;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy239;
		} else {
			if(yych == 's')	goto yy1192;
			goto yy239;
		}
	}
yy1190:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3458 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF22D, CPU_SSE2); }
#line 8249 "x86id.c"
yy1192:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3459 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF25A, CPU_SSE2); }
#line 8255 "x86id.c"
yy1194:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1195;
	if(yych != 's')	goto yy239;
yy1195:	yych = *++YYCURSOR;
	if(yych <= 'I'){
		if(yych == 'D')	goto yy1196;
		if(yych <= 'H')	goto yy239;
		goto yy1198;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 'i')	goto yy1198;
			goto yy239;
		}
	}
yy1196:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3460 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF35A, CPU_SSE2); }
#line 8277 "x86id.c"
yy1198:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3344 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF32D, CPU_SSE); }
#line 8283 "x86id.c"
yy1200:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1201;
	if(yych != 's')	goto yy239;
yy1201:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1202;
		if(yych <= 'R')	goto yy239;
		goto yy1204;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1204;
			goto yy239;
		}
	}
yy1202:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3424 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF22A, CPU_SSE2); }
#line 8305 "x86id.c"
yy1204:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3343 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF32A, CPU_SSE); }
#line 8311 "x86id.c"
yy1206:	yych = *++YYCURSOR;
	if(yych == '2')	goto yy1227;
	goto yy239;
yy1207:	yych = *++YYCURSOR;
	if(yych == '2')	goto yy1218;
	goto yy239;
yy1208:	yych = *++YYCURSOR;
	if(yych != '2')	goto yy239;
	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych == 'D')	goto yy1210;
		if(yych <= 'O')	goto yy239;
		goto yy1211;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 'p')	goto yy1211;
			goto yy239;
		}
	}
yy1210:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy1216;
	if(yych == 'q')	goto yy1216;
	goto yy239;
yy1211:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'I')	goto yy1212;
		if(yych <= 'R')	goto yy239;
		goto yy1214;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy239;
		} else {
			if(yych == 's')	goto yy1214;
			goto yy239;
		}
	}
yy1212:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3454 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x662D, CPU_SSE2); }
#line 8355 "x86id.c"
yy1214:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3455 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x665A, CPU_SSE2); }
#line 8361 "x86id.c"
yy1216:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3452 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF2E6, CPU_SSE2); }
#line 8367 "x86id.c"
yy1218:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych == 'D')	goto yy1220;
		if(yych <= 'O')	goto yy239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1220;
		} else {
			if(yych != 'p')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych <= 'I'){
		if(yych == 'D')	goto yy1223;
		if(yych <= 'H')	goto yy239;
		goto yy1225;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1223;
		} else {
			if(yych == 'i')	goto yy1225;
			goto yy239;
		}
	}
yy1220:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy1221;
	if(yych != 'q')	goto yy239;
yy1221:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3457 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x665B, CPU_SSE2); }
#line 8402 "x86id.c"
yy1223:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3456 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x5A, CPU_SSE2); }
#line 8408 "x86id.c"
yy1225:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3342 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x2D, CPU_SSE); }
#line 8414 "x86id.c"
yy1227:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1228;
	if(yych != 'p')	goto yy239;
yy1228:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1229;
		if(yych <= 'R')	goto yy239;
		goto yy1231;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1231;
			goto yy239;
		}
	}
yy1229:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3423 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x662A, CPU_SSE2); }
#line 8436 "x86id.c"
yy1231:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3341 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x2A, CPU_SSE); }
#line 8442 "x86id.c"
yy1233:	yych = *++YYCURSOR;
	if(yych != '2')	goto yy239;
	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1235;
	if(yych != 'p')	goto yy239;
yy1235:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1236;
		if(yych <= 'R')	goto yy239;
		goto yy1238;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1238;
			goto yy239;
		}
	}
yy1236:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3451 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF3E6, CPU_SSE2); }
#line 8466 "x86id.c"
yy1238:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3453 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x5B, CPU_SSE2); }
#line 8472 "x86id.c"
yy1240:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2361 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64 && oid[2] == '8') {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_CRREG | (oid[2]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 8486 "x86id.c"
yy1242:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1243;
	if(yych != 'i')	goto yy239;
yy1243:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1244;
	if(yych != 'd')	goto yy239;
yy1244:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3193 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0FA2, CPU_486); }
#line 8498 "x86id.c"
yy1246:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1247;
	if(yych != 'i')	goto yy239;
yy1247:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1248;
	if(yych != 's')	goto yy239;
yy1248:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1249;
		if(yych <= 'R')	goto yy239;
		goto yy1251;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1251;
			goto yy239;
		}
	}
yy1249:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3422 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x662F, CPU_SSE2); }
#line 8523 "x86id.c"
yy1251:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3340 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x2F, CPU_SSE); }
#line 8529 "x86id.c"
yy1253:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2746 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00F5, CPU_Any); }
#line 8535 "x86id.c"
yy1255:	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych <= 'N'){
			if(yych <= 'E'){
				if(yych <= '\000')	goto yy1256;
				if(yych <= 'D')	goto yy238;
				goto yy1320;
			} else {
				if(yych == 'L')	goto yy1321;
				if(yych <= 'M')	goto yy238;
				goto yy1322;
			}
		} else {
			if(yych <= 'S'){
				if(yych <= 'O')	goto yy1323;
				if(yych <= 'P')	goto yy1324;
				if(yych <= 'R')	goto yy238;
				goto yy1325;
			} else {
				if(yych == 'U')	goto yy1326;
				if(yych <= 'W')	goto yy238;
				goto yy1327;
			}
		}
	} else {
		if(yych <= 'o'){
			if(yych <= 'k'){
				if(yych == 'e')	goto yy1320;
				goto yy238;
			} else {
				if(yych <= 'l')	goto yy1321;
				if(yych <= 'm')	goto yy238;
				if(yych <= 'n')	goto yy1322;
				goto yy1323;
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'p')	goto yy1324;
				if(yych == 's')	goto yy1325;
				goto yy238;
			} else {
				if(yych <= 'u')	goto yy1326;
				if(yych == 'x')	goto yy1327;
				goto yy238;
			}
		}
	}
yy1256:
#line 2794 "./modules/arch/x86/x86id.re"
{ RET_INSN(arith, 0x0738, CPU_Any); }
#line 8586 "x86id.c"
yy1257:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy1258;
	if(yych != 'v')	goto yy239;
yy1258:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy1266;
	case 'B':	case 'b':	goto yy1262;
	case 'C':	case 'c':	goto yy1264;
	case 'E':	case 'e':	goto yy1268;
	case 'G':	case 'g':	goto yy1278;
	case 'L':	case 'l':	goto yy1276;
	case 'N':	case 'n':	goto yy1261;
	case 'O':	case 'o':	goto yy1259;
	case 'P':	case 'p':	goto yy1274;
	case 'S':	case 's':	goto yy1272;
	case 'Z':	case 'z':	goto yy1270;
	default:	goto yy239;
	}
yy1259:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3219 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x00, CPU_686); }
#line 8610 "x86id.c"
yy1261:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy1292;
	case 'B':	case 'b':	goto yy1294;
	case 'C':	case 'c':	goto yy1296;
	case 'E':	case 'e':	goto yy1298;
	case 'G':	case 'g':	goto yy1300;
	case 'L':	case 'l':	goto yy1302;
	case 'O':	case 'o':	goto yy1304;
	case 'P':	case 'p':	goto yy1306;
	case 'S':	case 's':	goto yy1308;
	case 'Z':	case 'z':	goto yy1310;
	default:	goto yy239;
	}
yy1262:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy1263;
		if(yych <= 'D')	goto yy238;
		goto yy1290;
	} else {
		if(yych == 'e')	goto yy1290;
		goto yy238;
	}
yy1263:
#line 3221 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x02, CPU_686); }
#line 8637 "x86id.c"
yy1264:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3222 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x02, CPU_686); }
#line 8643 "x86id.c"
yy1266:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy1267;
		if(yych <= 'D')	goto yy238;
		goto yy1288;
	} else {
		if(yych == 'e')	goto yy1288;
		goto yy238;
	}
yy1267:
#line 3234 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x07, CPU_686); }
#line 8656 "x86id.c"
yy1268:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3227 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x04, CPU_686); }
#line 8662 "x86id.c"
yy1270:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3228 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x04, CPU_686); }
#line 8668 "x86id.c"
yy1272:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3235 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x08, CPU_686); }
#line 8674 "x86id.c"
yy1274:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= 'D'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'E')	goto yy1284;
			if(yych <= 'N')	goto yy238;
			goto yy1286;
		}
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy238;
			goto yy1284;
		} else {
			if(yych == 'o')	goto yy1286;
			goto yy238;
		}
	}

#line 3237 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x0A, CPU_686); }
#line 8696 "x86id.c"
yy1276:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy1277;
		if(yych <= 'D')	goto yy238;
		goto yy1282;
	} else {
		if(yych == 'e')	goto yy1282;
		goto yy238;
	}
yy1277:
#line 3241 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x0C, CPU_686); }
#line 8709 "x86id.c"
yy1278:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy1279;
		if(yych <= 'D')	goto yy238;
		goto yy1280;
	} else {
		if(yych == 'e')	goto yy1280;
		goto yy238;
	}
yy1279:
#line 3248 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x0F, CPU_686); }
#line 8722 "x86id.c"
yy1280:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3244 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x0D, CPU_686); }
#line 8728 "x86id.c"
yy1282:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3245 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x0E, CPU_686); }
#line 8734 "x86id.c"
yy1284:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3238 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x0A, CPU_686); }
#line 8740 "x86id.c"
yy1286:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3240 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x0B, CPU_686); }
#line 8746 "x86id.c"
yy1288:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3226 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x03, CPU_686); }
#line 8752 "x86id.c"
yy1290:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3231 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x06, CPU_686); }
#line 8758 "x86id.c"
yy1292:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy1293;
		if(yych <= 'D')	goto yy238;
		goto yy1318;
	} else {
		if(yych == 'e')	goto yy1318;
		goto yy238;
	}
yy1293:
#line 3232 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x06, CPU_686); }
#line 8771 "x86id.c"
yy1294:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy1295;
		if(yych <= 'D')	goto yy238;
		goto yy1316;
	} else {
		if(yych == 'e')	goto yy1316;
		goto yy238;
	}
yy1295:
#line 3224 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x03, CPU_686); }
#line 8784 "x86id.c"
yy1296:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3225 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x03, CPU_686); }
#line 8790 "x86id.c"
yy1298:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3229 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x05, CPU_686); }
#line 8796 "x86id.c"
yy1300:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy1301;
		if(yych <= 'D')	goto yy238;
		goto yy1314;
	} else {
		if(yych == 'e')	goto yy1314;
		goto yy238;
	}
yy1301:
#line 3246 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x0E, CPU_686); }
#line 8809 "x86id.c"
yy1302:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy1303;
		if(yych <= 'D')	goto yy238;
		goto yy1312;
	} else {
		if(yych == 'e')	goto yy1312;
		goto yy238;
	}
yy1303:
#line 3243 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x0D, CPU_686); }
#line 8822 "x86id.c"
yy1304:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3220 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x01, CPU_686); }
#line 8828 "x86id.c"
yy1306:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3239 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x0B, CPU_686); }
#line 8834 "x86id.c"
yy1308:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3236 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x09, CPU_686); }
#line 8840 "x86id.c"
yy1310:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3230 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x05, CPU_686); }
#line 8846 "x86id.c"
yy1312:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3247 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x0F, CPU_686); }
#line 8852 "x86id.c"
yy1314:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3242 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x0C, CPU_686); }
#line 8858 "x86id.c"
yy1316:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3233 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x07, CPU_686); }
#line 8864 "x86id.c"
yy1318:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3223 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmovcc, 0x02, CPU_686); }
#line 8870 "x86id.c"
yy1320:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy1436;
	if(yych == 'q')	goto yy1436;
	goto yy239;
yy1321:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych == 'E')	goto yy1414;
		if(yych <= 'S')	goto yy239;
		goto yy1415;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy239;
			goto yy1414;
		} else {
			if(yych == 't')	goto yy1415;
			goto yy239;
		}
	}
yy1322:	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych == 'E')	goto yy1379;
		if(yych <= 'K')	goto yy239;
		goto yy1380;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy239;
			goto yy1379;
		} else {
			if(yych == 'l')	goto yy1380;
			goto yy239;
		}
	}
yy1323:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1367;
	if(yych == 'r')	goto yy1367;
	goto yy239;
yy1324:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1365;
		if(yych <= 'R')	goto yy239;
		goto yy1363;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1365;
		} else {
			if(yych == 's')	goto yy1363;
			goto yy239;
		}
	}
yy1325:	yych = *++YYCURSOR;
	switch(yych){
	case 'B':	case 'b':	goto yy1353;
	case 'D':	case 'd':	goto yy1357;
	case 'Q':	case 'q':	goto yy1359;
	case 'S':	case 's':	goto yy1361;
	case 'W':	case 'w':	goto yy1355;
	default:	goto yy239;
	}
yy1326:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1339;
	if(yych == 'n')	goto yy1339;
	goto yy239;
yy1327:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1328;
	if(yych != 'c')	goto yy239;
yy1328:	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy1329;
	if(yych != 'h')	goto yy239;
yy1329:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy1330;
	if(yych != 'g')	goto yy239;
yy1330:	yych = *++YYCURSOR;
	if(yych <= '4'){
		if(yych <= '\000')	goto yy1331;
		if(yych <= '3')	goto yy238;
		goto yy1332;
	} else {
		if(yych == '8')	goto yy1333;
		goto yy238;
	}
yy1331:
#line 3187 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmpxchgxadd, 0xB0, CPU_486); }
#line 8955 "x86id.c"
yy1332:	yych = *++YYCURSOR;
	if(yych == '8')	goto yy1336;
	goto yy239;
yy1333:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy1334;
	if(yych != 'b')	goto yy239;
yy1334:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3198 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmpxchg8b, 0, CPU_586); }
#line 8967 "x86id.c"
yy1336:	yych = *++YYCURSOR;
	if(yych != '6')	goto yy239;
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3188 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmpxchgxadd, 0xA6, CPU_486|CPU_Undoc); }
#line 8975 "x86id.c"
yy1339:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy1340;
	if(yych != 'o')	goto yy239;
yy1340:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1341;
	if(yych != 'r')	goto yy239;
yy1341:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1342;
	if(yych != 'd')	goto yy239;
yy1342:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy1343;
		if(yych <= 'R')	goto yy239;
		goto yy1344;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
		} else {
			if(yych == 's')	goto yy1344;
			goto yy239;
		}
	}
yy1343:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1349;
		if(yych <= 'R')	goto yy239;
		goto yy1351;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1349;
		} else {
			if(yych == 's')	goto yy1351;
			goto yy239;
		}
	}
yy1344:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1345;
		if(yych <= 'R')	goto yy239;
		goto yy1347;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1347;
			goto yy239;
		}
	}
yy1345:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3419 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x03F2, CPU_SSE2); }
#line 9030 "x86id.c"
yy1347:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3337 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x03F3, CPU_SSE); }
#line 9036 "x86id.c"
yy1349:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3418 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x0366, CPU_SSE2); }
#line 9042 "x86id.c"
yy1351:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3336 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpps, 0x03, CPU_SSE); }
#line 9048 "x86id.c"
yy1353:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2971 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00A6, CPU_Any); }
#line 9054 "x86id.c"
yy1355:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2972 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x10A7, CPU_Any); }
#line 9060 "x86id.c"
yy1357:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2973 "./modules/arch/x86/x86id.re"
{ RET_INSN(cmpsd, 0, CPU_Any); }
#line 9066 "x86id.c"
yy1359:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2974 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is an instruction in 64-bit mode"),
			      oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    RET_INSN(onebyte, 0x40A7, CPU_Hammer|CPU_64);
	}
#line 9080 "x86id.c"
yy1361:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3339 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssessimm, 0xF3C2, CPU_SSE); }
#line 9086 "x86id.c"
yy1363:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3338 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssepsimm, 0xC2, CPU_SSE); }
#line 9092 "x86id.c"
yy1365:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3420 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssessimm, 0x66C2, CPU_SSE2); }
#line 9098 "x86id.c"
yy1367:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1368;
	if(yych != 'd')	goto yy239;
yy1368:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy1369;
		if(yych <= 'R')	goto yy239;
		goto yy1370;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
		} else {
			if(yych == 's')	goto yy1370;
			goto yy239;
		}
	}
yy1369:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1375;
		if(yych <= 'R')	goto yy239;
		goto yy1377;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1375;
		} else {
			if(yych == 's')	goto yy1377;
			goto yy239;
		}
	}
yy1370:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1371;
		if(yych <= 'R')	goto yy239;
		goto yy1373;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1373;
			goto yy239;
		}
	}
yy1371:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3417 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x07F2, CPU_SSE2); }
#line 9147 "x86id.c"
yy1373:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3335 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x07F3, CPU_SSE); }
#line 9153 "x86id.c"
yy1375:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3416 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x0766, CPU_SSE2); }
#line 9159 "x86id.c"
yy1377:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3334 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpps, 0x07, CPU_SSE); }
#line 9165 "x86id.c"
yy1379:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy1403;
	if(yych == 'q')	goto yy1403;
	goto yy239;
yy1380:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych == 'E')	goto yy1381;
		if(yych <= 'S')	goto yy239;
		goto yy1382;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy239;
		} else {
			if(yych == 't')	goto yy1382;
			goto yy239;
		}
	}
yy1381:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy1393;
		if(yych <= 'R')	goto yy239;
		goto yy1394;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
			goto yy1393;
		} else {
			if(yych == 's')	goto yy1394;
			goto yy239;
		}
	}
yy1382:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy1383;
		if(yych <= 'R')	goto yy239;
		goto yy1384;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
		} else {
			if(yych == 's')	goto yy1384;
			goto yy239;
		}
	}
yy1383:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1389;
		if(yych <= 'R')	goto yy239;
		goto yy1391;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1389;
		} else {
			if(yych == 's')	goto yy1391;
			goto yy239;
		}
	}
yy1384:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1385;
		if(yych <= 'R')	goto yy239;
		goto yy1387;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1387;
			goto yy239;
		}
	}
yy1385:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3415 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x05F2, CPU_SSE2); }
#line 9242 "x86id.c"
yy1387:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3333 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x05F3, CPU_SSE); }
#line 9248 "x86id.c"
yy1389:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3414 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x0566, CPU_SSE2); }
#line 9254 "x86id.c"
yy1391:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3332 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpps, 0x05, CPU_SSE); }
#line 9260 "x86id.c"
yy1393:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1399;
		if(yych <= 'R')	goto yy239;
		goto yy1401;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1399;
		} else {
			if(yych == 's')	goto yy1401;
			goto yy239;
		}
	}
yy1394:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1395;
		if(yych <= 'R')	goto yy239;
		goto yy1397;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1397;
			goto yy239;
		}
	}
yy1395:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3413 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x06F2, CPU_SSE2); }
#line 9293 "x86id.c"
yy1397:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3331 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x06F3, CPU_SSE); }
#line 9299 "x86id.c"
yy1399:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3412 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x0666, CPU_SSE2); }
#line 9305 "x86id.c"
yy1401:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3330 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpps, 0x06, CPU_SSE); }
#line 9311 "x86id.c"
yy1403:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy1404;
		if(yych <= 'R')	goto yy239;
		goto yy1405;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
		} else {
			if(yych == 's')	goto yy1405;
			goto yy239;
		}
	}
yy1404:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1410;
		if(yych <= 'R')	goto yy239;
		goto yy1412;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1410;
		} else {
			if(yych == 's')	goto yy1412;
			goto yy239;
		}
	}
yy1405:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1406;
		if(yych <= 'R')	goto yy239;
		goto yy1408;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1408;
			goto yy239;
		}
	}
yy1406:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3411 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x04F2, CPU_SSE2); }
#line 9357 "x86id.c"
yy1408:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3329 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x04F3, CPU_SSE); }
#line 9363 "x86id.c"
yy1410:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3410 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x0466, CPU_SSE2); }
#line 9369 "x86id.c"
yy1412:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3328 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpps, 0x04, CPU_SSE); }
#line 9375 "x86id.c"
yy1414:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy1426;
		if(yych <= 'R')	goto yy239;
		goto yy1427;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
			goto yy1426;
		} else {
			if(yych == 's')	goto yy1427;
			goto yy239;
		}
	}
yy1415:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy1416;
		if(yych <= 'R')	goto yy239;
		goto yy1417;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
		} else {
			if(yych == 's')	goto yy1417;
			goto yy239;
		}
	}
yy1416:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1424;
		if(yych <= 'R')	goto yy239;
		goto yy1422;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1424;
		} else {
			if(yych == 's')	goto yy1422;
			goto yy239;
		}
	}
yy1417:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1420;
		if(yych <= 'R')	goto yy239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1420;
		} else {
			if(yych != 's')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3327 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x01F3, CPU_SSE); }
#line 9434 "x86id.c"
yy1420:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3409 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x01F2, CPU_SSE2); }
#line 9440 "x86id.c"
yy1422:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3326 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpps, 0x01, CPU_SSE); }
#line 9446 "x86id.c"
yy1424:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3408 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x0166, CPU_SSE2); }
#line 9452 "x86id.c"
yy1426:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1434;
		if(yych <= 'R')	goto yy239;
		goto yy1432;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1434;
		} else {
			if(yych == 's')	goto yy1432;
			goto yy239;
		}
	}
yy1427:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1430;
		if(yych <= 'R')	goto yy239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1430;
		} else {
			if(yych != 's')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3325 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x02F3, CPU_SSE); }
#line 9484 "x86id.c"
yy1430:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3407 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x02F2, CPU_SSE2); }
#line 9490 "x86id.c"
yy1432:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3324 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpps, 0x02, CPU_SSE); }
#line 9496 "x86id.c"
yy1434:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3406 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x0266, CPU_SSE2); }
#line 9502 "x86id.c"
yy1436:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy1437;
		if(yych <= 'R')	goto yy239;
		goto yy1438;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
		} else {
			if(yych == 's')	goto yy1438;
			goto yy239;
		}
	}
yy1437:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1445;
		if(yych <= 'R')	goto yy239;
		goto yy1443;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1445;
		} else {
			if(yych == 's')	goto yy1443;
			goto yy239;
		}
	}
yy1438:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1441;
		if(yych <= 'R')	goto yy239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1441;
		} else {
			if(yych != 's')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3323 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x00F3, CPU_SSE); }
#line 9547 "x86id.c"
yy1441:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3405 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x00F2, CPU_SSE2); }
#line 9553 "x86id.c"
yy1443:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3322 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpps, 0x00, CPU_SSE); }
#line 9559 "x86id.c"
yy1445:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3404 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssecmpss, 0x0066, CPU_SSE2); }
#line 9565 "x86id.c"
yy1447:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2742 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00F8, CPU_Any); }
#line 9571 "x86id.c"
yy1449:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2743 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00FC, CPU_Any); }
#line 9577 "x86id.c"
yy1451:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2744 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00FA, CPU_Any); }
#line 9583 "x86id.c"
yy1453:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1460;
	if(yych == 's')	goto yy1460;
	goto yy239;
yy1454:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy1455;
	if(yych != 'l')	goto yy239;
yy1455:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy1456;
	if(yych != 'u')	goto yy239;
yy1456:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1457;
	if(yych != 's')	goto yy239;
yy1457:	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy1458;
	if(yych != 'h')	goto yy239;
yy1458:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3263 "./modules/arch/x86/x86id.re"
{ RET_INSN(clflush, 0, CPU_P3); }
#line 9605 "x86id.c"
yy1460:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2745 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F06, CPU_286|CPU_Priv); }
#line 9611 "x86id.c"
yy1462:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy1463;
		if(yych <= 'D')	goto yy238;
		goto yy1466;
	} else {
		if(yych == 'e')	goto yy1466;
		goto yy238;
	}
yy1463:
#line 2857 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x2099, CPU_386); }
#line 9624 "x86id.c"
yy1464:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2858 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is an instruction in 64-bit mode"),
			      oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    RET_INSN(onebyte, 0x4099, CPU_Hammer|CPU_64);
	}
#line 9638 "x86id.c"
yy1466:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2847 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is an instruction in 64-bit mode"),
			      oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    RET_INSN(onebyte, 0x4098, CPU_Hammer|CPU_64);
	}
#line 9652 "x86id.c"
yy1468:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2845 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x1098, CPU_Any); }
#line 9658 "x86id.c"
yy1470:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy1471;
	if(yych != 'l')	goto yy239;
yy1471:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2884 "./modules/arch/x86/x86id.re"
{ RET_INSN(call, 0, CPU_Any); }
#line 9667 "x86id.c"
yy1473:	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy239;
	if(yych <= '5')	goto yy1577;
	goto yy239;
yy1474:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'B'){
			if(yych <= '\000')	goto yy1475;
			if(yych <= 'A')	goto yy238;
			goto yy1575;
		} else {
			if(yych == 'D')	goto yy1571;
			if(yych <= 'V')	goto yy238;
			goto yy1573;
		}
	} else {
		if(yych <= 'c'){
			if(yych == 'b')	goto yy1575;
			goto yy238;
		} else {
			if(yych <= 'd')	goto yy1571;
			if(yych == 'w')	goto yy1573;
			goto yy238;
		}
	}
yy1475:
#line 2481 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG64 | (oid[1]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 9704 "x86id.c"
yy1476:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy1569;
	if(yych == 'x')	goto yy1569;
	goto yy239;
yy1477:	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych == 'P')	goto yy1567;
		if(yych <= 'W')	goto yy239;
		goto yy1565;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
			goto yy1567;
		} else {
			if(yych == 'x')	goto yy1565;
			goto yy239;
		}
	}
yy1478:	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych <= 'P'){
			if(yych == 'L')	goto yy1554;
			if(yych <= 'O')	goto yy239;
			goto yy1558;
		} else {
			if(yych == 'R')	goto yy1556;
			if(yych <= 'W')	goto yy239;
			goto yy1552;
		}
	} else {
		if(yych <= 'p'){
			if(yych == 'l')	goto yy1554;
			if(yych <= 'o')	goto yy239;
			goto yy1558;
		} else {
			if(yych <= 'r'){
				if(yych <= 'q')	goto yy239;
				goto yy1556;
			} else {
				if(yych == 'x')	goto yy1552;
				goto yy239;
			}
		}
	}
yy1479:	yych = *++YYCURSOR;
	switch(yych){
	case 'I':	case 'i':	goto yy1534;
	case 'M':	case 'm':	goto yy1537;
	case 'P':	case 'p':	goto yy1538;
	case 'S':	case 's':	goto yy1539;
	case 'T':	case 't':	goto yy1536;
	case 'X':	case 'x':	goto yy1532;
	default:	goto yy239;
	}
yy1480:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych == 'P')	goto yy1515;
		if(yych <= 'S')	goto yy239;
		goto yy1517;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
			goto yy1515;
		} else {
			if(yych == 't')	goto yy1517;
			goto yy239;
		}
	}
yy1481:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1513;
	if(yych == 'p')	goto yy1513;
	goto yy239;
yy1482:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych == 'L')	goto yy1509;
		if(yych <= 'Q')	goto yy239;
		goto yy1511;
	} else {
		if(yych <= 'l'){
			if(yych <= 'k')	goto yy239;
			goto yy1509;
		} else {
			if(yych == 'r')	goto yy1511;
			goto yy239;
		}
	}
yy1483:	yych = *++YYCURSOR;
	switch(yych){
	case 'D':	case 'd':	goto yy1491;
	case 'I':	case 'i':	goto yy1486;
	case 'L':	case 'l':	goto yy1492;
	case 'M':	case 'm':	goto yy1488;
	case 'P':	case 'p':	goto yy1484;
	case 'Q':	case 'q':	goto yy1490;
	case 'T':	case 't':	goto yy1493;
	default:	goto yy239;
	}
yy1484:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2445 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG64 | 4;
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 9815 "x86id.c"
yy1486:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2463 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG64 | 6;
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 9829 "x86id.c"
yy1488:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3068 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0FAA, CPU_586|CPU_SMM); }
#line 9835 "x86id.c"
yy1490:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1501;
	if(yych == 'r')	goto yy1501;
	goto yy239;
yy1491:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1499;
	if(yych == 'c')	goto yy1499;
	goto yy239;
yy1492:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1496;
	if(yych == 'd')	goto yy1496;
	goto yy239;
yy1493:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1494;
	if(yych != 's')	goto yy239;
yy1494:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3536 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixsmm, 0x7D, CPU_486|CPU_Cyrix|CPU_SMM); }
#line 9856 "x86id.c"
yy1496:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1497;
	if(yych != 't')	goto yy239;
yy1497:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3535 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixsmm, 0x7B, CPU_486|CPU_Cyrix|CPU_SMM); }
#line 9865 "x86id.c"
yy1499:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3534 "./modules/arch/x86/x86id.re"
{ RET_INSN(rsdc, 0, CPU_486|CPU_Cyrix|CPU_SMM); }
#line 9871 "x86id.c"
yy1501:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1502;
	if(yych != 't')	goto yy239;
yy1502:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy1503;
		if(yych <= 'R')	goto yy239;
		goto yy1504;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
		} else {
			if(yych == 's')	goto yy1504;
			goto yy239;
		}
	}
yy1503:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1507;
	if(yych == 's')	goto yy1507;
	goto yy239;
yy1504:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1505;
	if(yych != 's')	goto yy239;
yy1505:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3387 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF352, CPU_SSE); }
#line 9900 "x86id.c"
yy1507:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3386 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x52, CPU_SSE); }
#line 9906 "x86id.c"
yy1509:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2873 "./modules/arch/x86/x86id.re"
{ RET_INSN(shift, 0x00, CPU_Any); }
#line 9912 "x86id.c"
yy1511:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2874 "./modules/arch/x86/x86id.re"
{ RET_INSN(shift, 0x01, CPU_Any); }
#line 9918 "x86id.c"
yy1513:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2644 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_RIP;
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 9932 "x86id.c"
yy1515:	yych = *++YYCURSOR;
	if(yych <= 'Z'){
		if(yych <= 'E'){
			if(yych <= '\000')	goto yy1516;
			if(yych <= 'D')	goto yy238;
			goto yy1523;
		} else {
			if(yych == 'N')	goto yy1525;
			if(yych <= 'Y')	goto yy238;
			goto yy1526;
		}
	} else {
		if(yych <= 'm'){
			if(yych == 'e')	goto yy1523;
			goto yy238;
		} else {
			if(yych <= 'n')	goto yy1525;
			if(yych == 'z')	goto yy1526;
			goto yy238;
		}
	}
yy1516:
#line 2344 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_LOCKREP;
	    data[1] = 0xF3;
	    return YASM_ARCH_CHECK_ID_PREFIX;
	}
#line 9961 "x86id.c"
yy1517:	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= 'E'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'F')	goto yy1519;
			if(yych <= 'M')	goto yy238;
			goto yy1521;
		}
	} else {
		if(yych <= 'f'){
			if(yych <= 'e')	goto yy238;
			goto yy1519;
		} else {
			if(yych == 'n')	goto yy1521;
			goto yy238;
		}
	}

#line 2886 "./modules/arch/x86/x86id.re"
{ RET_INSN(retnf, 0xC2, CPU_Any); }
#line 9983 "x86id.c"
yy1519:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2888 "./modules/arch/x86/x86id.re"
{ RET_INSN(retnf, 0xCA, CPU_Any); }
#line 9989 "x86id.c"
yy1521:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2887 "./modules/arch/x86/x86id.re"
{ RET_INSN(retnf, 0xC2, CPU_Any); }
#line 9995 "x86id.c"
yy1523:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2349 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_LOCKREP;
	    data[1] = 0xF4;
	    return YASM_ARCH_CHECK_ID_PREFIX;
	}
#line 10005 "x86id.c"
yy1525:	yych = *++YYCURSOR;
	if(yych <= 'Z'){
		if(yych == 'E')	goto yy1528;
		if(yych <= 'Y')	goto yy239;
		goto yy1530;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy239;
			goto yy1528;
		} else {
			if(yych == 'z')	goto yy1530;
			goto yy239;
		}
	}
yy1526:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2354 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_LOCKREP;
	    data[1] = 0xF4;
	    return YASM_ARCH_CHECK_ID_PREFIX;
	}
#line 10029 "x86id.c"
yy1528:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2334 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_LOCKREP;
	    data[1] = 0xF2;
	    return YASM_ARCH_CHECK_ID_PREFIX;
	}
#line 10039 "x86id.c"
yy1530:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2339 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_LOCKREP;
	    data[1] = 0xF2;
	    return YASM_ARCH_CHECK_ID_PREFIX;
	}
#line 10049 "x86id.c"
yy1532:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2427 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG64 | 2;
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 10063 "x86id.c"
yy1534:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2472 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG64 | 7;
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 10077 "x86id.c"
yy1536:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1549;
	if(yych == 's')	goto yy1549;
	goto yy239;
yy1537:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1546;
	if(yych == 's')	goto yy1546;
	goto yy239;
yy1538:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy1543;
	if(yych == 'm')	goto yy1543;
	goto yy239;
yy1539:	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy1540;
	if(yych != 'h')	goto yy239;
yy1540:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1541;
	if(yych != 'r')	goto yy239;
yy1541:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3533 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F36, CPU_686|CPU_Cyrix|CPU_SMM); }
#line 10101 "x86id.c"
yy1543:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1544;
	if(yych != 'c')	goto yy239;
yy1544:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3216 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F33, CPU_686); }
#line 10110 "x86id.c"
yy1546:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1547;
	if(yych != 'r')	goto yy239;
yy1547:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3197 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F32, CPU_586|CPU_Priv); }
#line 10119 "x86id.c"
yy1549:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1550;
	if(yych != 'c')	goto yy239;
yy1550:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3196 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F31, CPU_586); }
#line 10128 "x86id.c"
yy1552:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2418 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG64 | 1;
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 10142 "x86id.c"
yy1554:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2875 "./modules/arch/x86/x86id.re"
{ RET_INSN(shift, 0x02, CPU_Any); }
#line 10148 "x86id.c"
yy1556:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2876 "./modules/arch/x86/x86id.re"
{ RET_INSN(shift, 0x03, CPU_Any); }
#line 10154 "x86id.c"
yy1558:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy1559;
		if(yych <= 'R')	goto yy239;
		goto yy1560;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
		} else {
			if(yych == 's')	goto yy1560;
			goto yy239;
		}
	}
yy1559:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1563;
	if(yych == 's')	goto yy1563;
	goto yy239;
yy1560:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1561;
	if(yych != 's')	goto yy239;
yy1561:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3385 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF353, CPU_SSE); }
#line 10180 "x86id.c"
yy1563:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3384 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x53, CPU_SSE); }
#line 10186 "x86id.c"
yy1565:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2436 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG64 | 3;
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 10200 "x86id.c"
yy1567:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2454 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG64 | 5;
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 10214 "x86id.c"
yy1569:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2409 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG64 | 0;
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 10228 "x86id.c"
yy1571:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2508 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG32 | (oid[1]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 10242 "x86id.c"
yy1573:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2535 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG16 | (oid[1]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 10256 "x86id.c"
yy1575:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2598 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG8 | (oid[1]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 10270 "x86id.c"
yy1577:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'B'){
			if(yych <= '\000')	goto yy1578;
			if(yych <= 'A')	goto yy238;
			goto yy1579;
		} else {
			if(yych == 'D')	goto yy1581;
			if(yych <= 'V')	goto yy238;
			goto yy1583;
		}
	} else {
		if(yych <= 'c'){
			if(yych == 'b')	goto yy1579;
			goto yy238;
		} else {
			if(yych <= 'd')	goto yy1581;
			if(yych == 'w')	goto yy1583;
			goto yy238;
		}
	}
yy1578:
#line 2490 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG64 | (10+oid[2]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 10303 "x86id.c"
yy1579:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2607 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG8 | (10+oid[2]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 10317 "x86id.c"
yy1581:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2517 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG32 | (10+oid[2]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 10331 "x86id.c"
yy1583:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2544 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG16 | (10+oid[2]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 10345 "x86id.c"
yy1585:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych == 'H')	goto yy1673;
		if(yych <= 'Q')	goto yy239;
		goto yy1674;
	} else {
		if(yych <= 'h'){
			if(yych <= 'g')	goto yy239;
			goto yy1673;
		} else {
			if(yych == 'r')	goto yy1674;
			goto yy239;
		}
	}
yy1586:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'M')	goto yy1667;
		if(yych <= 'R')	goto yy239;
		goto yy1665;
	} else {
		if(yych <= 'm'){
			if(yych <= 'l')	goto yy239;
			goto yy1667;
		} else {
			if(yych == 's')	goto yy1665;
			goto yy239;
		}
	}
yy1587:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'A')	goto yy1658;
		if(yych <= 'R')	goto yy239;
		goto yy1660;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy239;
			goto yy1658;
		} else {
			if(yych == 's')	goto yy1660;
			goto yy239;
		}
	}
yy1588:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'E')	goto yy1653;
		if(yych <= 'R')	goto yy239;
		goto yy1651;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy239;
			goto yy1653;
		} else {
			if(yych == 's')	goto yy1651;
			goto yy239;
		}
	}
yy1589:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1648;
		if(yych <= 'R')	goto yy239;
		goto yy1646;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1648;
		} else {
			if(yych == 's')	goto yy1646;
			goto yy239;
		}
	}
yy1590:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1643;
	if(yych == 'd')	goto yy1643;
	goto yy239;
yy1591:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1640;
	if(yych == 'd')	goto yy1640;
	goto yy239;
yy1592:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1637;
	if(yych == 's')	goto yy1637;
	goto yy239;
yy1593:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= 'B'){
			if(yych == 'A')	goto yy1605;
			goto yy239;
		} else {
			if(yych <= 'C')	goto yy1602;
			if(yych <= 'D')	goto yy1604;
			if(yych <= 'N')	goto yy239;
			goto yy1603;
		}
	} else {
		if(yych <= 'c'){
			if(yych == 'a')	goto yy1605;
			if(yych <= 'b')	goto yy239;
			goto yy1602;
		} else {
			if(yych <= 'd')	goto yy1604;
			if(yych == 'o')	goto yy1603;
			goto yy239;
		}
	}
yy1594:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'L')	goto yy1600;
		if(yych <= 'R')	goto yy239;
		goto yy1598;
	} else {
		if(yych <= 'l'){
			if(yych <= 'k')	goto yy239;
			goto yy1600;
		} else {
			if(yych == 's')	goto yy1598;
			goto yy239;
		}
	}
yy1595:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1596;
	if(yych != 'r')	goto yy239;
yy1596:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3092 "./modules/arch/x86/x86id.re"
{ RET_INSN(prot286, 0x0300, CPU_286|CPU_Prot|CPU_Priv); }
#line 10472 "x86id.c"
yy1598:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2740 "./modules/arch/x86/x86id.re"
{ RET_INSN(lfgss, 0xB6, CPU_386); }
#line 10478 "x86id.c"
yy1600:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3091 "./modules/arch/x86/x86id.re"
{ RET_INSN(bsfr, 0x03, CPU_286|CPU_Prot); }
#line 10484 "x86id.c"
yy1602:	yych = *++YYCURSOR;
	if(yych == 'K')	goto yy1635;
	if(yych == 'k')	goto yy1635;
	goto yy239;
yy1603:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1624;
	if(yych == 'p')	goto yy1624;
	goto yy239;
yy1604:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1615;
	if(yych == 's')	goto yy1615;
	goto yy239;
yy1605:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1606;
	if(yych != 'd')	goto yy239;
yy1606:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1607;
	if(yych != 'a')	goto yy239;
yy1607:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy1608;
	if(yych != 'l')	goto yy239;
yy1608:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy1609;
	if(yych != 'l')	goto yy239;
yy1609:	yych = *++YYCURSOR;
	if(yych <= '\000')	goto yy1610;
	if(yych == '2')	goto yy1611;
	goto yy238;
yy1610:
#line 3546 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F07, CPU_386|CPU_Undoc); }
#line 10516 "x86id.c"
yy1611:	yych = *++YYCURSOR;
	if(yych != '8')	goto yy239;
	yych = *++YYCURSOR;
	if(yych != '6')	goto yy239;
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3547 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F05, CPU_286|CPU_Undoc); }
#line 10526 "x86id.c"
yy1615:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'D'){
			if(yych == 'B')	goto yy1616;
			if(yych <= 'C')	goto yy239;
			goto yy1620;
		} else {
			if(yych == 'Q')	goto yy1622;
			if(yych <= 'V')	goto yy239;
			goto yy1618;
		}
	} else {
		if(yych <= 'd'){
			if(yych == 'b')	goto yy1616;
			if(yych <= 'c')	goto yy239;
			goto yy1620;
		} else {
			if(yych <= 'q'){
				if(yych <= 'p')	goto yy239;
				goto yy1622;
			} else {
				if(yych == 'w')	goto yy1618;
				goto yy239;
			}
		}
	}
yy1616:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2989 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00AC, CPU_Any); }
#line 10558 "x86id.c"
yy1618:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2990 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x10AD, CPU_Any); }
#line 10564 "x86id.c"
yy1620:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2991 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x20AD, CPU_386); }
#line 10570 "x86id.c"
yy1622:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2992 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is an instruction in 64-bit mode"),
			      oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    RET_INSN(onebyte, 0x40AD, CPU_Hammer|CPU_64);
	}
#line 10584 "x86id.c"
yy1624:	yych = *++YYCURSOR;
	if(yych <= 'Z'){
		if(yych <= 'E'){
			if(yych <= '\000')	goto yy1625;
			if(yych <= 'D')	goto yy238;
			goto yy1628;
		} else {
			if(yych == 'N')	goto yy1630;
			if(yych <= 'Y')	goto yy238;
			goto yy1626;
		}
	} else {
		if(yych <= 'm'){
			if(yych == 'e')	goto yy1628;
			goto yy238;
		} else {
			if(yych <= 'n')	goto yy1630;
			if(yych == 'z')	goto yy1626;
			goto yy238;
		}
	}
yy1625:
#line 2934 "./modules/arch/x86/x86id.re"
{ RET_INSN(loop, 0x02, CPU_Any); }
#line 10609 "x86id.c"
yy1626:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2935 "./modules/arch/x86/x86id.re"
{ RET_INSN(loop, 0x01, CPU_Any); }
#line 10615 "x86id.c"
yy1628:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2936 "./modules/arch/x86/x86id.re"
{ RET_INSN(loop, 0x01, CPU_Any); }
#line 10621 "x86id.c"
yy1630:	yych = *++YYCURSOR;
	if(yych <= 'Z'){
		if(yych == 'E')	goto yy1631;
		if(yych <= 'Y')	goto yy239;
		goto yy1633;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy239;
		} else {
			if(yych == 'z')	goto yy1633;
			goto yy239;
		}
	}
yy1631:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2938 "./modules/arch/x86/x86id.re"
{ RET_INSN(loop, 0x00, CPU_Any); }
#line 10640 "x86id.c"
yy1633:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2937 "./modules/arch/x86/x86id.re"
{ RET_INSN(loop, 0x00, CPU_Any); }
#line 10646 "x86id.c"
yy1635:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2329 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_LOCKREP; 
	    data[1] = 0xF0;
	    return YASM_ARCH_CHECK_ID_PREFIX;
	}
#line 10656 "x86id.c"
yy1637:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy1638;
	if(yych != 'w')	goto yy239;
yy1638:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3090 "./modules/arch/x86/x86id.re"
{ RET_INSN(prot286, 0x0601, CPU_286|CPU_Priv); }
#line 10665 "x86id.c"
yy1640:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1641;
	if(yych != 't')	goto yy239;
yy1641:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3089 "./modules/arch/x86/x86id.re"
{ RET_INSN(prot286, 0x0200, CPU_286|CPU_Prot|CPU_Priv); }
#line 10674 "x86id.c"
yy1643:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1644;
	if(yych != 't')	goto yy239;
yy1644:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3088 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x030F01, CPU_286|CPU_Priv); }
#line 10683 "x86id.c"
yy1646:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2739 "./modules/arch/x86/x86id.re"
{ RET_INSN(lfgss, 0xB5, CPU_386); }
#line 10689 "x86id.c"
yy1648:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1649;
	if(yych != 't')	goto yy239;
yy1649:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3087 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x020F01, CPU_286|CPU_Priv); }
#line 10698 "x86id.c"
yy1651:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2738 "./modules/arch/x86/x86id.re"
{ RET_INSN(lfgss, 0xB4, CPU_386); }
#line 10704 "x86id.c"
yy1653:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1654;
	if(yych != 'n')	goto yy239;
yy1654:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1655;
	if(yych != 'c')	goto yy239;
yy1655:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1656;
	if(yych != 'e')	goto yy239;
yy1656:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3264 "./modules/arch/x86/x86id.re"
{ RET_INSN(threebyte, 0x0FAEE8, CPU_P3); }
#line 10719 "x86id.c"
yy1658:	yych = *++YYCURSOR;
	if(yych <= 'V'){
		if(yych <= '\000')	goto yy1659;
		if(yych <= 'U')	goto yy238;
		goto yy1662;
	} else {
		if(yych == 'v')	goto yy1662;
		goto yy238;
	}
yy1659:
#line 2722 "./modules/arch/x86/x86id.re"
{ RET_INSN(lea, 0, CPU_Any); }
#line 10732 "x86id.c"
yy1660:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2731 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(ldes, 0xC4, CPU_Any);
	}
#line 10744 "x86id.c"
yy1662:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1663;
	if(yych != 'e')	goto yy239;
yy1663:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2890 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00C9, CPU_186); }
#line 10753 "x86id.c"
yy1665:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2724 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(ldes, 0xC5, CPU_Any);
	}
#line 10765 "x86id.c"
yy1667:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy1668;
	if(yych != 'x')	goto yy239;
yy1668:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1669;
	if(yych != 'c')	goto yy239;
yy1669:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1670;
	if(yych != 's')	goto yy239;
yy1670:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1671;
	if(yych != 'r')	goto yy239;
yy1671:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3349 "./modules/arch/x86/x86id.re"
{ RET_INSN(ldstmxcsr, 0x02, CPU_SSE); }
#line 10783 "x86id.c"
yy1673:	yych = *++YYCURSOR;
	if(yych == 'F')	goto yy1676;
	if(yych == 'f')	goto yy1676;
	goto yy239;
yy1674:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3086 "./modules/arch/x86/x86id.re"
{ RET_INSN(bsfr, 0x02, CPU_286|CPU_Prot); }
#line 10793 "x86id.c"
yy1676:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2747 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
 	    RET_INSN(onebyte, 0x009F, CPU_Any);
	}
#line 10805 "x86id.c"
yy1678:	yych = *++YYCURSOR;
	if(yych == '6')	goto yy1733;
	goto yy239;
yy1679:	yych = *++YYCURSOR;
	if(yych == '2')	goto yy1731;
	goto yy239;
yy1680:	yych = *++YYCURSOR;
	if(yych == '4')	goto yy1729;
	goto yy239;
yy1681:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= 'D'){
			if(yych == 'A')	goto yy1721;
			if(yych <= 'C')	goto yy239;
			goto yy1725;
		} else {
			if(yych == 'M')	goto yy1727;
			if(yych <= 'R')	goto yy239;
			goto yy1723;
		}
	} else {
		if(yych <= 'd'){
			if(yych == 'a')	goto yy1721;
			if(yych <= 'c')	goto yy239;
			goto yy1725;
		} else {
			if(yych <= 'm'){
				if(yych <= 'l')	goto yy239;
				goto yy1727;
			} else {
				if(yych == 's')	goto yy1723;
				goto yy239;
			}
		}
	}
yy1682:	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= 'B')	goto yy239;
		if(yych <= 'C')	goto yy1709;
		goto yy1707;
	} else {
		if(yych <= 'b')	goto yy239;
		if(yych <= 'c')	goto yy1709;
		if(yych <= 'd')	goto yy1707;
		goto yy239;
	}
yy1683:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2558 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG8 | 4; return YASM_ARCH_CHECK_ID_REG; }
#line 10857 "x86id.c"
yy1685:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2554 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG8 | 0; return YASM_ARCH_CHECK_ID_REG; }
#line 10863 "x86id.c"
yy1687:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1694;
	if(yych == 'd')	goto yy1694;
	goto yy239;
yy1688:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1691;
	if(yych == 'p')	goto yy1691;
	goto yy239;
yy1689:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2527 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG16 | 0; return YASM_ARCH_CHECK_ID_REG; }
#line 10877 "x86id.c"
yy1691:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy1692;
	if(yych != 'l')	goto yy239;
yy1692:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3079 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(arpl, 0, CPU_286|CPU_Prot);
	}
#line 10892 "x86id.c"
yy1694:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= 'M'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'N')	goto yy1696;
			if(yych <= 'O')	goto yy238;
			goto yy1697;
		}
	} else {
		if(yych <= 'n'){
			if(yych <= 'm')	goto yy238;
			goto yy1696;
		} else {
			if(yych == 'p')	goto yy1697;
			goto yy238;
		}
	}

#line 2796 "./modules/arch/x86/x86id.re"
{ RET_INSN(arith, 0x0420, CPU_Any); }
#line 10914 "x86id.c"
yy1696:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1702;
	if(yych == 'p')	goto yy1702;
	goto yy239;
yy1697:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1700;
		if(yych <= 'R')	goto yy239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1700;
		} else {
			if(yych != 's')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3321 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x54, CPU_SSE); }
#line 10936 "x86id.c"
yy1700:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3403 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x6654, CPU_SSE2); }
#line 10942 "x86id.c"
yy1702:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1703;
		if(yych <= 'R')	goto yy239;
		goto yy1705;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1705;
			goto yy239;
		}
	}
yy1703:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3402 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x6655, CPU_SSE2); }
#line 10961 "x86id.c"
yy1705:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3320 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x55, CPU_SSE); }
#line 10967 "x86id.c"
yy1707:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= 'O'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'P')	goto yy1711;
			if(yych <= 'R')	goto yy238;
			goto yy1712;
		}
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy238;
			goto yy1711;
		} else {
			if(yych == 's')	goto yy1712;
			goto yy238;
		}
	}

#line 2789 "./modules/arch/x86/x86id.re"
{ RET_INSN(arith, 0x0000, CPU_Any); }
#line 10989 "x86id.c"
yy1709:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2799 "./modules/arch/x86/x86id.re"
{ RET_INSN(arith, 0x0210, CPU_Any); }
#line 10995 "x86id.c"
yy1711:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1719;
		if(yych <= 'R')	goto yy239;
		goto yy1717;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1719;
		} else {
			if(yych == 's')	goto yy1717;
			goto yy239;
		}
	}
yy1712:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1715;
		if(yych <= 'R')	goto yy239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy1715;
		} else {
			if(yych != 's')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3319 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF358, CPU_SSE); }
#line 11027 "x86id.c"
yy1715:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3401 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF258, CPU_SSE2); }
#line 11033 "x86id.c"
yy1717:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3318 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x58, CPU_SSE); }
#line 11039 "x86id.c"
yy1719:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3400 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x6658, CPU_SSE2); }
#line 11045 "x86id.c"
yy1721:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2802 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(onebyte, 0x0037, CPU_Any);
	}
#line 11057 "x86id.c"
yy1723:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2809 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(onebyte, 0x003F, CPU_Any);
	}
#line 11069 "x86id.c"
yy1725:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2830 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(aadm, 0x01, CPU_Any);
	}
#line 11081 "x86id.c"
yy1727:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2837 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(aadm, 0x00, CPU_Any);
	}
#line 11093 "x86id.c"
yy1729:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2317 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a prefix in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_ADDRSIZE;
	    data[1] = 64;
	    return YASM_ARCH_CHECK_ID_PREFIX;
	}
#line 11108 "x86id.c"
yy1731:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2312 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_ADDRSIZE;
	    data[1] = 32;
	    return YASM_ARCH_CHECK_ID_PREFIX;
	}
#line 11118 "x86id.c"
yy1733:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2302 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex,
		    N_("Cannot override address size to 16 bits in 64-bit mode"));
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_ADDRSIZE;
	    data[1] = 16;
	    return YASM_ARCH_CHECK_ID_PREFIX;
	}
#line 11133 "x86id.c"
yy1735:	yych = *++YYCURSOR;
	if(yych == '6')	goto yy1759;
	goto yy239;
yy1736:	yych = *++YYCURSOR;
	if(yych == '2')	goto yy1757;
	goto yy239;
yy1737:	yych = *++YYCURSOR;
	if(yych == '4')	goto yy1755;
	goto yy239;
yy1738:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy1739;
		if(yych <= 'O')	goto yy238;
		goto yy1750;
	} else {
		if(yych == 'p')	goto yy1750;
		goto yy238;
	}
yy1739:
#line 2797 "./modules/arch/x86/x86id.re"
{ RET_INSN(arith, 0x0108, CPU_Any); }
#line 11155 "x86id.c"
yy1740:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1741;
	if(yych != 't')	goto yy239;
yy1741:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= '\000')	goto yy1742;
		if(yych <= 'R')	goto yy238;
		goto yy1743;
	} else {
		if(yych == 's')	goto yy1743;
		goto yy238;
	}
yy1742:
#line 2720 "./modules/arch/x86/x86id.re"
{ RET_INSN(out, 0, CPU_Any); }
#line 11171 "x86id.c"
yy1743:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'C'){
			if(yych != 'B')	goto yy239;
		} else {
			if(yych <= 'D')	goto yy1748;
			if(yych <= 'V')	goto yy239;
			goto yy1746;
		}
	} else {
		if(yych <= 'c'){
			if(yych != 'b')	goto yy239;
		} else {
			if(yych <= 'd')	goto yy1748;
			if(yych == 'w')	goto yy1746;
			goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2986 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x006E, CPU_Any); }
#line 11195 "x86id.c"
yy1746:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2987 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x106F, CPU_Any); }
#line 11201 "x86id.c"
yy1748:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2988 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x206F, CPU_386); }
#line 11207 "x86id.c"
yy1750:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy1751;
		if(yych <= 'R')	goto yy239;
		goto yy1753;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy1753;
			goto yy239;
		}
	}
yy1751:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3441 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x6656, CPU_SSE2); }
#line 11226 "x86id.c"
yy1753:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3367 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x56, CPU_SSE); }
#line 11232 "x86id.c"
yy1755:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2291 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a prefix in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_OPERSIZE;
	    data[1] = 64;
	    return YASM_ARCH_CHECK_ID_PREFIX;
	}
#line 11247 "x86id.c"
yy1757:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2286 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_OPERSIZE;
	    data[1] = 32;
	    return YASM_ARCH_CHECK_ID_PREFIX;
	}
#line 11257 "x86id.c"
yy1759:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2281 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_OPERSIZE;
	    data[1] = 16;
	    return YASM_ARCH_CHECK_ID_PREFIX;
	}
#line 11267 "x86id.c"
yy1761:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1767;
	if(yych == 's')	goto yy1767;
	goto yy239;
yy1762:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2275 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_TO;
	    return YASM_ARCH_CHECK_ID_TARGETMOD;
	}
#line 11280 "x86id.c"
yy1764:	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy239;
	if(yych >= '8')	goto yy239;
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2374 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_TRREG | (oid[2]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 11292 "x86id.c"
yy1767:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1768;
	if(yych != 't')	goto yy239;
yy1768:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2795 "./modules/arch/x86/x86id.re"
{ RET_INSN(test, 0, CPU_Any); }
#line 11301 "x86id.c"
yy1770:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy2097;
	if(yych == 'x')	goto yy2097;
	goto yy239;
yy1771:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= 'C'){
			if(yych == 'B')	goto yy2090;
			goto yy239;
		} else {
			if(yych <= 'D')	goto yy2089;
			if(yych <= 'Q')	goto yy239;
			goto yy2087;
		}
	} else {
		if(yych <= 'c'){
			if(yych == 'b')	goto yy2090;
			goto yy239;
		} else {
			if(yych <= 'd')	goto yy2089;
			if(yych == 'r')	goto yy2087;
			goto yy239;
		}
	}
yy1772:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'L')	goto yy2080;
		if(yych <= 'R')	goto yy239;
		goto yy2081;
	} else {
		if(yych <= 'l'){
			if(yych <= 'k')	goto yy239;
			goto yy2080;
		} else {
			if(yych == 's')	goto yy2081;
			goto yy239;
		}
	}
yy1773:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= 'K'){
			if(yych == 'H')	goto yy2043;
			goto yy239;
		} else {
			if(yych <= 'L')	goto yy2044;
			if(yych <= 'M')	goto yy2045;
			if(yych <= 'N')	goto yy239;
			goto yy2042;
		}
	} else {
		if(yych <= 'l'){
			if(yych == 'h')	goto yy2043;
			if(yych <= 'k')	goto yy239;
			goto yy2044;
		} else {
			if(yych <= 'm')	goto yy2045;
			if(yych == 'o')	goto yy2042;
			goto yy239;
		}
	}
yy1774:	yych = *++YYCURSOR;
	if(yych <= 'I'){
		if(yych == 'E')	goto yy2028;
		if(yych <= 'H')	goto yy239;
		goto yy2027;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy239;
			goto yy2028;
		} else {
			if(yych == 'i')	goto yy2027;
			goto yy239;
		}
	}
yy1775:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy2023;
	if(yych == 'm')	goto yy2023;
	goto yy239;
yy1776:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy2017;
	if(yych == 'r')	goto yy2017;
	goto yy239;
yy1777:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy1978;
	case 'C':	case 'c':	goto yy1977;
	case 'D':	case 'd':	goto yy1980;
	case 'L':	case 'l':	goto yy1975;
	case 'M':	case 'm':	goto yy1979;
	case 'N':	case 'n':	goto yy1981;
	case 'S':	case 's':	goto yy1976;
	default:	goto yy239;
	}
yy1778:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1947;
	if(yych == 'd')	goto yy1947;
	goto yy239;
yy1779:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy1942;
	if(yych == 'u')	goto yy1942;
	goto yy239;
yy1780:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= 'I'){
			if(yych == 'C')	goto yy1915;
			if(yych <= 'H')	goto yy239;
			goto yy1913;
		} else {
			if(yych == 'O')	goto yy1916;
			if(yych <= 'R')	goto yy239;
			goto yy1914;
		}
	} else {
		if(yych <= 'i'){
			if(yych == 'c')	goto yy1915;
			if(yych <= 'h')	goto yy239;
			goto yy1913;
		} else {
			if(yych <= 'o'){
				if(yych <= 'n')	goto yy239;
				goto yy1916;
			} else {
				if(yych == 's')	goto yy1914;
				goto yy239;
			}
		}
	}
yy1781:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= 'Q'){
			if(yych == 'A')	goto yy1899;
			goto yy239;
		} else {
			if(yych <= 'R')	goto yy1900;
			if(yych <= 'S')	goto yy239;
			goto yy1898;
		}
	} else {
		if(yych <= 'q'){
			if(yych == 'a')	goto yy1899;
			goto yy239;
		} else {
			if(yych <= 'r')	goto yy1900;
			if(yych == 't')	goto yy1898;
			goto yy239;
		}
	}
yy1782:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'N')	goto yy1887;
		if(yych <= 'R')	goto yy239;
		goto yy1888;
	} else {
		if(yych <= 'n'){
			if(yych <= 'm')	goto yy239;
			goto yy1887;
		} else {
			if(yych == 's')	goto yy1888;
			goto yy239;
		}
	}
yy1783:	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'E'){
			if(yych <= 'A'){
				if(yych <= '\000')	goto yy1784;
				if(yych <= '@')	goto yy238;
				goto yy1845;
			} else {
				if(yych == 'C')	goto yy1844;
				if(yych <= 'D')	goto yy238;
				goto yy1846;
			}
		} else {
			if(yych <= 'P'){
				if(yych == 'I')	goto yy1843;
				goto yy238;
			} else {
				if(yych <= 'Q')	goto yy1842;
				if(yych <= 'S')	goto yy238;
				if(yych <= 'T')	goto yy1839;
				goto yy1841;
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'b'){
				if(yych == 'a')	goto yy1845;
				goto yy238;
			} else {
				if(yych <= 'c')	goto yy1844;
				if(yych == 'e')	goto yy1846;
				goto yy238;
			}
		} else {
			if(yych <= 'q'){
				if(yych <= 'i')	goto yy1843;
				if(yych <= 'p')	goto yy238;
				goto yy1842;
			} else {
				if(yych <= 's')	goto yy238;
				if(yych <= 't')	goto yy1839;
				if(yych <= 'u')	goto yy1841;
				goto yy238;
			}
		}
	}
yy1784:
#line 2640 "./modules/arch/x86/x86id.re"
{ data[0] = 0x6404; return YASM_ARCH_CHECK_ID_SEGREG; }
#line 11512 "x86id.c"
yy1785:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1836;
	if(yych == 's')	goto yy1836;
	goto yy239;
yy1786:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1824;
	if(yych == 'c')	goto yy1824;
	goto yy239;
yy1787:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1820;
	if(yych == 'a')	goto yy1820;
	goto yy239;
yy1788:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= 'C'){
			if(yych == 'A')	goto yy1798;
			if(yych <= 'B')	goto yy239;
			goto yy1797;
		} else {
			if(yych <= 'Q')	goto yy239;
			if(yych <= 'R')	goto yy1801;
			if(yych <= 'S')	goto yy1800;
			goto yy1799;
		}
	} else {
		if(yych <= 'c'){
			if(yych == 'a')	goto yy1798;
			if(yych <= 'b')	goto yy239;
			goto yy1797;
		} else {
			if(yych <= 'r'){
				if(yych <= 'q')	goto yy239;
				goto yy1801;
			} else {
				if(yych <= 's')	goto yy1800;
				if(yych <= 't')	goto yy1799;
				goto yy239;
			}
		}
	}
yy1789:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy1790;
	if(yych != 'l')	goto yy239;
yy1790:	yych = *++YYCURSOR;
	if(yych != '2')	goto yy239;
	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy1792;
	if(yych != 'x')	goto yy239;
yy1792:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy1793;
		if(yych <= 'O')	goto yy238;
		goto yy1794;
	} else {
		if(yych == 'p')	goto yy1794;
		goto yy238;
	}
yy1793:
#line 3146 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9F1, CPU_FPU); }
#line 11573 "x86id.c"
yy1794:	yych = *++YYCURSOR;
	if(yych != '1')	goto yy239;
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3154 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9F9, CPU_FPU); }
#line 11581 "x86id.c"
yy1797:	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy1818;
	if(yych == 'h')	goto yy1818;
	goto yy239;
yy1798:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy1816;
	if(yych == 'm')	goto yy1816;
	goto yy239;
yy1799:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1811;
	if(yych == 'r')	goto yy1811;
	goto yy239;
yy1800:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1807;
	if(yych == 'a')	goto yy1807;
	goto yy239;
yy1801:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1802;
	if(yych != 's')	goto yy239;
yy1802:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1803;
	if(yych != 't')	goto yy239;
yy1803:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy1804;
	if(yych != 'o')	goto yy239;
yy1804:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1805;
	if(yych != 'r')	goto yy239;
yy1805:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3215 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x010FAE, CPU_686|CPU_FPU); }
#line 11615 "x86id.c"
yy1807:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy1808;
	if(yych != 'v')	goto yy239;
yy1808:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1809;
	if(yych != 'e')	goto yy239;
yy1809:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3214 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x000FAE, CPU_686|CPU_FPU); }
#line 11627 "x86id.c"
yy1811:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1812;
	if(yych != 'a')	goto yy239;
yy1812:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1813;
	if(yych != 'c')	goto yy239;
yy1813:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1814;
	if(yych != 't')	goto yy239;
yy1814:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3149 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9F4, CPU_FPU); }
#line 11642 "x86id.c"
yy1816:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3119 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9E5, CPU_FPU); }
#line 11648 "x86id.c"
yy1818:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3109 "./modules/arch/x86/x86id.re"
{ RET_INSN(fxch, 0, CPU_FPU); }
#line 11654 "x86id.c"
yy1820:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1821;
	if(yych != 'i')	goto yy239;
yy1821:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1822;
	if(yych != 't')	goto yy239;
yy1822:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3181 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x009B, CPU_FPU); }
#line 11666 "x86id.c"
yy1824:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy1825;
	if(yych != 'o')	goto yy239;
yy1825:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy1826;
	if(yych != 'm')	goto yy239;
yy1826:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= 'H'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'I')	goto yy1828;
			if(yych <= 'O')	goto yy238;
			goto yy1830;
		}
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy238;
			goto yy1828;
		} else {
			if(yych == 'p')	goto yy1830;
			goto yy238;
		}
	}

#line 3115 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcom2, 0xDDE0, CPU_286|CPU_FPU); }
#line 11694 "x86id.c"
yy1828:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy1829;
		if(yych <= 'O')	goto yy238;
		goto yy1834;
	} else {
		if(yych == 'p')	goto yy1834;
		goto yy238;
	}
yy1829:
#line 3258 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcom2, 0xDBE8, CPU_686|CPU_FPU); }
#line 11707 "x86id.c"
yy1830:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy1831;
		if(yych <= 'O')	goto yy238;
		goto yy1832;
	} else {
		if(yych == 'p')	goto yy1832;
		goto yy238;
	}
yy1831:
#line 3116 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcom2, 0xDDE8, CPU_286|CPU_FPU); }
#line 11720 "x86id.c"
yy1832:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3117 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xDAE9, CPU_286|CPU_FPU); }
#line 11726 "x86id.c"
yy1834:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3260 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcom2, 0xDFE8, CPU_686|CPU_FPU); }
#line 11732 "x86id.c"
yy1836:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1837;
	if(yych != 't')	goto yy239;
yy1837:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3118 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9E4, CPU_FPU); }
#line 11741 "x86id.c"
yy1839:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= 'D'){
			if(yych <= '\000')	goto yy1840;
			if(yych == 'C')	goto yy1875;
			goto yy238;
		} else {
			if(yych <= 'O'){
				if(yych <= 'E')	goto yy1876;
				goto yy238;
			} else {
				if(yych <= 'P')	goto yy1877;
				if(yych <= 'R')	goto yy238;
				goto yy1879;
			}
		}
	} else {
		if(yych <= 'e'){
			if(yych == 'c')	goto yy1875;
			if(yych <= 'd')	goto yy238;
			goto yy1876;
		} else {
			if(yych <= 'p'){
				if(yych <= 'o')	goto yy238;
				goto yy1877;
			} else {
				if(yych == 's')	goto yy1879;
				goto yy238;
			}
		}
	}
yy1840:
#line 3104 "./modules/arch/x86/x86id.re"
{ RET_INSN(fst, 0, CPU_FPU); }
#line 11776 "x86id.c"
yy1841:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy1867;
	if(yych == 'b')	goto yy1867;
	goto yy239;
yy1842:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1864;
	if(yych == 'r')	goto yy1864;
	goto yy239;
yy1843:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1858;
	if(yych == 'n')	goto yy1858;
	goto yy239;
yy1844:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1854;
	if(yych == 'a')	goto yy1854;
	goto yy239;
yy1845:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy1851;
	if(yych == 'v')	goto yy1851;
	goto yy239;
yy1846:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1847;
	if(yych != 't')	goto yy239;
yy1847:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1848;
	if(yych != 'p')	goto yy239;
yy1848:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy1849;
	if(yych != 'm')	goto yy239;
yy1849:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3544 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xDBE4, CPU_286|CPU_FPU|CPU_Obs); }
#line 11811 "x86id.c"
yy1851:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1852;
	if(yych != 'e')	goto yy239;
yy1852:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3176 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x069BDD, CPU_FPU); }
#line 11820 "x86id.c"
yy1854:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy1855;
	if(yych != 'l')	goto yy239;
yy1855:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1856;
	if(yych != 'e')	goto yy239;
yy1856:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3158 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9FD, CPU_FPU); }
#line 11832 "x86id.c"
yy1858:	yych = *++YYCURSOR;
	if(yych <= 'C'){
		if(yych <= '\000')	goto yy1859;
		if(yych <= 'B')	goto yy238;
		goto yy1860;
	} else {
		if(yych == 'c')	goto yy1860;
		goto yy238;
	}
yy1859:
#line 3159 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9FE, CPU_286|CPU_FPU); }
#line 11845 "x86id.c"
yy1860:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy1861;
	if(yych != 'o')	goto yy239;
yy1861:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1862;
	if(yych != 's')	goto yy239;
yy1862:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3156 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9FB, CPU_286|CPU_FPU); }
#line 11857 "x86id.c"
yy1864:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1865;
	if(yych != 't')	goto yy239;
yy1865:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3155 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9FA, CPU_FPU); }
#line 11866 "x86id.c"
yy1867:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= 'O'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'P')	goto yy1869;
			if(yych <= 'Q')	goto yy238;
			goto yy1871;
		}
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy238;
			goto yy1869;
		} else {
			if(yych == 'r')	goto yy1871;
			goto yy238;
		}
	}

#line 3130 "./modules/arch/x86/x86id.re"
{ RET_INSN(farith, 0x04E0E8, CPU_FPU); }
#line 11888 "x86id.c"
yy1869:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3132 "./modules/arch/x86/x86id.re"
{ RET_INSN(farithp, 0xE8, CPU_FPU); }
#line 11894 "x86id.c"
yy1871:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy1872;
		if(yych <= 'O')	goto yy238;
		goto yy1873;
	} else {
		if(yych == 'p')	goto yy1873;
		goto yy238;
	}
yy1872:
#line 3133 "./modules/arch/x86/x86id.re"
{ RET_INSN(farith, 0x05E8E0, CPU_FPU); }
#line 11907 "x86id.c"
yy1873:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3135 "./modules/arch/x86/x86id.re"
{ RET_INSN(farithp, 0xE0, CPU_FPU); }
#line 11913 "x86id.c"
yy1875:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy1885;
	if(yych == 'w')	goto yy1885;
	goto yy239;
yy1876:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1882;
	if(yych == 'n')	goto yy1882;
	goto yy239;
yy1877:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3106 "./modules/arch/x86/x86id.re"
{ RET_INSN(fldstp, 0x0703D8, CPU_FPU); }
#line 11927 "x86id.c"
yy1879:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy1880;
	if(yych != 'w')	goto yy239;
yy1880:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3169 "./modules/arch/x86/x86id.re"
{ RET_INSN(fstsw, 0, CPU_FPU); }
#line 11936 "x86id.c"
yy1882:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy1883;
	if(yych != 'v')	goto yy239;
yy1883:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3173 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x069BD9, CPU_FPU); }
#line 11945 "x86id.c"
yy1885:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3167 "./modules/arch/x86/x86id.re"
{ RET_INSN(fstcw, 0, CPU_FPU); }
#line 11951 "x86id.c"
yy1887:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1893;
	if(yych == 'd')	goto yy1893;
	goto yy239;
yy1888:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1889;
	if(yych != 't')	goto yy239;
yy1889:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy1890;
	if(yych != 'o')	goto yy239;
yy1890:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1891;
	if(yych != 'r')	goto yy239;
yy1891:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3177 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebytemem, 0x04DD, CPU_FPU); }
#line 11970 "x86id.c"
yy1893:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1894;
	if(yych != 'i')	goto yy239;
yy1894:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1895;
	if(yych != 'n')	goto yy239;
yy1895:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1896;
	if(yych != 't')	goto yy239;
yy1896:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3157 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9FC, CPU_FPU); }
#line 11985 "x86id.c"
yy1898:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1910;
	if(yych == 'a')	goto yy1910;
	goto yy239;
yy1899:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1906;
	if(yych == 't')	goto yy1906;
	goto yy239;
yy1900:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1901;
	if(yych != 'e')	goto yy239;
yy1901:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy1902;
	if(yych != 'm')	goto yy239;
yy1902:	yych = *++YYCURSOR;
	if(yych <= '\000')	goto yy1903;
	if(yych == '1')	goto yy1904;
	goto yy238;
yy1903:
#line 3153 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9F8, CPU_FPU); }
#line 12007 "x86id.c"
yy1904:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3150 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9F5, CPU_286|CPU_FPU); }
#line 12013 "x86id.c"
yy1906:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1907;
	if(yych != 'a')	goto yy239;
yy1907:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1908;
	if(yych != 'n')	goto yy239;
yy1908:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3148 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9F3, CPU_FPU); }
#line 12025 "x86id.c"
yy1910:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1911;
	if(yych != 'n')	goto yy239;
yy1911:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3147 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9F2, CPU_FPU); }
#line 12034 "x86id.c"
yy1913:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1938;
	if(yych == 'n')	goto yy1938;
	goto yy239;
yy1914:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych == 'A')	goto yy1923;
		if(yych <= 'S')	goto yy239;
		goto yy1924;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy239;
			goto yy1923;
		} else {
			if(yych == 't')	goto yy1924;
			goto yy239;
		}
	}
yy1915:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy1919;
	if(yych == 'l')	goto yy1919;
	goto yy239;
yy1916:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1917;
	if(yych != 'p')	goto yy239;
yy1917:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3180 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9D0, CPU_FPU); }
#line 12065 "x86id.c"
yy1919:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1920;
	if(yych != 'e')	goto yy239;
yy1920:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy1921;
	if(yych != 'x')	goto yy239;
yy1921:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3170 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xDBE2, CPU_FPU); }
#line 12077 "x86id.c"
yy1923:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy1935;
	if(yych == 'v')	goto yy1935;
	goto yy239;
yy1924:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= 'D'){
			if(yych != 'C')	goto yy239;
		} else {
			if(yych <= 'E')	goto yy1927;
			if(yych <= 'R')	goto yy239;
			goto yy1926;
		}
	} else {
		if(yych <= 'd'){
			if(yych != 'c')	goto yy239;
		} else {
			if(yych <= 'e')	goto yy1927;
			if(yych == 's')	goto yy1926;
			goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy1933;
	if(yych == 'w')	goto yy1933;
	goto yy239;
yy1926:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy1931;
	if(yych == 'w')	goto yy1931;
	goto yy239;
yy1927:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1928;
	if(yych != 'n')	goto yy239;
yy1928:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy1929;
	if(yych != 'v')	goto yy239;
yy1929:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3172 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebytemem, 0x06D9, CPU_FPU); }
#line 12119 "x86id.c"
yy1931:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3168 "./modules/arch/x86/x86id.re"
{ RET_INSN(fnstsw, 0, CPU_FPU); }
#line 12125 "x86id.c"
yy1933:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3166 "./modules/arch/x86/x86id.re"
{ RET_INSN(fldnstcw, 0x07, CPU_FPU); }
#line 12131 "x86id.c"
yy1935:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1936;
	if(yych != 'e')	goto yy239;
yy1936:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3175 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebytemem, 0x06DD, CPU_FPU); }
#line 12140 "x86id.c"
yy1938:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1939;
	if(yych != 'i')	goto yy239;
yy1939:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1940;
	if(yych != 't')	goto yy239;
yy1940:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3163 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xDBE3, CPU_FPU); }
#line 12152 "x86id.c"
yy1942:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy1943;
	if(yych != 'l')	goto yy239;
yy1943:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy1944;
		if(yych <= 'O')	goto yy238;
		goto yy1945;
	} else {
		if(yych == 'p')	goto yy1945;
		goto yy238;
	}
yy1944:
#line 3136 "./modules/arch/x86/x86id.re"
{ RET_INSN(farith, 0x01C8C8, CPU_FPU); }
#line 12168 "x86id.c"
yy1945:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3138 "./modules/arch/x86/x86id.re"
{ RET_INSN(farithp, 0xC8, CPU_FPU); }
#line 12174 "x86id.c"
yy1947:	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych <= 'D'){
			if(yych <= '1'){
				if(yych <= '\000')	goto yy1948;
				if(yych <= '0')	goto yy238;
				goto yy1949;
			} else {
				if(yych == 'C')	goto yy1951;
				goto yy238;
			}
		} else {
			if(yych <= 'L'){
				if(yych <= 'E')	goto yy1952;
				if(yych <= 'K')	goto yy238;
				goto yy1953;
			} else {
				if(yych == 'P')	goto yy1954;
				goto yy238;
			}
		}
	} else {
		if(yych <= 'k'){
			if(yych <= 'c'){
				if(yych <= 'Z')	goto yy1955;
				if(yych <= 'b')	goto yy238;
				goto yy1951;
			} else {
				if(yych == 'e')	goto yy1952;
				goto yy238;
			}
		} else {
			if(yych <= 'p'){
				if(yych <= 'l')	goto yy1953;
				if(yych <= 'o')	goto yy238;
				goto yy1954;
			} else {
				if(yych == 'z')	goto yy1955;
				goto yy238;
			}
		}
	}
yy1948:
#line 3101 "./modules/arch/x86/x86id.re"
{ RET_INSN(fldstp, 0x0500C0, CPU_FPU); }
#line 12220 "x86id.c"
yy1949:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3120 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9E8, CPU_FPU); }
#line 12226 "x86id.c"
yy1951:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy1973;
	if(yych == 'w')	goto yy1973;
	goto yy239;
yy1952:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1970;
	if(yych == 'n')	goto yy1970;
	goto yy239;
yy1953:	yych = *++YYCURSOR;
	if(yych <= 'M'){
		if(yych <= '2'){
			if(yych <= '1')	goto yy239;
			goto yy1959;
		} else {
			if(yych == 'G')	goto yy1960;
			goto yy239;
		}
	} else {
		if(yych <= 'g'){
			if(yych <= 'N')	goto yy1961;
			if(yych <= 'f')	goto yy239;
			goto yy1960;
		} else {
			if(yych == 'n')	goto yy1961;
			goto yy239;
		}
	}
yy1954:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1957;
	if(yych == 'i')	goto yy1957;
	goto yy239;
yy1955:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3126 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9EE, CPU_FPU); }
#line 12263 "x86id.c"
yy1957:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3123 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9EB, CPU_FPU); }
#line 12269 "x86id.c"
yy1959:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych == 'E')	goto yy1966;
		if(yych <= 'S')	goto yy239;
		goto yy1968;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy239;
			goto yy1966;
		} else {
			if(yych == 't')	goto yy1968;
			goto yy239;
		}
	}
yy1960:	yych = *++YYCURSOR;
	if(yych == '2')	goto yy1964;
	goto yy239;
yy1961:	yych = *++YYCURSOR;
	if(yych != '2')	goto yy239;
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3125 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9ED, CPU_FPU); }
#line 12294 "x86id.c"
yy1964:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3124 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9EC, CPU_FPU); }
#line 12300 "x86id.c"
yy1966:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3122 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9EA, CPU_FPU); }
#line 12306 "x86id.c"
yy1968:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3121 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9E9, CPU_FPU); }
#line 12312 "x86id.c"
yy1970:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy1971;
	if(yych != 'v')	goto yy239;
yy1971:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3174 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebytemem, 0x04D9, CPU_FPU); }
#line 12321 "x86id.c"
yy1973:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3165 "./modules/arch/x86/x86id.re"
{ RET_INSN(fldnstcw, 0x05, CPU_FPU); }
#line 12327 "x86id.c"
yy1975:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy2015;
	if(yych == 'd')	goto yy2015;
	goto yy239;
yy1976:	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'S')	goto yy239;
		if(yych <= 'T')	goto yy2006;
		goto yy2008;
	} else {
		if(yych <= 's')	goto yy239;
		if(yych <= 't')	goto yy2006;
		if(yych <= 'u')	goto yy2008;
		goto yy239;
	}
yy1977:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy2001;
	if(yych == 'o')	goto yy2001;
	goto yy239;
yy1978:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1998;
	if(yych == 'd')	goto yy1998;
	goto yy239;
yy1979:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy1995;
	if(yych == 'u')	goto yy1995;
	goto yy239;
yy1980:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1990;
	if(yych == 'i')	goto yy1990;
	goto yy239;
yy1981:	yych = *++YYCURSOR;
	if(yych <= 'I'){
		if(yych == 'C')	goto yy1982;
		if(yych <= 'H')	goto yy239;
		goto yy1983;
	} else {
		if(yych <= 'c'){
			if(yych <= 'b')	goto yy239;
		} else {
			if(yych == 'i')	goto yy1983;
			goto yy239;
		}
	}
yy1982:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1986;
	if(yych == 's')	goto yy1986;
	goto yy239;
yy1983:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1984;
	if(yych != 't')	goto yy239;
yy1984:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3164 "./modules/arch/x86/x86id.re"
{ RET_INSN(threebyte, 0x98DBE3UL, CPU_FPU); }
#line 12384 "x86id.c"
yy1986:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1987;
	if(yych != 't')	goto yy239;
yy1987:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1988;
	if(yych != 'p')	goto yy239;
yy1988:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3152 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9F7, CPU_FPU); }
#line 12396 "x86id.c"
yy1990:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy1991;
	if(yych != 'v')	goto yy239;
yy1991:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= '\000')	goto yy1992;
		if(yych <= 'Q')	goto yy238;
		goto yy1993;
	} else {
		if(yych == 'r')	goto yy1993;
		goto yy238;
	}
yy1992:
#line 3140 "./modules/arch/x86/x86id.re"
{ RET_INSN(fiarith, 0x06DA, CPU_FPU); }
#line 12412 "x86id.c"
yy1993:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3143 "./modules/arch/x86/x86id.re"
{ RET_INSN(fiarith, 0x07DA, CPU_FPU); }
#line 12418 "x86id.c"
yy1995:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy1996;
	if(yych != 'l')	goto yy239;
yy1996:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3137 "./modules/arch/x86/x86id.re"
{ RET_INSN(fiarith, 0x01DA, CPU_FPU); }
#line 12427 "x86id.c"
yy1998:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy1999;
	if(yych != 'd')	goto yy239;
yy1999:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3129 "./modules/arch/x86/x86id.re"
{ RET_INSN(fiarith, 0x00DA, CPU_FPU); }
#line 12436 "x86id.c"
yy2001:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy2002;
	if(yych != 'm')	goto yy239;
yy2002:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy2003;
		if(yych <= 'O')	goto yy238;
		goto yy2004;
	} else {
		if(yych == 'p')	goto yy2004;
		goto yy238;
	}
yy2003:
#line 3111 "./modules/arch/x86/x86id.re"
{ RET_INSN(fiarith, 0x02DA, CPU_FPU); }
#line 12452 "x86id.c"
yy2004:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3113 "./modules/arch/x86/x86id.re"
{ RET_INSN(fiarith, 0x03DA, CPU_FPU); }
#line 12458 "x86id.c"
yy2006:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy2007;
		if(yych <= 'O')	goto yy238;
		goto yy2013;
	} else {
		if(yych == 'p')	goto yy2013;
		goto yy238;
	}
yy2007:
#line 3105 "./modules/arch/x86/x86id.re"
{ RET_INSN(fiarith, 0x02DB, CPU_FPU); }
#line 12471 "x86id.c"
yy2008:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy2009;
	if(yych != 'b')	goto yy239;
yy2009:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= '\000')	goto yy2010;
		if(yych <= 'Q')	goto yy238;
		goto yy2011;
	} else {
		if(yych == 'r')	goto yy2011;
		goto yy238;
	}
yy2010:
#line 3131 "./modules/arch/x86/x86id.re"
{ RET_INSN(fiarith, 0x04DA, CPU_FPU); }
#line 12487 "x86id.c"
yy2011:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3134 "./modules/arch/x86/x86id.re"
{ RET_INSN(fiarith, 0x05DA, CPU_FPU); }
#line 12493 "x86id.c"
yy2013:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3107 "./modules/arch/x86/x86id.re"
{ RET_INSN(fildstp, 0x0703, CPU_FPU); }
#line 12499 "x86id.c"
yy2015:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3102 "./modules/arch/x86/x86id.re"
{ RET_INSN(fildstp, 0x0500, CPU_FPU); }
#line 12505 "x86id.c"
yy2017:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy2018;
	if(yych != 'e')	goto yy239;
yy2018:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy2019;
	if(yych != 'e')	goto yy239;
yy2019:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy2020;
		if(yych <= 'O')	goto yy238;
		goto yy2021;
	} else {
		if(yych == 'p')	goto yy2021;
		goto yy238;
	}
yy2020:
#line 3178 "./modules/arch/x86/x86id.re"
{ RET_INSN(ffree, 0xDD, CPU_FPU); }
#line 12524 "x86id.c"
yy2021:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3179 "./modules/arch/x86/x86id.re"
{ RET_INSN(ffree, 0xDF, CPU_686|CPU_FPU|CPU_Undoc); }
#line 12530 "x86id.c"
yy2023:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy2024;
	if(yych != 'm')	goto yy239;
yy2024:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy2025;
	if(yych != 's')	goto yy239;
yy2025:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3481 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F0E, CPU_3DNow); }
#line 12542 "x86id.c"
yy2027:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy2034;
	if(yych == 'v')	goto yy2034;
	goto yy239;
yy2028:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy2029;
	if(yych != 'c')	goto yy239;
yy2029:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy2030;
	if(yych != 's')	goto yy239;
yy2030:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy2031;
	if(yych != 't')	goto yy239;
yy2031:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy2032;
	if(yych != 'p')	goto yy239;
yy2032:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3151 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9F6, CPU_FPU); }
#line 12564 "x86id.c"
yy2034:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= 'O'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'P')	goto yy2036;
			if(yych <= 'Q')	goto yy238;
			goto yy2038;
		}
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy238;
			goto yy2036;
		} else {
			if(yych == 'r')	goto yy2038;
			goto yy238;
		}
	}

#line 3139 "./modules/arch/x86/x86id.re"
{ RET_INSN(farith, 0x06F0F8, CPU_FPU); }
#line 12586 "x86id.c"
yy2036:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3141 "./modules/arch/x86/x86id.re"
{ RET_INSN(farithp, 0xF8, CPU_FPU); }
#line 12592 "x86id.c"
yy2038:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy2039;
		if(yych <= 'O')	goto yy238;
		goto yy2040;
	} else {
		if(yych == 'p')	goto yy2040;
		goto yy238;
	}
yy2039:
#line 3142 "./modules/arch/x86/x86id.re"
{ RET_INSN(farith, 0x07F8F0, CPU_FPU); }
#line 12605 "x86id.c"
yy2040:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3144 "./modules/arch/x86/x86id.re"
{ RET_INSN(farithp, 0xF0, CPU_FPU); }
#line 12611 "x86id.c"
yy2042:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'M')	goto yy2068;
		if(yych <= 'R')	goto yy239;
		goto yy2070;
	} else {
		if(yych <= 'm'){
			if(yych <= 'l')	goto yy239;
			goto yy2068;
		} else {
			if(yych == 's')	goto yy2070;
			goto yy239;
		}
	}
yy2043:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy2066;
	if(yych == 's')	goto yy2066;
	goto yy239;
yy2044:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy2063;
	if(yych == 'e')	goto yy2063;
	goto yy239;
yy2045:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy2046;
	if(yych != 'o')	goto yy239;
yy2046:	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy2047;
	if(yych != 'v')	goto yy239;
yy2047:	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'E'){
			if(yych == 'B')	goto yy2048;
			if(yych <= 'D')	goto yy239;
			goto yy2050;
		} else {
			if(yych == 'N')	goto yy2052;
			if(yych <= 'T')	goto yy239;
			goto yy2053;
		}
	} else {
		if(yych <= 'e'){
			if(yych == 'b')	goto yy2048;
			if(yych <= 'd')	goto yy239;
			goto yy2050;
		} else {
			if(yych <= 'n'){
				if(yych <= 'm')	goto yy239;
				goto yy2052;
			} else {
				if(yych == 'u')	goto yy2053;
				goto yy239;
			}
		}
	}
yy2048:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy2049;
		if(yych <= 'D')	goto yy238;
		goto yy2061;
	} else {
		if(yych == 'e')	goto yy2061;
		goto yy238;
	}
yy2049:
#line 3249 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcmovcc, 0xDAC0, CPU_686|CPU_FPU); }
#line 12678 "x86id.c"
yy2050:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3250 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcmovcc, 0xDAC8, CPU_686|CPU_FPU); }
#line 12684 "x86id.c"
yy2052:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych == 'B')	goto yy2055;
		if(yych <= 'D')	goto yy239;
		goto yy2057;
	} else {
		if(yych <= 'b'){
			if(yych <= 'a')	goto yy239;
			goto yy2055;
		} else {
			if(yych == 'e')	goto yy2057;
			goto yy239;
		}
	}
yy2053:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3252 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcmovcc, 0xDAD8, CPU_686|CPU_FPU); }
#line 12704 "x86id.c"
yy2055:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy2056;
		if(yych <= 'D')	goto yy238;
		goto yy2059;
	} else {
		if(yych == 'e')	goto yy2059;
		goto yy238;
	}
yy2056:
#line 3253 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcmovcc, 0xDBC0, CPU_686|CPU_FPU); }
#line 12717 "x86id.c"
yy2057:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3254 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcmovcc, 0xDBC8, CPU_686|CPU_FPU); }
#line 12723 "x86id.c"
yy2059:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3255 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcmovcc, 0xDBD0, CPU_686|CPU_FPU); }
#line 12729 "x86id.c"
yy2061:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3251 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcmovcc, 0xDAD0, CPU_686|CPU_FPU); }
#line 12735 "x86id.c"
yy2063:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy2064;
	if(yych != 'x')	goto yy239;
yy2064:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3171 "./modules/arch/x86/x86id.re"
{ RET_INSN(threebyte, 0x98DBE2UL, CPU_FPU); }
#line 12744 "x86id.c"
yy2066:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3161 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9E0, CPU_FPU); }
#line 12750 "x86id.c"
yy2068:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= 'H'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'I')	goto yy2074;
			if(yych <= 'O')	goto yy238;
			goto yy2072;
		}
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy238;
			goto yy2074;
		} else {
			if(yych == 'p')	goto yy2072;
			goto yy238;
		}
	}

#line 3110 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcom, 0x02D0, CPU_FPU); }
#line 12772 "x86id.c"
yy2070:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3160 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9FF, CPU_286|CPU_FPU); }
#line 12778 "x86id.c"
yy2072:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy2073;
		if(yych <= 'O')	goto yy238;
		goto yy2078;
	} else {
		if(yych == 'p')	goto yy2078;
		goto yy238;
	}
yy2073:
#line 3112 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcom, 0x03D8, CPU_FPU); }
#line 12791 "x86id.c"
yy2074:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy2075;
		if(yych <= 'O')	goto yy238;
		goto yy2076;
	} else {
		if(yych == 'p')	goto yy2076;
		goto yy238;
	}
yy2075:
#line 3257 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcom2, 0xDBF0, CPU_686|CPU_FPU); }
#line 12804 "x86id.c"
yy2076:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3259 "./modules/arch/x86/x86id.re"
{ RET_INSN(fcom2, 0xDFF0, CPU_686|CPU_FPU); }
#line 12810 "x86id.c"
yy2078:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3114 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xDED9, CPU_FPU); }
#line 12816 "x86id.c"
yy2080:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy2085;
	if(yych == 'd')	goto yy2085;
	goto yy239;
yy2081:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy2082;
	if(yych != 't')	goto yy239;
yy2082:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy2083;
	if(yych != 'p')	goto yy239;
yy2083:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3108 "./modules/arch/x86/x86id.re"
{ RET_INSN(fbldstp, 0x06, CPU_FPU); }
#line 12832 "x86id.c"
yy2085:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3103 "./modules/arch/x86/x86id.re"
{ RET_INSN(fbldstp, 0x04, CPU_FPU); }
#line 12838 "x86id.c"
yy2087:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2271 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_FAR;
	    return YASM_ARCH_CHECK_ID_TARGETMOD;
	}
#line 12847 "x86id.c"
yy2089:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy2093;
	if(yych == 'd')	goto yy2093;
	goto yy239;
yy2090:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy2091;
	if(yych != 's')	goto yy239;
yy2091:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3162 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9E1, CPU_FPU); }
#line 12860 "x86id.c"
yy2093:	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych <= '\000')	goto yy2094;
		if(yych <= 'O')	goto yy238;
		goto yy2095;
	} else {
		if(yych == 'p')	goto yy2095;
		goto yy238;
	}
yy2094:
#line 3127 "./modules/arch/x86/x86id.re"
{ RET_INSN(farith, 0x00C0C0, CPU_FPU); }
#line 12873 "x86id.c"
yy2095:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3128 "./modules/arch/x86/x86id.re"
{ RET_INSN(farithp, 0xC0, CPU_FPU); }
#line 12879 "x86id.c"
yy2097:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy2098;
	if(yych != 'm')	goto yy239;
yy2098:	yych = *++YYCURSOR;
	if(yych != '1')	goto yy239;
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3145 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0xD9F0, CPU_FPU); }
#line 12890 "x86id.c"
yy2101:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= 'K'){
			if(yych == 'H')	goto yy2330;
			goto yy239;
		} else {
			if(yych <= 'L')	goto yy2331;
			if(yych <= 'Q')	goto yy239;
			goto yy2333;
		}
	} else {
		if(yych <= 'k'){
			if(yych == 'h')	goto yy2330;
			goto yy239;
		} else {
			if(yych <= 'l')	goto yy2331;
			if(yych == 'r')	goto yy2333;
			goto yy239;
		}
	}
yy2102:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy2328;
	if(yych == 'b')	goto yy2328;
	goto yy239;
yy2103:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy2318;
	if(yych == 'a')	goto yy2318;
	goto yy239;
yy2104:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy2256;
	if(yych == 't')	goto yy2256;
	goto yy239;
yy2105:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy2251;
	if(yych == 'e')	goto yy2251;
	goto yy239;
yy2106:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy2248;
	if(yych == 'd')	goto yy2248;
	goto yy239;
yy2107:	yych = *++YYCURSOR;
	switch(yych){
	case 'L':	case 'l':	goto yy2230;
	case 'O':	case 'o':	goto yy2229;
	case 'R':	case 'r':	goto yy2232;
	case 'U':	case 'u':	goto yy2234;
	default:	goto yy239;
	}
yy2108:	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych <= 'C'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'D')	goto yy2226;
			if(yych <= 'K')	goto yy238;
			goto yy2224;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy238;
			goto yy2226;
		} else {
			if(yych == 'l')	goto yy2224;
			goto yy238;
		}
	}

#line 2533 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG16 | 6; return YASM_ARCH_CHECK_ID_REG; }
#line 12960 "x86id.c"
yy2110:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy2221;
	if(yych == 'd')	goto yy2221;
	goto yy239;
yy2111:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'I')	goto yy2210;
		if(yych <= 'R')	goto yy239;
		goto yy2209;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy239;
			goto yy2210;
		} else {
			if(yych == 's')	goto yy2209;
			goto yy239;
		}
	}
yy2112:	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych <= '\000')	goto yy2113;
		if(yych <= 'K')	goto yy238;
		goto yy2207;
	} else {
		if(yych == 'l')	goto yy2207;
		goto yy238;
	}
yy2113:
#line 2531 "./modules/arch/x86/x86id.re"
{ data[0] = X86_REG16 | 4; return YASM_ARCH_CHECK_ID_REG; }
#line 12991 "x86id.c"
yy2114:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy2195;
	if(yych == 'r')	goto yy2195;
	goto yy239;
yy2115:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2626 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64)
		yasm__warning(YASM_WARN_GENERAL, lindex,
		    N_("`%s' segment register ignored in 64-bit mode"), oid);
	    data[0] = 0x3602;
	    return YASM_ARCH_CHECK_ID_SEGREG;
	}
#line 13007 "x86id.c"
yy2117:	yych = *++YYCURSOR;
	switch(yych){
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':	goto yy2169;
	case 'C':	case 'c':	goto yy2171;
	case 'D':	case 'd':	goto yy2173;
	case 'I':	case 'i':	goto yy2175;
	case 'M':	case 'm':	goto yy2180;
	case 'O':	case 'o':	goto yy2177;
	case 'R':	case 'r':	goto yy2178;
	default:	goto yy239;
	}
yy2118:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy2157;
	if(yych == 'b')	goto yy2157;
	goto yy239;
yy2119:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= 'K'){
			if(yych == 'D')	goto yy2147;
			goto yy239;
		} else {
			if(yych <= 'L')	goto yy2148;
			if(yych <= 'S')	goto yy239;
			goto yy2149;
		}
	} else {
		if(yych <= 'k'){
			if(yych == 'd')	goto yy2147;
			goto yy239;
		} else {
			if(yych <= 'l')	goto yy2148;
			if(yych == 't')	goto yy2149;
			goto yy239;
		}
	}
yy2120:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy2142;
	if(yych == 'a')	goto yy2142;
	goto yy239;
yy2121:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy2122;
	if(yych != 's')	goto yy239;
yy2122:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= 'D'){
			if(yych != 'C')	goto yy239;
		} else {
			if(yych <= 'E')	goto yy2124;
			if(yych <= 'Q')	goto yy239;
			goto yy2125;
		}
	} else {
		if(yych <= 'd'){
			if(yych != 'c')	goto yy239;
		} else {
			if(yych <= 'e')	goto yy2124;
			if(yych == 'r')	goto yy2125;
			goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy2138;
	if(yych == 'a')	goto yy2138;
	goto yy239;
yy2124:	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych == 'N')	goto yy2129;
		if(yych <= 'W')	goto yy239;
		goto yy2130;
	} else {
		if(yych <= 'n'){
			if(yych <= 'm')	goto yy239;
			goto yy2129;
		} else {
			if(yych == 'x')	goto yy2130;
			goto yy239;
		}
	}
yy2125:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy2126;
	if(yych != 'e')	goto yy239;
yy2126:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy2127;
	if(yych != 't')	goto yy239;
yy2127:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3508 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F07, CPU_686|CPU_AMD|CPU_Priv); }
#line 13104 "x86id.c"
yy2129:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy2134;
	if(yych == 't')	goto yy2134;
	goto yy239;
yy2130:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy2131;
	if(yych != 'i')	goto yy239;
yy2131:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy2132;
	if(yych != 't')	goto yy239;
yy2132:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3207 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(twobyte, 0x0F35, CPU_686|CPU_Priv);
	}
#line 13126 "x86id.c"
yy2134:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy2135;
	if(yych != 'e')	goto yy239;
yy2135:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy2136;
	if(yych != 'r')	goto yy239;
yy2136:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3200 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(twobyte, 0x0F34, CPU_686);
	}
#line 13144 "x86id.c"
yy2138:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy2139;
	if(yych != 'l')	goto yy239;
yy2139:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy2140;
	if(yych != 'l')	goto yy239;
yy2140:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3507 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F05, CPU_686|CPU_AMD); }
#line 13156 "x86id.c"
yy2142:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy2143;
	if(yych != 'p')	goto yy239;
yy2143:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy2144;
	if(yych != 'g')	goto yy239;
yy2144:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy2145;
	if(yych != 's')	goto yy239;
yy2145:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3510 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is an instruction in 64-bit mode"),
			      oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    RET_INSN(threebyte, 0x0F01F8, CPU_Hammer|CPU_64);
	}
#line 13179 "x86id.c"
yy2147:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy2155;
	if(yych == 'c')	goto yy2155;
	goto yy239;
yy2148:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy2152;
	if(yych == 'd')	goto yy2152;
	goto yy239;
yy2149:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy2150;
	if(yych != 's')	goto yy239;
yy2150:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3539 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixsmm, 0x7C, CPU_486|CPU_Cyrix|CPU_SMM); }
#line 13196 "x86id.c"
yy2152:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy2153;
	if(yych != 't')	goto yy239;
yy2153:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3538 "./modules/arch/x86/x86id.re"
{ RET_INSN(cyrixsmm, 0x7A, CPU_486|CPU_Cyrix|CPU_SMM); }
#line 13205 "x86id.c"
yy2155:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3537 "./modules/arch/x86/x86id.re"
{ RET_INSN(svdc, 0, CPU_486|CPU_Cyrix|CPU_SMM); }
#line 13211 "x86id.c"
yy2157:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= 'O'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'P')	goto yy2159;
			if(yych <= 'R')	goto yy238;
			goto yy2160;
		}
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy238;
			goto yy2159;
		} else {
			if(yych == 's')	goto yy2160;
			goto yy238;
		}
	}

#line 2791 "./modules/arch/x86/x86id.re"
{ RET_INSN(arith, 0x0528, CPU_Any); }
#line 13233 "x86id.c"
yy2159:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy2167;
		if(yych <= 'R')	goto yy239;
		goto yy2165;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy2167;
		} else {
			if(yych == 's')	goto yy2165;
			goto yy239;
		}
	}
yy2160:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy2163;
		if(yych <= 'R')	goto yy239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy2163;
		} else {
			if(yych != 's')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3394 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF35C, CPU_SSE); }
#line 13265 "x86id.c"
yy2163:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3446 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF25C, CPU_SSE2); }
#line 13271 "x86id.c"
yy2165:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3393 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x5C, CPU_SSE); }
#line 13277 "x86id.c"
yy2167:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3445 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x665C, CPU_SSE2); }
#line 13283 "x86id.c"
yy2169:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2380 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_FPUREG | (oid[2]-'0');
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 13292 "x86id.c"
yy2171:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2785 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00F9, CPU_Any); }
#line 13298 "x86id.c"
yy2173:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2786 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00FD, CPU_Any); }
#line 13304 "x86id.c"
yy2175:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2787 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00FB, CPU_Any); }
#line 13310 "x86id.c"
yy2177:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy2186;
	if(yych == 's')	goto yy2186;
	goto yy239;
yy2178:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3097 "./modules/arch/x86/x86id.re"
{ RET_INSN(str, 0, CPU_286|CPU_Prot); }
#line 13320 "x86id.c"
yy2180:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy2181;
	if(yych != 'x')	goto yy239;
yy2181:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy2182;
	if(yych != 'c')	goto yy239;
yy2182:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy2183;
	if(yych != 's')	goto yy239;
yy2183:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy2184;
	if(yych != 'r')	goto yy239;
yy2184:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3392 "./modules/arch/x86/x86id.re"
{ RET_INSN(ldstmxcsr, 0x03, CPU_SSE); }
#line 13338 "x86id.c"
yy2186:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'D'){
			if(yych == 'B')	goto yy2187;
			if(yych <= 'C')	goto yy239;
			goto yy2191;
		} else {
			if(yych == 'Q')	goto yy2193;
			if(yych <= 'V')	goto yy239;
			goto yy2189;
		}
	} else {
		if(yych <= 'd'){
			if(yych == 'b')	goto yy2187;
			if(yych <= 'c')	goto yy239;
			goto yy2191;
		} else {
			if(yych <= 'q'){
				if(yych <= 'p')	goto yy239;
				goto yy2193;
			} else {
				if(yych == 'w')	goto yy2189;
				goto yy239;
			}
		}
	}
yy2187:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3025 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00AA, CPU_Any); }
#line 13370 "x86id.c"
yy2189:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3026 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x10AB, CPU_Any); }
#line 13376 "x86id.c"
yy2191:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3027 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x20AB, CPU_386); }
#line 13382 "x86id.c"
yy2193:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3028 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is an instruction in 64-bit mode"),
			      oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    RET_INSN(onebyte, 0x40AB, CPU_Hammer|CPU_64);
	}
#line 13396 "x86id.c"
yy2195:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy2196;
	if(yych != 't')	goto yy239;
yy2196:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'P')	goto yy2197;
		if(yych <= 'R')	goto yy239;
		goto yy2198;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
		} else {
			if(yych == 's')	goto yy2198;
			goto yy239;
		}
	}
yy2197:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy2203;
		if(yych <= 'R')	goto yy239;
		goto yy2205;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
			goto yy2203;
		} else {
			if(yych == 's')	goto yy2205;
			goto yy239;
		}
	}
yy2198:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy2199;
		if(yych <= 'R')	goto yy239;
		goto yy2201;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy2201;
			goto yy239;
		}
	}
yy2199:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3444 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF251, CPU_SSE2); }
#line 13445 "x86id.c"
yy2201:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3391 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0xF351, CPU_SSE); }
#line 13451 "x86id.c"
yy2203:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3443 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssess, 0x6651, CPU_SSE2); }
#line 13457 "x86id.c"
yy2205:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3390 "./modules/arch/x86/x86id.re"
{ RET_INSN(sseps, 0x51, CPU_SSE); }
#line 13463 "x86id.c"
yy2207:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2562 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG8X | 4;
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 13477 "x86id.c"
yy2209:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy2219;
	if(yych == 'w')	goto yy2219;
	goto yy239;
yy2210:	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= '\000')	goto yy2211;
		if(yych <= 'M')	goto yy238;
		goto yy2212;
	} else {
		if(yych == 'n')	goto yy2212;
		goto yy238;
	}
yy2211:
#line 3555 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00F1, CPU_386|CPU_Undoc); }
#line 13494 "x86id.c"
yy2212:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy2213;
	if(yych != 't')	goto yy239;
yy2213:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= '\000')	goto yy2214;
		if(yych <= 'N')	goto yy238;
		goto yy2215;
	} else {
		if(yych == 'o')	goto yy2215;
		goto yy238;
	}
yy2214:
#line 3540 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F38, CPU_686|CPU_Cyrix); }
#line 13510 "x86id.c"
yy2215:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy2216;
	if(yych != 'l')	goto yy239;
yy2216:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy2217;
	if(yych != 'd')	goto yy239;
yy2217:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3541 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobyte, 0x0F7E, CPU_486|CPU_Cyrix|CPU_Obs); }
#line 13522 "x86id.c"
yy2219:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3096 "./modules/arch/x86/x86id.re"
{ RET_INSN(sldtmsw, 0x0401, CPU_286); }
#line 13528 "x86id.c"
yy2221:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy2222;
	if(yych != 't')	goto yy239;
yy2222:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3095 "./modules/arch/x86/x86id.re"
{ RET_INSN(sldtmsw, 0x0000, CPU_286); }
#line 13537 "x86id.c"
yy2224:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2580 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is a register in 64-bit mode"), oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    data[0] = X86_REG8X | 6;
	    return YASM_ARCH_CHECK_ID_REG;
	}
#line 13551 "x86id.c"
yy2226:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy2227;
	if(yych != 't')	goto yy239;
yy2227:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3094 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x010F01, CPU_286|CPU_Priv); }
#line 13560 "x86id.c"
yy2229:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy2245;
	if(yych == 'r')	goto yy2245;
	goto yy239;
yy2230:	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= '\000')	goto yy2231;
		if(yych <= 'C')	goto yy238;
		goto yy2243;
	} else {
		if(yych == 'd')	goto yy2243;
		goto yy238;
	}
yy2231:
#line 2878 "./modules/arch/x86/x86id.re"
{ RET_INSN(shift, 0x04, CPU_Any); }
#line 13577 "x86id.c"
yy2232:	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= '\000')	goto yy2233;
		if(yych <= 'C')	goto yy238;
		goto yy2241;
	} else {
		if(yych == 'd')	goto yy2241;
		goto yy238;
	}
yy2233:
#line 2879 "./modules/arch/x86/x86id.re"
{ RET_INSN(shift, 0x05, CPU_Any); }
#line 13590 "x86id.c"
yy2234:	yych = *++YYCURSOR;
	if(yych == 'F')	goto yy2235;
	if(yych != 'f')	goto yy239;
yy2235:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy2236;
	if(yych != 'p')	goto yy239;
yy2236:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'D')	goto yy2237;
		if(yych <= 'R')	goto yy239;
		goto yy2239;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy239;
		} else {
			if(yych == 's')	goto yy2239;
			goto yy239;
		}
	}
yy2237:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3442 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssessimm, 0x66C6, CPU_SSE2); }
#line 13615 "x86id.c"
yy2239:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3389 "./modules/arch/x86/x86id.re"
{ RET_INSN(ssepsimm, 0xC6, CPU_SSE); }
#line 13621 "x86id.c"
yy2241:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2882 "./modules/arch/x86/x86id.re"
{ RET_INSN(shlrd, 0xAC, CPU_386); }
#line 13627 "x86id.c"
yy2243:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2881 "./modules/arch/x86/x86id.re"
{ RET_INSN(shlrd, 0xA4, CPU_386); }
#line 13633 "x86id.c"
yy2245:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy2246;
	if(yych != 't')	goto yy239;
yy2246:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2267 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_SHORT;
	    return YASM_ARCH_CHECK_ID_TARGETMOD;
	}
#line 13645 "x86id.c"
yy2248:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy2249;
	if(yych != 't')	goto yy239;
yy2249:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3093 "./modules/arch/x86/x86id.re"
{ RET_INSN(twobytemem, 0x000F01, CPU_286|CPU_Priv); }
#line 13654 "x86id.c"
yy2251:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy2252;
	if(yych != 'n')	goto yy239;
yy2252:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy2253;
	if(yych != 'c')	goto yy239;
yy2253:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy2254;
	if(yych != 'e')	goto yy239;
yy2254:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3388 "./modules/arch/x86/x86id.re"
{ RET_INSN(threebyte, 0x0FAEF8, CPU_P3); }
#line 13669 "x86id.c"
yy2256:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy2257;
	case 'B':	case 'b':	goto yy2259;
	case 'C':	case 'c':	goto yy2261;
	case 'E':	case 'e':	goto yy2263;
	case 'G':	case 'g':	goto yy2265;
	case 'L':	case 'l':	goto yy2267;
	case 'N':	case 'n':	goto yy2269;
	case 'O':	case 'o':	goto yy2270;
	case 'P':	case 'p':	goto yy2272;
	case 'S':	case 's':	goto yy2274;
	case 'Z':	case 'z':	goto yy2276;
	default:	goto yy239;
	}
yy2257:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy2258;
		if(yych <= 'D')	goto yy238;
		goto yy2316;
	} else {
		if(yych == 'e')	goto yy2316;
		goto yy238;
	}
yy2258:
#line 2955 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x07, CPU_386); }
#line 13697 "x86id.c"
yy2259:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy2260;
		if(yych <= 'D')	goto yy238;
		goto yy2314;
	} else {
		if(yych == 'e')	goto yy2314;
		goto yy238;
	}
yy2260:
#line 2942 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x02, CPU_386); }
#line 13710 "x86id.c"
yy2261:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2943 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x02, CPU_386); }
#line 13716 "x86id.c"
yy2263:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2948 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x04, CPU_386); }
#line 13722 "x86id.c"
yy2265:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy2266;
		if(yych <= 'D')	goto yy238;
		goto yy2312;
	} else {
		if(yych == 'e')	goto yy2312;
		goto yy238;
	}
yy2266:
#line 2969 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x0F, CPU_386); }
#line 13735 "x86id.c"
yy2267:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy2268;
		if(yych <= 'D')	goto yy238;
		goto yy2310;
	} else {
		if(yych == 'e')	goto yy2310;
		goto yy238;
	}
yy2268:
#line 2962 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x0C, CPU_386); }
#line 13748 "x86id.c"
yy2269:	yych = *++YYCURSOR;
	switch(yych){
	case 'A':	case 'a':	goto yy2284;
	case 'B':	case 'b':	goto yy2286;
	case 'C':	case 'c':	goto yy2288;
	case 'E':	case 'e':	goto yy2290;
	case 'G':	case 'g':	goto yy2298;
	case 'L':	case 'l':	goto yy2300;
	case 'O':	case 'o':	goto yy2282;
	case 'P':	case 'p':	goto yy2296;
	case 'S':	case 's':	goto yy2294;
	case 'Z':	case 'z':	goto yy2292;
	default:	goto yy239;
	}
yy2270:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2940 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x00, CPU_386); }
#line 13768 "x86id.c"
yy2272:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= 'D'){
			if(yych >= '\001')	goto yy238;
		} else {
			if(yych <= 'E')	goto yy2278;
			if(yych <= 'N')	goto yy238;
			goto yy2280;
		}
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy238;
			goto yy2278;
		} else {
			if(yych == 'o')	goto yy2280;
			goto yy238;
		}
	}

#line 2958 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x0A, CPU_386); }
#line 13790 "x86id.c"
yy2274:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2956 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x08, CPU_386); }
#line 13796 "x86id.c"
yy2276:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2949 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x04, CPU_386); }
#line 13802 "x86id.c"
yy2278:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2959 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x0A, CPU_386); }
#line 13808 "x86id.c"
yy2280:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2961 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x0B, CPU_386); }
#line 13814 "x86id.c"
yy2282:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2941 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x01, CPU_386); }
#line 13820 "x86id.c"
yy2284:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy2285;
		if(yych <= 'D')	goto yy238;
		goto yy2308;
	} else {
		if(yych == 'e')	goto yy2308;
		goto yy238;
	}
yy2285:
#line 2953 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x06, CPU_386); }
#line 13833 "x86id.c"
yy2286:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy2287;
		if(yych <= 'D')	goto yy238;
		goto yy2306;
	} else {
		if(yych == 'e')	goto yy2306;
		goto yy238;
	}
yy2287:
#line 2945 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x03, CPU_386); }
#line 13846 "x86id.c"
yy2288:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2946 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x03, CPU_386); }
#line 13852 "x86id.c"
yy2290:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2950 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x05, CPU_386); }
#line 13858 "x86id.c"
yy2292:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2951 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x05, CPU_386); }
#line 13864 "x86id.c"
yy2294:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2957 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x09, CPU_386); }
#line 13870 "x86id.c"
yy2296:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2960 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x0B, CPU_386); }
#line 13876 "x86id.c"
yy2298:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy2299;
		if(yych <= 'D')	goto yy238;
		goto yy2304;
	} else {
		if(yych == 'e')	goto yy2304;
		goto yy238;
	}
yy2299:
#line 2967 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x0E, CPU_386); }
#line 13889 "x86id.c"
yy2300:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '\000')	goto yy2301;
		if(yych <= 'D')	goto yy238;
		goto yy2302;
	} else {
		if(yych == 'e')	goto yy2302;
		goto yy238;
	}
yy2301:
#line 2964 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x0D, CPU_386); }
#line 13902 "x86id.c"
yy2302:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2968 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x0F, CPU_386); }
#line 13908 "x86id.c"
yy2304:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2963 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x0C, CPU_386); }
#line 13914 "x86id.c"
yy2306:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2954 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x07, CPU_386); }
#line 13920 "x86id.c"
yy2308:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2944 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x02, CPU_386); }
#line 13926 "x86id.c"
yy2310:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2966 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x0E, CPU_386); }
#line 13932 "x86id.c"
yy2312:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2965 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x0D, CPU_386); }
#line 13938 "x86id.c"
yy2314:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2952 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x06, CPU_386); }
#line 13944 "x86id.c"
yy2316:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2947 "./modules/arch/x86/x86id.re"
{ RET_INSN(setcc, 0x03, CPU_386); }
#line 13950 "x86id.c"
yy2318:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy2319;
	if(yych != 's')	goto yy239;
yy2319:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'D'){
			if(yych == 'B')	goto yy2320;
			if(yych <= 'C')	goto yy239;
			goto yy2324;
		} else {
			if(yych == 'Q')	goto yy2326;
			if(yych <= 'V')	goto yy239;
			goto yy2322;
		}
	} else {
		if(yych <= 'd'){
			if(yych == 'b')	goto yy2320;
			if(yych <= 'c')	goto yy239;
			goto yy2324;
		} else {
			if(yych <= 'q'){
				if(yych <= 'p')	goto yy239;
				goto yy2326;
			} else {
				if(yych == 'w')	goto yy2322;
				goto yy239;
			}
		}
	}
yy2320:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3013 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x00AE, CPU_Any); }
#line 13985 "x86id.c"
yy2322:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3014 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x10AF, CPU_Any); }
#line 13991 "x86id.c"
yy2324:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3015 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x20AF, CPU_386); }
#line 13997 "x86id.c"
yy2326:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3016 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits != 64) {
		yasm__warning(YASM_WARN_GENERAL, lindex,
			      N_("`%s' is an instruction in 64-bit mode"),
			      oid);
		return YASM_ARCH_CHECK_ID_NONE;
	    }
	    RET_INSN(onebyte, 0x40AF, CPU_Hammer|CPU_64);
	}
#line 14011 "x86id.c"
yy2328:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2793 "./modules/arch/x86/x86id.re"
{ RET_INSN(arith, 0x0318, CPU_Any); }
#line 14017 "x86id.c"
yy2330:	yych = *++YYCURSOR;
	if(yych == 'F')	goto yy2337;
	if(yych == 'f')	goto yy2337;
	goto yy239;
yy2331:	yych = *++YYCURSOR;
	if(yych <= 'C'){
		if(yych <= '\000')	goto yy2332;
		if(yych <= 'B')	goto yy238;
		goto yy2335;
	} else {
		if(yych == 'c')	goto yy2335;
		goto yy238;
	}
yy2332:
#line 2877 "./modules/arch/x86/x86id.re"
{ RET_INSN(shift, 0x04, CPU_Any); }
#line 14034 "x86id.c"
yy2333:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2880 "./modules/arch/x86/x86id.re"
{ RET_INSN(shift, 0x07, CPU_Any); }
#line 14040 "x86id.c"
yy2335:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3548 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(onebyte, 0x00D6, CPU_Undoc);
	}
#line 14052 "x86id.c"
yy2337:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2754 "./modules/arch/x86/x86id.re"
{
	    if (yasm_x86_LTX_mode_bits == 64) {
		yasm__error(lindex, N_("`%s' invalid in 64-bit mode"), oid);
		RET_INSN(not64, 0, CPU_Not64);
	    }
	    RET_INSN(onebyte, 0x009E, CPU_Any);
	}
#line 14064 "x86id.c"
yy2339:	yych = *++YYCURSOR;
	if(yych <= 'G'){
		if(yych == 'A')	goto yy2345;
		if(yych <= 'F')	goto yy239;
		goto yy2346;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy239;
			goto yy2345;
		} else {
			if(yych == 'g')	goto yy2346;
			goto yy239;
		}
	}
yy2340:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych == 'P')	goto yy2343;
		if(yych <= 'S')	goto yy239;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy239;
			goto yy2343;
		} else {
			if(yych != 't')	goto yy239;
		}
	}
	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2801 "./modules/arch/x86/x86id.re"
{ RET_INSN(f6, 0x02, CPU_Any); }
#line 14096 "x86id.c"
yy2343:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 3077 "./modules/arch/x86/x86id.re"
{ RET_INSN(onebyte, 0x0090, CPU_Any); }
#line 14102 "x86id.c"
yy2345:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy2348;
	if(yych == 'r')	goto yy2348;
	goto yy239;
yy2346:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2800 "./modules/arch/x86/x86id.re"
{ RET_INSN(f6, 0x03, CPU_Any); }
#line 14112 "x86id.c"
yy2348:	yych = *++YYCURSOR;
	if(yych >= '\001')	goto yy238;

#line 2263 "./modules/arch/x86/x86id.re"
{
	    data[0] = X86_NEAR;
	    return YASM_ARCH_CHECK_ID_TARGETMOD;
	}
#line 14121 "x86id.c"
}
#line 3567 "./modules/arch/x86/x86id.re"

}
